var UtilBroker = Components.classes["component://netscape/utilitybroker"].createInstance();
UtilBroker = UtilBroker.QueryInterface(Components.interfaces.hpIUtilityBroker);

var InstallBroker = Components.classes["@dugout/infield/instservice;1"].getService(Components.interfaces.IInstService);

function Hilite(sHTMLpage, sSearchTerms)
{
   dump("inside Hilite\n");

  var retVal=new Object();
  var langStr = new Object();
  var hilite=1;
  UtilBroker.HPGetMacro("LANG",langStr,retVal);

  switch(langStr.value)
  {
     case "cht":
     case "chs":
     case "kor":
     case "jpn":
     case "rus":
     case "tha":
       hilite=0;
       break;

     default:
       hilite=1;
  }


if(hilite == 1)
{
   var bReturn  = new Object();
   var sHilitedHTMLpage = new Object();
   UtilBroker.HPHilite(sHTMLpage, sSearchTerms, sHilitedHTMLpage, bReturn);

   // top sets to top window, not the frame window
  if(bReturn.value)
  {
      // success. Launch new page
      dump("HPhilite OK\n");
      dump("HTML page: " + sHilitedHTMLpage.value + "\n");

      // only keep filename. The dugout protocol handler will look
      // in the cache first for this file (and find it)

      var sFile = sHilitedHTMLpage.value.match(/\w+\.\w+$/);
//dump(sFile + "\n");
      top.location = sFile;
   }
   else
   {
      // failure
      dump("HPhilite failed\n");
   }
}
else
{
  top.location = sHTMLpage;
}

}


//bit 1=search capability supported
//bit 2=print capability supported
function ChkCapabilities()
{
	var retVal=new Object();
	var langStr = new Object();
	var retstr=3;

	UtilBroker.HPGetMacro("LANG",langStr,retVal);

	switch(langStr.value)
	{
		case "cht":
		case "jpn":
		case "kor":
		case "tha":
			var os=ProcessSysInfoItem("WindowsVersion");
			if(os.match(/Microsoft\s+Windows\s+95/i))
			{
				if(langStr.value=="tha")
					retstr=0
				else
					retstr=1

				if(ChkCapabilities.arguments.length)
					retstr=ChkCapabilities.arguments[0].replace(/(_\w+).gif/i,"$1-"+ retstr + ".gif");
				break;
			}

		default:
			if(ChkCapabilities.arguments.length)
				retstr=ChkCapabilities.arguments[0];

	}

	return retstr;
}


function HandlePrnDisplay()
{
	var elementTag=null;
	var capabilities=ChkCapabilities();
	var numParams=HandlePrnDisplay.arguments.length;

	if(capabilities < 2)
	{
		if(numParams)
		{
			elementTag=HandlePrnDisplay.arguments[0];
			var tagType=elementTag.match(/^<\s*(\w+)/);
			if(tagType)
			{
				tagType=RegExp.$1;
				tagType=tagType.toLowerCase();
			}

			if(tagType=="img")
		 		elementTag=elementTag.replace(/(_\w+).gif/i,"$1-"+ capabilities + ".gif");
			else if(tagType=="div")
			{
				tagType=elementTag.match(/id=\s*("|')?(\w+)/);
				if(tagType)
				{
					tagType=RegExp.$2;
					tagType=tagType.toLowerCase();
				}

				switch(tagType)
				{
					case "printbutton":
					case "printlabel":
							elementTag=elementTag.replace(/id=\s*("|')?(\w+)("|')?/,'style="visibility:hidden"');
							break;
				}
			}
		}
		else
		{
			var divElements=document.getElementsByTagName("DIV");
			var divPrintLabel=null;
			var divPrintButton=null;

			if(divElements["footerbackground"])
			{
				divPrintLabel=divElements["footPrintLabel"];
				divPrintButton=divElements["footPrintButton"];
			}
			else if(divElements["swoosh"])
			{
				divPrintLabel=divElements["printLabel"];
				divPrintButton=divElements["printButton"];
			}

			if(divPrintLabel)
				divPrintLabel.setAttribute("style","visibility:hidden");

			if(divPrintButton)
				divPrintButton.setAttribute("style","visibility:hidden");
		}
	}
	else if(numParams)
			elementTag=HandlePrnDisplay.arguments[0];

	if(elementTag)
		document.write(elementTag);
}


function ConvertStringToBool( strInput, bDefault)
{
	var sInput = strInput.toLowerCase();
	var result = bDefault;

	if ( "true" == sInput)
	{
		result = true;
	}
	else if ( "false" == sInput)
	{
		result = false;
	}

	return result;
}

function GetSysInfoItem(SysInfoItem)
{
	var retStr=ProcessSysInfoItem(SysInfoItem)

	if(retStr == "")
		retStr= "-------------"
	else
	{
		retStr=retStr.replace(/\n/g,"<P>");
		retStr=retStr.replace(/\,/g,"<BR>");
		retStr=retStr.replace(/\t/g," - ");
		retStr=retStr.replace(/\;/g,"");
	}

    return '<td width="60%" class="blockText">' + retStr + '</td>'
}


function ProcessSysInfoItem(SysInfoItem)
{
	var returnValue = new Object();
	var outString = new Object();
	var inString="";
	var retStr="Unknown";

	switch(SysInfoItem)
	{
		case "PrinterMdl":
			UtilBroker.HPGetMacro("MODEL",outString, returnValue);
			retStr=outString.value.replace(/(\d+\w*)/, "$1" + CheckBundle("DERIV"));
			break;

		case "PrinterAssistantVersion":
			retStr=updateNum();
			if(retStr)
				retStr=versionNum() + " / " + retStr;
			else
				retStr=versionNum() + " / " + "0.0";
			break;

		case "MfgInfo":
			UtilBroker.HPGetMacro("MFG",outString,returnValue);
			if(outString.value=="")
				retStr="Hewlett Packard"
			else
				retStr=outString.value;
			break;

		case "DrvVersion":
			retStr=ProcessSysInfoItem("PrinterInfoBasic");
			retStr=retStr.match(/Drv\s*=\s*[^,]+/);
			retStr=retStr[0].match(/[\d\.]+$/);
			retStr=retStr[0];
			break;

		default:
			inString = "$SystemInfo," + SysInfoItem + "$";
			UtilBroker.HPExpandString(inString,outString,returnValue);
			retStr=outString.value;
			break;
	}

	return retStr;
}


function SetScreenReaderText(text)
{
	switch(currLang.toLowerCase())
	{
		case "enu":
		case "esm":
		case "fra":
		case "deu":
		case "ita":
		case "ptb":
			text=text.replace(/[ \t\f]+/g," ")
			//dump("\nscreenreader:" + text);
			UtilBroker.HPSetWindowText(text);
			break;
	}
}


function LogMessage()
{
	var verbosity="2";
	var message="";
	if(LogMessage.arguments.length > 1)
	{
		verbosity=LogMessage.arguments[0];
		message=LogMessage.arguments[1];
	}
	else
		message=LogMessage.arguments[0];

	message=message.replace(/\,/," ");

	var returnValue = new Object();
	var outString = new Object();
	var inString = "$LogMessage," + verbosity + "," + message + "$";
	UtilBroker.HPExpandString(inString,outString,returnValue);
}


function OnLoadQuickIdeasHome()
{
	//since label styles are manipulated it is important
	//to display the button labels in reverse order so that
	//the side effect of a style change does not affect 
	//the style of the next element
	var numButtons=0;
	var displayMap=0;
	var altText="";

	if(CheckBundle("PHOTO_BUNDLES")!="")
	{
		displayMap=1
		numButtons++
	}

	if(CheckBundle("SOHO_BUNDLES")!="")
	{
		displayMap= displayMap | 2
		numButtons++
	}

	if(CheckBundle("IR_BUNDLES")!="")
	{
		displayMap= displayMap | 4
		numButtons++
	}

	if(CheckBundle("WIRELESS_BUNDLES")!="")
	{
		displayMap= displayMap | 8
	   	numButtons++
	}

	DisplayBScnSwoosh(numButtons + 1);	
	altText=DisplayBScnBtnLbl("ButtonLabelLast",displayMap==(1|2|4|8)?"Last":numButtons);
	DisplayBScnBtn(numButtons,"ideas_wow_print_sample.html",altText);

	if(displayMap & 8)
	{
	   	numButtons--;
	   	altText=DisplayBScnBtnLbl("ButtonLabel3",numButtons);
	   	DisplayBScnBtn(numButtons,"ideas_wireless_list_fs.html",altText);
	}

	if(displayMap & 4)
	{
		numButtons--;
		altText=DisplayBScnBtnLbl("ButtonLabel2",numButtons);
		DisplayBScnBtn(numButtons,"ideas_infrared_printing_fs.html",altText);
	}

	if(displayMap & 2)
	{
		numButtons--;
		altText=DisplayBScnBtnLbl("ButtonLabel1",numButtons);
		DisplayBScnBtn(numButtons,"ideas_soho_list_fs.html",altText);
	}

	if(displayMap & 1)
	{
		numButtons--;
		altText=DisplayBScnBtnLbl("ButtonLabel0",numButtons);
		DisplayBScnBtn(numButtons,"ideas_photo_list_fs.html",altText);
	}
}

function DisplaySupportPhoneList(mode,ctrlNode)
{
	if(mode=="hide")
	{
		var showList=true;
		var phonelist=GetElementFromPath("BODY,TABLE,TBODY");
		if(phonelist)
		{
			var elmntID=ProcessSysInfoItem("RegionInfo")

			if(elmntID)
			{
				var tablehead=GetElementFromPath("BODY,TABLE,THEAD");
				if(tablehead)
				{
					var elmnt=GetElementFromPath("BODY,TABLE,TBODY,TR:" + elmntID);
					var elmntctrl=GetElementFromPath("BODY,TABLE,THEAD,TR:phonelist_ctrl")

					if(elmnt && elmntctrl)
					{
						var extent;

						extent=elmnt.getAttribute("extent");
						if(extent)
							extent=parseInt(extent);
						else
							extent=1

						for(var i=1;elmnt && i<=extent;i++)
						{
							if(i != 1)
								elmnt=GetElementFromPath("BODY,TABLE,TBODY,TR:" + elmntID + i);								

							if(elmnt)
								tablehead.insertBefore(elmnt,elmntctrl)
						}							

						top.document.phonelist=phonelist
						phonelist.parentNode.removeChild(phonelist);
						showList=false;
					}						
				}
			}		
		}

		if(showList)
		{
			var elmntctrl=GetElementFromPath("BODY,TABLE,THEAD,TR:phonelist_ctrl")
			elmntctrl.parentNode.removeChild(elmntctrl);
		}		
	}
	else if(ctrlNode && top.document.phonelist)
	{
		var tableNode=ctrlNode;

		while(tableNode.parentNode)
		{
			tableNode=tableNode.parentNode;
			if(tableNode.nodeName=="TABLE")
				break;
		}

		ctrlNode.parentNode.removeChild(ctrlNode)
		if(tableNode && (tableNode.nodeName=="TABLE"))
			tableNode.appendChild(top.document.phonelist);

		LoadFocalIndex("reset");
	}
}


//param:
//	path - path expression identifiying path to element to be removed
//	Ex)
//	   div:button1,span:5,p - removes the first p element from the 5th span element of the div element named button1
function GetElementFromPath(path)
{
	var pathArray=path.split(",")
	var pathEntry=null;
	var elementObj=document;

	for(var i=0;i<pathArray.length;i++)
	{
		pathEntry=pathArray[i].split(":")
		if(pathEntry.length==1)
			elementObj=elementObj.getElementsByTagName(pathEntry[0]).item(0)
		else if(pathEntry[1].match(/\b\d+\b/))
			elementObj=elementObj.getElementsByTagName(pathEntry[0]).item(parseInt(pathEntry[1]))
		else
		{
			elementObj=elementObj.getElementsByTagName(pathEntry[0])
			elementObj=elementObj[pathEntry[1]]
		}

		if(!elementObj)
			break;
	}

	return elementObj;
}

//RemoveBranch removes a whole section form a document
function RemoveBranch(path)
{
	var elementObj=GetElementFromPath(path);
	
	if(elementObj)
		elementObj.parentNode.removeChild(elementObj);
}


function DisplayElement(macro,path,visibilityVal)
{
	if(macro==1 || CheckBundle(macro) != "")
	{
		var elementObj=GetElementFromPath(path);

		if(elementObj)
		{
			var elementStyle=elementObj.getAttribute("style")

			if(elementStyle == "")
				elementObj.setAttribute("style","visibility:" + visibilityVal)
			else if(elementStyle.match(/visibility/i))
			{
				if(elementStyle.match("/" + visibilityVal + "/i") == null)
				{
					if(elementStyle.match(/hidden/i))
						elementObj.setAttribute("style",elementStyle.replace(/hidden/i,visibilityVal))
					else
						elementObj.setAttribute("style",elementStyle.replace(/visible/i,visibilityVal))
				}
			}
			else
				elementObj.setAttribute("style",elementStyle + " visibility:" + visibilityVal)
		}
	}
}


function DisplayBScnBtn(btnNum,nextURL,altText)
{
	var btnDivId="Button" + (btnNum + 1) + "B"
	var divElements=document.getElementsByTagName("div");
	divElements[btnDivId].setAttribute("style","visibility:visible");
	var aElement=divElements[btnDivId].getElementsByTagName("a").item(0);
	aElement.setAttribute("href",nextURL);
	aElement.setAttribute("alt",altText);
}


function DisplayBScnSwoosh(numButtons)
{
	var imageName="images/b_background" + numButtons + ".gif"
	imageName=ChkCapabilities(imageName);

	var divElement=document.createElement("div");
	divElement.setAttribute("id","swoosh");
		
	var imgElement=document.createElement("img");
	imgElement.setAttribute("src",imageName);
	imgElement.setAttribute("width","70");
	imgElement.setAttribute("height","480");

	divElement.appendChild(imgElement);

	var docBody=document.getElementsByTagName("body").item(0);
	docBody.appendChild(divElement);
	HandlePrnDisplay();
}


function DisplayBScnBtnLbl(id,btnPos)
{
	var posLabelId;
	var divElements=document.getElementsByTagName("div");
	var btnLblStyle;
	var re=/hidden/i;
	var labelText;

	if(divElements["ButtonLabel" + btnPos])
	{
		btnLblStyle=divElements[id].getAttribute("style");
		posLabelId="ButtonLabel" + btnPos
		labelText=divElements[id].getAttribute("alt");
	}
	else
	{
		btnLblStyle=divElements["ButtonLabelLast"].getAttribute("style");
		posLabelId="ButtonLabelLast"
		labelText=divElements["ButtonLabelLast"].getAttribute("alt");
	}

	btnLblStyle=btnLblStyle.replace(re,"visible");

	if(id != posLabelId)
	{
		re=/left:\s*\d+/i;
		var leftPos=divElements[posLabelId].getAttribute("style").match(re);
		re=/\d+/i;
		leftPos=leftPos[0].match(re);

		re=/top:\s*\d+/i;
		var topPos=divElements[posLabelId].getAttribute("style").match(re);
		re=/\d+/i;
		topPos=topPos[0].match(re);

		btnLblPElmts=divElements[id].getElementsByTagName("p");
		posLblPElmts=divElements[posLabelId].getElementsByTagName("p");

		if(btnLblPElmts.length != posLblPElmts.length)
		{
			if(btnLblPElmts.length > posLblPElmts.length)
				topPos=parseInt(topPos)-20
			else
				topPos=parseInt(topPos)+20
	    }
		
		re=/left:\s*\d+/i;
		btnLblStyle=btnLblStyle.replace(re,"left:" + leftPos)
		
		re=/top:\s*\d+/i;
		btnLblStyle=btnLblStyle.replace(re,"top:" + topPos)				
	}

	divElements[id].setAttribute("style",btnLblStyle);

	return labelText;
}


function CheckBundle(macroStr)
{
	var retStr=""

	if(macroStr=="EREG")
	{
		if(CheckERegMacro())
			retStr=macroStr
	}
	else
	{
	    var utilRetStr = new Object();
		UtilBroker.HPGetMacro(macroStr,utilRetStr);
		
		if(utilRetStr.value != "")
		{
			if(utilRetStr.value =="1")
				retStr=utilRetStr.value
			else if(macroStr=="DERIV")
				retStr=utilRetStr.value
			else
			{
				var langStr=new Object();
				UtilBroker.HPGetMacro("LANG",langStr);
				if(langStr.value != "")
				{
					if(utilRetStr.value.indexOf(langStr.value)!=-1)
						retStr=langStr.value
				}
			}
		}
	}
	
	return retStr;
}

function Search()
{
	var inputSearchTerms=document.getElementsByTagName("input").item(0);
	LogMessage("Search Terms: " + inputSearchTerms.value);
	var searchResult=new Object();
	searchResult.value=0;

	//remove leading whitespace
	inputSearchTerms.value=inputSearchTerms.value.replace(/^\s+/,"")

	if(inputSearchTerms.value != "")
	{
		UtilBroker.HPDugoutSearch(inputSearchTerms.value,true, searchResult);
	}
	else
	{
		searchResult.value=1;
	}

	if(searchResult.value==0)
	{
		window.location.href = "search_results_frameset.html";
	}
	else 
	{
		var divElements=document.getElementsByTagName("div");
		var divElement=null;
		var searchResultText=null;
		var elmtStopWord=null;
		
		if(searchResult.value < 0)
			searchResultText= GetSearchResultString("SearchErrorStr");

		for(var count=0 ; count < divElements.length ; count++)
		{
			if(divElements[count].getAttribute("id")=="SearchResults")
				divElement=divElements[count];

			if(searchResult.value > 0)
			{
				if(divElements[count].getAttribute("id")=="Layer1")
				{
					var inputElement=divElements[count].getElementsByTagName("input").item(0);
					if(inputElement && (inputElement.value != ""))
					{
						searchResultText= GetSearchResultString("NoMatchStr",inputElement.value);

						if(searchResult.value==2)
						{
							elmtStopWord=document.createElement("p");
							elmtStopWord.appendChild(document.createTextNode(GetSearchResultString("StopWordStr",inputElement.value)));
						}
					}
					else
						searchResultText= GetSearchResultString("NoMatchStr","");
				}
			}
		}

		if(divElement!=null)
		{
			while(divElement.lastChild)
				divElement.removeChild(divElement.lastChild);
			divElement.appendChild(document.createTextNode(searchResultText));
			if(elmtStopWord != null)
				divElement.appendChild(elmtStopWord);
		}
		else
		{
			var docBody=document.getElementsByTagName("body").item(0);
				
			divElement=document.createElement("div");
			divElement.setAttribute("id","SearchResults");
			divElement.setAttribute("style","position:absolute; left:170px; top:275px; width:340px; height:48px; z-index:1; visibility: visible");
			divElement.setAttribute("class","searchResultText");
			divElement.appendChild(document.createTextNode(searchResultText));
			if(elmtStopWord != null)
				divElement.appendChild(elmtStopWord);
			docBody.appendChild(divElement);
		}

		if(elmtStopWord != null)
			SetScreenReaderText(searchResultText + elmtStopWord);
		else
			SetScreenReaderText(searchResultText);
	}
}

function PrintDemoPage()
{	
    if(PrintDemoPage.arguments[0] == "href")
	{
		window.location.href = PrintDemoPage.arguments[1];
	    return;
    }

    var strDemoPage = new String();
    var strDugoutPath = new String();
	var curFile = new String();
    var product = new Object();
    var lang = new Object();
    var returnValue = new Object();
	var infieldRoot = new Object();
    var pfName = new Object();
    	
    InstallBroker.InitProcess( null, true );
    
    // get location of install root and master.hpi file
    UtilBroker.HPGetMacro( "INFIELD_DIR", infieldRoot, returnValue );
    infieldRoot.value += "\\"
    
    // get sample pcl path
	UtilBroker.HPGetMacro("INSTALLDIR", strDugoutPath, returnValue );

    // get product
    UtilBroker.HPGetMacro("PROD",product, returnValue);
    InstallBroker.SetProcessString( "product", product.value );
    
    // get lang
    UtilBroker.HPGetMacro( "LANG", lang, returnValue );
    InstallBroker.SetProcessString( "lang", lang.value );
    
    // sample is in dugout path + product subdir
    strDugoutPath.value += "\\" + product.value + "\\";
	
   	// make the name of the print sample file a macro for the installer
   	InstallBroker.SetProcessString( "print_sample_file", strDugoutPath.value + "sample" + PrintDemoPage.arguments[0] + ".pcl" );
   	InstallBroker.Process( infieldRoot.value+"master.hpi", "print_demopage");    
}

function HidePrintDemoButtons()
{
	var result = new Object;
	var strDugoutPath = new String();
	var product = new Object();
    var returnValue = new Object();
	var fstart=new Date();
	var start=fstart

    // get dugout root directory
	UtilBroker.HPGetMacro("INSTALLDIR", strDugoutPath, returnValue );
 
	var stop=new Date()
	if((stop-start) > 500)
		LogMessage(0,"Retrieving INSTALLDIR took: " + (stop-start) + "ms") 

	start=stop
    // get product
    UtilBroker.HPGetMacro("PROD",product, returnValue);

	stop=new Date()
	if((stop-start) > 500)
		LogMessage(0,"Retrieving PROD took: " + (stop- start) + "ms") 

    // set dugout path to dugout directory + product subdirectory
    strDugoutPath.value += "\\" + product.value + "\\";
	
	// look for files that exist and if they don't then show the corresponding button
	for( var i = 1; i <= 2; i++ )
	{
  		result.value = false;
		start=stop
  		InstallBroker.CheckFileExists( strDugoutPath.value + "sample" + i + ".pcl", result);
		stop=new Date()
		if((stop-start) > 500)
			LogMessage(0,"CheckFileExists(" +  strDugoutPath.value + "sample" + i + ".pcl" + ") took: " + (stop-start) + "ms") 
	  	
	  	if (result.value != false) 
		{
			start=stop
            document.getElementsByTagName("div")["printSample" + i].setAttribute( "style", "visibility:visible" );
			stop=new Date()
			if((stop-start) > 500)
				LogMessage(0,"Setting Visibility took:" + (stop-start) + "ms") 
		}
	}
	
	if((stop-fstart) > 2000)
		LogMessage(0,"HidePrintDemoButtons() took:" + (stop-fstart) + "ms") 
}

function ShowBundlesTable() 
{ 
    var numOfBundles = ShowBundlesTable.arguments[0];
    var bundleName = new String();
	var deep = ShowBundlesTable.arguments[numOfBundles +1];

	for(var i = 1; i <= numOfBundles; i++)
	{
	    bundleName = ShowBundlesTable.arguments[i]; 

		var inString = "$ReadHTMLCFG," + bundleName + "$"; 
		var returnValue = new Object();
	    var outString = new Object();

		UtilBroker.HPExpandString(inString,outString,returnValue);

		// if the configuration file doesn't have
		// arguments[i] listed then collapse
		// all rows associated with it
		if(outString.value <= 0)
		{
		   if(deep > 1)
		   {
			  for(var j = 1; j <= deep; j++)
		      {
				 var BundleNameCat = bundleName + j;

			     document.getElementsByTagName("tr")[BundleNameCat].setAttribute("style", "visibility:collapse" );
		      }
		   }
		   else
		   {
		      document.getElementsByTagName("tr")["bundleName"].setAttribute("style", "visibility:collapse" );
		   }
		}
	}
}

function VendorLower()
{
	return "hp";
}

function VendorUpper()
{
	return "HP";
}

function versionNum()
{
    var outString = new Object();
	UtilBroker.HPGetMacro("VERSION",outString);
	return outString.value;
}

function updateNum()
{
    var outString = new Object();
	UtilBroker.HPGetMacro("UPDATE",outString);
	return outString.value;
}

function exitButton()
{
    var outString = new Object();
	returnValue = UtilBroker.HPGetMacro("GETBACK",outString);
	
	if(outString.value == 1)
	{ 
		var strIsPreload = new Object();
		var infieldRoot = new Object();
		
		window.parent.location = "dugout_get_back.html"
		UtilBroker.HPSetMacro("GETBACK","0");

        	// get location of install root and master.hpi file
        	UtilBroker.HPGetMacro( "INFIELD_DIR", infieldRoot, returnValue );
        	infieldRoot.value += "\\";
        	
        	// get temp path
        	InstallBroker.GetProcessString( "hpistr.hpi", "preload", strIsPreload );
        	if( strIsPreload.value != "true" )
		{
			InstallBroker.Process( infieldRoot.value+"master.hpi", "html_background_off");
		}
	}
	else
	{
		var inString = "$CloseApp$"; 
		var returnValue = new Object();
	    var outString = new Object();

		UtilBroker.HPExpandString(inString,outString,returnValue);
	}
}

function exitInstall()
{

	var inString = "$CloseApp$"; 
	var returnValue = new Object();
	var outString = new Object();

	UtilBroker.HPExpandString(inString,outString,returnValue);
}


function PrintCurrentPage()
{
	LogMessage("-- Printing Current Page --")
	var returnValue = new Object();
	var outString = new Object();
	var frameIndex=null;

	//see if a frame is specified and add it to the macro
	if(PrintCurrentPage.arguments[0])
		frameIndex="," + PrintCurrentPage.arguments[0] + "$";
	else
		frameIndex="$";

	var inString = "$PrintCurrentPage" + frameIndex; 
	UtilBroker.HPExpandString(inString,outString,returnValue);
}


function LoadJumpURL()
{
	// assume first parameter is the action and if 
	// there is a second parameter that it is the manufacturer
	var retVal=new Object();

	//get all of the URL params
	var actionStr=LoadJumpURL.arguments[0];
	var mfgStr=LoadJumpURL.arguments[1];
	var prodStr = new Object();
	var langStr = new Object();
    
	UtilBroker.HPGetMacro("PROD",prodStr, retVal);
	UtilBroker.HPGetMacro("LANG",langStr,retVal);

	LogMessage("Jumpstation: action=" + actionStr + " mfg=" + (mfgStr?mfgStr:"default"))

	if(JumpstationSupportsLang(actionStr,langStr))
	{
		var serverStr=new Object();
		UtilBroker.HPGetMacro("JUMPSERVER",serverStr,retVal);

		if(serverStr.value == "")
			serverStr.value="hpdjjs.com"

		//set manufacturer if none specified
		if(!mfgStr || mfgStr == "")
		{
			var mfgStrContainer=new Object();
			UtilBroker.HPGetMacro("MFG",mfgStrContainer,retVal);

			if(mfgStrContainer.value == "")
				mfgStr = "HP";
			else
				mfgStr = mfgStrContainer.value;
		}

		//create new URL
		var JumpStationURL="http://" + serverStr.value + "/jumpstation?action=" + actionStr + "&mfg=" + mfgStr + "&lang=" + langStr.value + "&product=" + prodStr.value;

		//convert white spaces to '+' to be valid in a URL and then load the URL
		var re=/\s+/;
		LoadOutsideURL(JumpStationURL.replace(re,"+"));
	}
	else
		parent.location.href = "support_language_mismatch.html";
}


function LoadOutsideURL()
{ 
	//first see if there is a default browser
	var retString=new Object();
	var retVal=new Object();
	var inString= "$DefaultBrowser$";
	
	UtilBroker.HPExpandString(inString,retString,retVal);

	if(retString != "")
	{
		//check to see if they are connected to the Internet
		inString="$InetConnectionStatus$";
		UtilBroker.HPExpandString(inString,retString,retVal);
		
		if(retString.value != "")
		{
			//launch browser with URL
			inString="$run," + LoadOutsideURL.arguments[0] + "$";
			UtilBroker.HPExpandString(inString,retString,retVal);
		}
		else
			parent.location.href = "connect_error.html";
	}
	else
	{
		// uh-oh do we have an html page in case they don't have a default broweser?
		parent.location.href = "isp_offer.html";
	}     
}


function JumpstationSupportsLang(action,lang)
{
	var retVal=0;
	switch(action.toLowerCase())
	{
		case "supportweb":
			switch(lang.value)
			{
				case "enu":
				case "fra":
				case "esm":
				case "ptb":
				case "deu":
				case "svc":
				case "kor":
				case "chs":
				case "cht":
				case "jpn":
					retVal=1;
					break;
			}
			break;

		case "supportforum":
			break;

		case "supportemail":
			switch(lang.value)
			{
				case "enu":
				case "kor":
				case "cht":
				case "jpn":
					retVal=1;
					break;					
			}
			break;

		case "printingideas":
		case "buyink":
		case "buymedia":
		case "buyaccess":
		case "buyhp":
		case "lowink":
			lang.value=lang.value + "&langid=0x" + ProcessSysInfoItem("LanguageID");
			retVal=1;
			break;

		case "homeoffice":	 //legacy
		case "mozilla":
		case "mozillampl":
		case "mozillacredits":
		case "regionalsupport":
		case "extwarrantyloc":
		case "techsupport":
		default:
			retVal=1;
			break;
	}

	return retVal;
}


function CheckBack()
{
	if(!document.URL.match(/\?no-back/))
		window.parent.back()
}

//function handles more efficient Swapping and restoring images
//params:
//	obj - top-level element containing image - will traverse to image element
//	imgId - optional, either image name or index - default is 0
//	newImgSrc - optional, new image src value.  If omitted tries to restore last image
// Ex)
//	SwapImageEx(this,'purpleBtn','Images/purpleButton2') - swaps the purpleBtn IMG elements image with "Images/purpleButton2"
//	SwapImageEx(this) - restores first IMG src to original value
function SwapImageEx(obj,imgId,newImgSrc) 
{
	var retval=0;
	if(typeof(obj) == "string")
		obj=GetElementFromPath(obj)

	if(!imgId)
		imgId=0

	if(obj && typeof(obj)=="object")
	{
		var imgs=obj.getElementsByTagName("IMG");
		var imgObj,lastImgSrc=null;

		if(imgs && imgs[imgId])
			imgObj=imgs[imgId]
		else if(obj.hasChildNodes())
		{
			for(var i=0;i<obj.childNodes.length;i++)
			{
				retval=SwapImageEx(obj.childNodes[i],imgId,newImgSrc);
				if(retval)
					break;
			}
		}

		if(!retval && imgObj)
		{
			if(newImgSrc)
			{
				if(imgObj.getAttribute("src")!=newImgSrc)
				{
					imgObj.lastImgSrc=imgObj.getAttribute("src");
					imgObj.setAttribute("src",newImgSrc);
				}
			}
			else if(imgObj.lastImgSrc)
			{
				imgObj.setAttribute("src",imgObj.lastImgSrc);
				imgObj.lastImgSrc=null;
			}		
				
			retval=1;
		}
	}

	return retval;
}

function MM_swapImgRestore() { //v2.0
  if (document.MM_swapImgData != null)
    for (var i=0; i<(document.MM_swapImgData.length-1); i+=2)
      document.MM_swapImgData[i].src = document.MM_swapImgData[i+1];
}

function MM_preloadImages() { //v2.0
  if (document.images) {
    var imgFiles = MM_preloadImages.arguments;
    if (document.preloadArray==null) document.preloadArray = new Array();
    var i = document.preloadArray.length;
    with (document) for (var j=0; j<imgFiles.length; j++) if (imgFiles[j].charAt(0)!="#"){
      preloadArray[i] = new Image;
      preloadArray[i++].src = imgFiles[j];
  } }
}

function MM_swapImage() { //v2.0
  var i,j=0,objStr,obj,swapArray=new Array,oldArray=document.MM_swapImgData;
  for (i=0; i < (MM_swapImage.arguments.length-2); i+=3) {
    objStr = MM_swapImage.arguments[(navigator.appName == 'Netscape')?i:i+1];
    if ((objStr.indexOf('document.layers[')==0 && document.layers==null) ||
        (objStr.indexOf('document.all[')   ==0 && document.all   ==null))
      objStr = 'document'+objStr.substring(objStr.lastIndexOf('.'),objStr.length);
    obj = eval(objStr);
    if (obj != null) {
      swapArray[j++] = obj;
      swapArray[j++] = (oldArray==null || oldArray[j-1]!=obj)?obj.src:oldArray[j];
      obj.src = MM_swapImage.arguments[i+2];
  } }
  document.MM_swapImgData = swapArray; //used for restore
}

function MM_callJS(jsStr) { //v2.0
  return eval(jsStr)
}

function CheckERegMacro()
{
	var temp = new Object();
	bResult= new Object();

	UtilBroker.HPGetMacro( "INFIELD_DIR", temp, bResult);
	var HPIFile = temp.value+"\\inc.hpi";
	var EregFile= temp.value+"\\ereg\\register.exe";
	
	InstallBroker.ProcessExpandStringEx(HPIFile, "$ereg_langs$", 3, temp, bResult);
	var strEregLangs = new String( temp.value);

	InstallBroker.GetProcessString( HPIFile, "lang", temp);
	var strLang = new String( temp.value);

	var indexVal = strEregLangs.toLowerCase().indexOf( strLang.toLowerCase());

	if(indexVal != -1)
	{
		InstallBroker.CheckFileExists(EregFile,bResult);
		if(bResult.value)
			return 1
		else
			return 0
	}
	else
		return 0
}


// ===========================================
// Added features for software install
// ===========================================
var G_infieldRoot = new Object();     //set it to global so InsertCD() can use!
function InstallSoftware(hpi,softwareName)
{
    var result = new Object;
    var infieldRoot = new Object();
    var product = new Object();
    var lang = new Object();
    var returnValue = new Object();
    
    InstallBroker.InitProcess( null, false );
    
    result.value = false;
    IsCDInserted(result);
    
    // get product
    UtilBroker.HPGetMacro("PROD",product, returnValue);
    InstallBroker.SetProcessString( "product", product.value );
    
    // get lang
    UtilBroker.HPGetMacro( "LANG", lang, returnValue );
    InstallBroker.SetProcessString( "lang", lang.value );
    	
    // get location of install root file
    UtilBroker.HPGetMacro( "INFIELD_DIR", infieldRoot, returnValue );
    infieldRoot.value += "\\";
    G_infieldRoot.value = infieldRoot.value;      //Save if for insertCD to use!
    dump('\n------ InstallSoftware() ------');
    dump('\npath='+ infieldRoot.value+' hpi='+hpi+' softwareName='+softwareName+ ' IsCDInserted.result=' + result.value);

    if (result.value) 
    {
        if (hpi == 'master.hpi') 
        {  
	        //quickHelp for alternate localization language PDF
	        dump('\nInstalling PDF files...');
	        InstallBroker.SetProcessString('alt_lang_pdf',softwareName);
	        InstallBroker.Process(infieldRoot.value+'master.hpi','view_alt_lang_pdf');
	    }
	    else
	    {
	         //3rd party software install
	         dump('\nLaunching 3rd party software installer...');
	        InstallBroker.Process(infieldRoot.value+hpi,softwareName);
	    }
    }
    else 
    {
        dump('\nGoto location insert_cd.html\n');
        InstallBroker.DisableAutoRun();
        parent.location.href = "insert_cd.html?"+"hpi="+hpi+","+"swName="+softwareName;
    }
    dump('\n-------------------------------\n');
}  

// ====================================
// Handling InsertCD page
// ====================================
var mutexClicked = false;
var G_hpi;
var G_softwareName;
var timeoutID;

function InsertCD(hpi,softwareName,timeOut) 
{
    var result = new Object;


    if (timeOut == 5) {
	G_hpi = hpi; //we know it's the first time cd_insert!
	G_softwareName = softwareName;
    }
    dump("\n###1 hpi="+hpi+ " swName="+softwareName);

    InstallBroker.IsCDInserted(result);
    dump('\nInsertCD() result = ' + result.value);
    if (result.value) 
    { 
        if ( mutexClicked) return;
        mutexClicked = true;
        
          dump('\nTurning off timeOut()');  
          clearTimeout(timeoutID);
        dump('\ntrying to goback to history pages???\n');
        window.history.go(-1);
        //window.parent.back();
    dump("\n###2 hpi="+hpi+ " swName="+softwareName);
        if (softwareName) 
        {
            InstallSoftware(hpi,softwareName);
        }
        else 
        {
            dump('\nError: InsertCd() softwareName is Empty!');
        }
    }
    else 
    {
      dump('\nNo CD insert detected yet! with time out ==>'+timeOut+' '+hpi);
		//setTimeout is running outside this function call, therefore, global var must use to pass in!
      timeoutID = setTimeout("InsertCD(G_hpi,G_softwareName,3)",timeOut*1000);
    }

}


function IsCDInserted( resultOut )
{
    var cdRoot = new Object();
    var result = new Object();
    
    UtilBroker.HPGetMacro( "CDROOT", cdRoot, result );
    
    // set the CDROOT so the installer engine knows where files are
    InstallBroker.SetProcessString( "4", cdRoot.value );
    
    cdRoot.value += "\\hpsetup.ini";
 
    resultOut.value = false;
  	InstallBroker.CheckFileExists( cdRoot.value, resultOut);
  	
  	return;
}


// ========================================================
//   Check if need to display ISP offer html page.
//   This code depend of regions & languages set in macro
//   ISP_OFFER = enu,xxx,xxx ...  html: id=link onClick="TryISP()
// ========================================================
function TryISP() 
{
   /* var rv = CheckBundle('ISP_OFFER');
     if (rv == "enu")
       window.location.href = "isp_offer.html";
     else 
       exitButton(); 
   } */

    //------------------------------------------------------------
    // slight change of plans for now  -- we will be launching an
    // executable instead of going to the isp_offer.html page
    //-----------------------------------------------------------
    var temp = new Object();
	var infieldRoot = new Object();
    
    // get location of install root and master.hpi file
    UtilBroker.HPGetMacro( "INFIELD_DIR", infieldRoot, returnValue );
    infieldRoot.value += "\\"
	var HPIFile = infieldRoot.value+"apps2.hpi";

	InstallBroker.GetProcessString( HPIFile, "hp_isp_available", temp);
	var bShowISP = ConvertStringToBool( temp.value, false);

    if( bShowISP )
	{
		// set hp_isp_available to false since we're running it
		// fixes double loading issue with dugout_get_back.html
        InstallBroker.SetProcessString( "hp_isp_available", "false" );
        
        // hide the browser window
        var inString = "$HIDE$"; 
		var returnValue = new Object();
	    var outString = new Object();
    	UtilBroker.HPExpandString(inString,outString,returnValue);

        //run isp exe
        InstallBroker.ProcessAndWait(HPIFile,'launch:hp_isp');
        
        //exit app
        exitButton();
    }
    else
        exitButton(); 
}

// --------------------------
// Get parameters from the
// document.search object
// --------------------------
function getArgs() {
  var args = new Object();
  var query = location.search.substring(1);		//get query string.
  var pairs = query.split(",");				//break at comma.

  for (var i=0; i< pairs.length; i++) {
    var pos = pairs[i].indexOf('=');			//Look for "name=value".
    if (pos == -1) continue;				//If not found, skip.
    var argname = pairs[i].substring(0,pos);   		//Extract the name.
    var value = pairs[i].substring(pos+1);		//Extract the value.
    args[argname] = unescape(value);			//store as a property.
  }
  return args;		
}


function RunEreg()
{
	// Grape HTML changes 17Jan2001 DJW
	// $EREGLOADPG$ is the page that ereg will load when it is done
    // Backing out HTML changes uncomment next 2 lines to enable 02Feb2001 MS

	var  outString = new Object();
	var returnValue = new Object();

	var inString = "$CreateProcess,^$EREG^$$"
	UtilBroker.HPExpandString(inString,outString,returnValue);	
}

function RunUninstaller()
{
	var  outString = new Object();
	var returnValue = new Object();

	var inString = "$CreateProcess,^$UNINSTALLER^$$"
	UtilBroker.HPExpandString(inString,outString,returnValue);			
}


// ====================================
// Accessiblity Support Module
// ====================================
var rootFlag=1
var leafFlag=2
var siblingFlag=3
var winchildFlag=1
var winsiblingFlag=2
var tabPressMutexValue=1
var enterPressMutexValue=2
var homePressMutexValue=4
var endPressMutexValue=8
var downArrowPressMutexValue=16
var upArrowPressMutexValue=32
var currLang=null

LoadAccessibilityModule()

function LoadAccessibilityModule(mode)
{
	//ensure accessibility is loaded from main frame if it exists
	if(!top.frames || !top.frames.length || top.frames[1].document==document)
	{
		if(!top.document.focusStack || (mode && mode=="reset"))
		{
			if(mode==null || mode!="reset")
			{
				LogMessage("Initializing Accessibility!!!")
				SetWindowFilters(top,"init")
			}

			if(!currLang)
			{
				var lang = new Object();
				UtilBroker.HPGetMacro("LANG",lang);
				currLang=lang.value
			}

			top.document.focusStack = new Array()
			SetWindowFilters(top,"filter")
			LoadFocalIndex()
			top.document.modifiers=0;
			top.document.mutex=0;
			top.focus()
		}
	}
}

function LoadFocalIndex(mode)
{
	if(mode=="index" || mode=="index|screen-read")
	{
		if(top.document.focusTable==null)
		{
			top.document.tempTable=new Array();
			top.document.indexTable=new Array();
			top.document.indexTable.numItems=0;

			if(top.document.tempTable && top.document.indexTable)
				FocalIndexer(top,mode)

			if(top.document.indexTable.length || top.document.tempTable.length)
			{
				LogMessage("Initializing FocusTable")
				top.document.focusTable=new Array();
				top.document.focusTable.currentIndex=0
				var extent=top.document.indexTable.numItems + top.document.tempTable.length
				var j=0,k=0
		
				for(var i=0;i<extent;i++)
				{
					if(top.document.indexTable[i] || !top.document.tempTable[j])
					{
						if(top.document.indexTable.numItems)
						{
							if(top.document.indexTable[i] && top.document.tempTable[j])
							{
								top.document.focusTable[i]=top.document.indexTable[i]
								k=i+1
							}
							else
							{
								var loop=1
								if(k < i)
									k=i
																
								do
								{
									if(top.document.indexTable[k])
									{
										top.document.focusTable[i]=top.document.indexTable[k]
										loop=0
									}
									k++
								}while(loop)
							}

							top.document.indexTable.numItems--
						}
					}
					else
					{
						top.document.focusTable[i]=top.document.tempTable[j]
						j++
					}
				}

				top.document.focusTable.mode="init"

				if(LoadFocalIndex.arguments.length > 1)
					top.document.focusTable.currentIndex=LoadFocalIndex.arguments[1];
				else if(top.document.index)
					top.document.focusTable.currentIndex=top.document.index;

				if(mode=="index")
					FindNextIndexedFocus();
				else if(top.frames.length)
				{
					top.document.focusTable.mode="index"
					FindNextIndexedFocus();					
				}
			}

			delete top.document.tempTable
			delete top.document.indexTable
			delete top.document.index			
		}
		else if(top.document.screenReaderText==null)
			FocalIndexer(top,mode)
	}
	else if(mode == "reset")
	{
		if(top.document.index)
			delete top.document.index;

		if(top.document.focusTable)
		{
		 	delete top.document.focusTable;
			delete top.document.currentWin;
			delete top.document.focusStack
		}

		if(top.document.screenReaderText)
		{
			delete top.document.screenReaderText;
			delete top.document.screenReaderIndex;
		}

		SetWindowFilters(top,"releaseall")
		LoadAccessibilityModule(mode)
	}
	else
	{
		if(LoadFocalIndex.arguments[0])
			top.document.index=LoadFocalIndex.arguments[0]
		else
			top.document.index=0
	}
}

function FocalIndexer(win,mode)
{
	var count=null;
	if(top.document.tempTable && top.document.indexTable)
		count=top.document.tempTable.length + top.document.indexTable.length
	DocFocalIndexer(win.document,mode,false)
	if((count!=null) && count==(top.document.tempTable.length + top.document.indexTable.length))
		top.document.tempTable[top.document.tempTable.length]=win

	if(win.frames.length)
	{
		for(var i=0;i<win.frames.length;i++)
			FocalIndexer(win.frames[i],mode)
	}
}

function DocFocalIndexer(node,mode,extractText)
{
	if((top.document.focusTable==null) && ValidFocalNode(node))
	{
		var tabindex=node.getAttribute("tabindex")
		if(tabindex != "")
		{
			tabindex=parseInt(tabindex)
			if(top.document.indexTable[tabindex])
				LogMessage("WARNING: Over Writing Existing Index!!!")
			else
				top.document.indexTable.numItems++

			top.document.indexTable[tabindex]=node
		}
		else
			top.document.tempTable[top.document.tempTable.length]=node
	}

	
	if((mode=="index|screen-read") && node.nodeType==Node.ELEMENT_NODE)
	{
		var classData=node.getAttribute("class");

		if(classData)
		{
			switch(classData)
			{
				case "buttonLabels": 
				case "GroupTitlesIX": 
				case "Level1IX": 
				case "Level2IX": 
				case "Level3IX": 
				case "Level4IX": 
					extractText=false;
					break;

				default:
					if(!extractText && top.document.screenReaderText)
					{
						if(top.document.screenReaderText[top.document.screenReaderText.length-1]!="\n")
							top.document.screenReaderText=top.document.screenReaderText+"\n"
					}
												
					extractText=true;
					break;
			}
		}
	}
	else if(extractText && node.nodeType==Node.TEXT_NODE)
	{
		var text=node.data.replace(/\s{2,}/g," ")
		text=text.replace(/^\s+|\s+$/,"")
		
		if(text && !text.match(/document.write|handleprndisplay/ig))
		{
			if(top.document.screenReaderText)
				top.document.screenReaderText=top.document.screenReaderText + " " + text
			else
			{
				top.document.screenReaderText=text
				top.document.screenReaderIndex=0
			}
		}
	}


	if(node.childNodes)
	{
		for(var i=0;i < node.childNodes.length;i++)
		{
			if(node.nodeType!=Node.ELEMENT_NODE || 
			   !(node.getAttribute("style").match(/hidden/i) || node.getAttribute("style").match(/collapse/i)))
				DocFocalIndexer(node.childNodes[i],mode,extractText)
		}
	}
}

function FindNextIndexedFocus(mode,param)
{
	if(top.document.focusTable)
	{
		CheckFocusDisplay(top.document.focusTable[top.document.focusTable.currentIndex],"blur")
		var loop=1
		var current=top.document.focusTable.currentIndex
		var node=null

		if(top.document.focusTable.mode)
		{
			mode=top.document.focusTable.mode;
			param=current;
			delete top.document.focusTable.mode;
		}

		do
		{
			top.document.focusTable.currentIndex=nextIndex()
			node=top.document.focusTable[top.document.focusTable.currentIndex]

			if(node)
			{
				loop=0
				switch(mode)
				{
					case "init":
						if((top.document.modifiers & Event.SHIFT_MASK) || 
							(top.document.focusTable[param].toString()=="[object Window]"))
							mode="nextElement"
						else
						{
							top.document.focusTable.currentIndex=param
							node=top.document.focusTable[param]
							break;
						}
						
					case "nextElement":
						if(node.toString()=="[object Window]")
							loop=1;
						break;

					case "match":
						if(node.toString()=="[object Window]" ||
						  (param && param!=node.getAttribute("name") &&
						  param!=node.localLink))
							loop=1
						break;

					case "index":
						if(top.document.focusTable.currentIndex !=param)
							loop=1
						break;

					case "object":
						if(param && top.document.focusTable[top.document.focusTable.currentIndex]!=param)
							loop=1									
						break;

					case "winobj":
						{
							var next=top.document.focusTable[nextIndex()]
							
							if((next.toString()=="[object Window]" && next!=param) ||
								(FindWindow(top,next.ownerDocument) != param))
								loop=1
						}
						break;

					case "next":
					default:
						break;
				}

				if(mode != "winobj")
				{
					if(node.toString()!="[object Window]" && 
						FindWindow(top,node.ownerDocument) != top.document.currentWin)
						SetWindowFilters(FindWindow(top,node.ownerDocument),"filter")

					if(!loop)
					{							
						if(node.toString()=="[object Window]")
							SetWindowFilters(top.document.focusTable[top.document.focusTable.currentIndex],"filter")
						else
						{
							if(top.document.focusTable[current].nodeName!="A")
								top.document.focusTable[current].blur();

							if(node.nodeName != "A")
								node.focus();

							//node.focus()
							//if(node.nodeName=="A")
							//	node.blur()

						  	CheckFocusDisplay(node,"focus")
						}
					}
				}
			}
		}while(loop && current!=top.document.focusTable.currentIndex)
	}
	else
		FindNextFocus()
}

function FindNextFocus()
{
	var focusStack=top.document.focusStack?top.document.focusStack:null
	var focalNode=peekFS()
	var node=null

	CheckFocusDisplay(focalNode,"blur")

	do{
		if(focusStack==null || focusStack.length==0)
		{
			pushFS(top)
			pushFS(top.document)
			SetWindowFilters(top,"filter")
			focusStack=top.document.focusStack
			focusStack.mode=leafFlag
			focusStack.winmode=winchildFlag
		}

		node=peekFS()

		if(node.toString()=="[object Window]")
		{
			if(top.document.currentWin && focalNode && focalNode.toString() != "[object Window]")
			{
				if(top.document.currentWin != FindWindow(top,focalNode.ownerDocument))
					break;
			}

			if(focusStack.winmode==winchildFlag && node.frames.length)
			{
				var index=0

				if(top.document.modifiers & Event.SHIFT_MASK)
					index=node.frames.length-1
				
				pushFS(node.frames[index])
				pushFS(node.frames[index].document)
				SetWindowFilters(node.frames[index],"filter")
			}
			else
			{
				popFS()

				if(focusStack.length && node.toString()=="[object Window]")
				{
					var parentwin=peekFS()
					for(var i=0;i<parentwin.frames.length;i++)
					{
						if(parentwin.frames[i]==node)
						{
							var newIndex=i
							if(top.document.modifiers & Event.SHIFT_MASK)
								newIndex--
							else
								newIndex++
							 
							if(newIndex >=0 && newIndex < parentwin.frames.length)
							{
								pushFS(parentwin.frames[newIndex])
								pushFS(parentwin.frames[newIndex].document)
								SetWindowFilters(parentwin.frames[newIndex],"filter")
								focusStack.winmode=winchildFlag
							}
							else
								focusStack.winmode=winsiblingFlag
						}
					}
				}
			}			
		}
		else
		{
			if(focusStack.mode==leafFlag)
			{
				if(node.hasChildNodes())
				{
					if(node.nodeType==Node.ELEMENT_NODE && node.getAttribute("style").match(/hidden/i))
						focusStack.mode=rootFlag
					else if(top.document.modifiers & Event.SHIFT_MASK)
						pushFS(node.lastChild)
					else
						pushFS(node.firstChild)
				}
				else
					focusStack.mode=rootFlag
			}
			else if(focusStack.mode==rootFlag)
			{
				focusStack.mode=siblingFlag

				if(ValidFocalNode(node,FindNextFocus.arguments[0]))
				{
					node.focus()
					CheckFocusDisplay(node,"focus")
					break;
				}
			}
			else if(focusStack.mode==siblingFlag)
			{
				popFS()

				if(node.parentNode && node.parentNode.hasChildNodes())
				{
					for(var i=0;i<node.parentNode.childNodes.length;i++)
					{
						if(node.parentNode.childNodes[i]==node)
						{
							if(top.document.modifiers & Event.SHIFT_MASK)
								i--
							else
								i++

							if((i >= 0) && (i < node.parentNode.childNodes.length))
								pushFS(node.parentNode.childNodes[i])

							break;
						}
					}
				}
			}
		}
	}while(top.document.focusStack.length==0 ||
			focalNode != peekFS())
}

function ValidFocalNode(node,match)
{
	var retval=0
	if(node.nodeType==Node.ELEMENT_NODE)
	{
		if(node.getAttribute("tabindex")!="")
		{
			var tabindex=node.getAttribute("tabindex")	  
			if(tabindex != "OFF")
			{
				if(!tabindex.match(/\d+/) || parseInt(tabindex) > 500)
					node.removeAttribute("tabindex")

				retval=1
			}
		}
		else if(node.getAttribute("style").match(/hidden/i))
		  	retval=0
		else
		{
			switch(node.nodeName)
			{
				case "A":
					if(match && match==node.getAttribute("name"))
						retval=1
					else if(node.getAttribute("href") || node.getAttribute("onclick") ||
					   node.getAttribute("onkeyup") || node.getAttribute("onkeypress") ||
					   node.getAttribute("ondblclick"))
					{
						if(ValidFocalNode.localLink)
						{
							node.localLink=ValidFocalNode.localLink
							delete ValidFocalNode.localLink
						}

						retval=1
					}
					else if(node.getAttribute("name"))
						ValidFocalNode.localLink=node.getAttribute("name")
					break;

				case "SELECT":
					{
						var onchange=node.getAttribute("onchange")
						if(onchange)
							onchange=onchange + ";FindNextIndexedFocus('object',this)"
						else
							onchange="FindNextIndexedFocus('object',this)"

						node.setAttribute("onchange",onchange);
					}
				case "INPUT":
				case "BUTTON":
					if(!match)
						retval=1
					break;
			}
		}
	}

	return retval
}

function CheckFocusDisplay(node,mode)
{
	if(node && node.nodeType==Node.ELEMENT_NODE && !node.getAttribute("onfocus"))
	{
		var orgnode=node
		var type=null;

		switch(node.nodeName)
		{
			case "SELECT": 
				if(mode=="focus")
				{
					type=" $listbox$ " + orgnode.value;
					var alttext=null
					if(orgnode.getAttribute("alt"))
						alttext=orgnode.getAttribute("alt") + type;

					if(alttext!="")
						SetScreenReaderText(alttext);
					break;
				}

			case "INPUT":
				if(mode=="focus")
				{
					var alttext= ""
					switch(orgnode.getAttribute("type"))
					{
						case "radio":
						case "checkbox":
							type=" $" + orgnode.getAttribute("type")  + "$ $" + (orgnode.checked?"checked":"!checked") + "$";
							break;

						case "button":
							type=orgnode.value + " $button$"
							break;

						case "file":
							break;

						default:
							type=orgnode.value + " $edit$"
							break;
					}
					
					if(orgnode.parentNode.getAttribute("alt"))
						alttext=orgnode.parentNode.getAttribute("alt")

					alttext=alttext + "\n" +  orgnode.getAttribute("alt") + type;

					if(alttext!="")
						SetScreenReaderText(alttext);
				}
				else if(mode=="blur")
					SetScreenReaderText("$NULL$");
				break;

			case "BUTTON":
				type=" $button$"
			default:
				if(type==null)
				{
					if(node.getElementsByTagName("IMG").item(0))
					{
						node=node.getElementsByTagName("IMG").item(0)
						type=" $button$"
					}
					else
						type=" $link$"
				}

				if(mode=="focus")
				{
					var style=node.getAttribute("style")
					if(style)
					{
						node.oldStyle=style
						style=style + ";"
					}

					style=style + "border-style: dotted; border-width:1px;"
					node.setAttribute("style",style)

					if(orgnode.getAttribute("alt") || orgnode.hasChildNodes())
					{
						var alttext= ""
						
						if(orgnode.getAttribute("alt"))
							alttext=orgnode.getAttribute("alt") + type
						else
						{
							orgnode.normalize()
							for(var i=0;i < orgnode.childNodes.length;i++)
							{
								if(orgnode.childNodes[i].nodeType==Node.TEXT_NODE)
								{
									var text=orgnode.childNodes[i].data.replace(/^\s+/,"")
									if(text!="")
										alttext=text + type
									break
								}
							}
						}

						if(alttext!="")
							SetScreenReaderText(alttext);
					}
				}
				else if(mode=="blur")
				{
					if(node.oldStyle)
					{
						node.setAttribute("style",node.oldStyle)
						delete node.oldStyle
					}
					else
						node.removeAttribute("style")

					SetScreenReaderText("$NULL$");
				}
			break;
		}
	}
}

function nextIndex(mode)
{
	var index=top.document.focusTable.currentIndex

	if(mode=="previous" || top.document.modifiers & Event.SHIFT_MASK)
	{			
		if(index <=0)
			index=top.document.focusTable.length
	
		index--
	}
	else //mode=="next"
	{
		index++
		if(index >= top.document.focusTable.length)
			index=0
	}

	return index
}

function pushFS(val)
{
	if(top.document.focusStack==null)
	{
		top.document.focusStack=new Array()
		top.document.focusStack.winmode=winsiblingFlag
	}
		
	top.document.focusStack.mode=leafFlag
	top.document.focusStack[top.document.focusStack.length]=val
}


function peekFS()
{
	var retval=null
	if(top.document.focusStack!=null && top.document.focusStack.length)
		retval=top.document.focusStack[top.document.focusStack.length-1]

	return retval
}

function popFS()
{
	var retval=null
	if(top.document.focusStack!=null)
	{
		retval=top.document.focusStack[top.document.focusStack.length-1]
		top.document.focusStack.length=top.document.focusStack.length-1
		top.document.focusStack.mode=rootFlag
	}

	return retval
}

function SetFocus(obj)
{
	if(top.document.focusTable)
	{
		if(obj != top.document.focusTable[top.document.focusTable.currentIndex])
			FindNextIndexedFocus("object",obj)
	}
	else
	{
		if(peekFS() != obj)
		{
			CheckFocusDisplay(peekFS(),"blur")

			var tempStack=new Array()
			var temp=obj
			var i=0

			while(temp)
			{
				tempStack[i]=temp

				if(temp.toString() == "[object Window]")
				{
					temp=FindWindow(top,temp)
					if(temp==top)
					{
						i++
						tempStack[i]=top
						temp=null
					}
				}
				else if(temp.toString() == "[object HTMLDocument]")
					temp=FindWindow(top,temp)
				else if(temp.parentNode)
					temp=temp.parentNode

				i++
			}

			top.document.focusStack.length=0
			top.document.focusStack.mode=siblingFlag
			top.document.focusStack.winmode=winsiblingFlag

			for(var j=0;j<i;j++)
				top.document.focusStack[j]=tempStack[i-j-1]
		}

		SetWindowFilters(FindWindow(top,obj.ownerDocument),"filter")			
		obj.focus()
	}
}

function EventFilter(evt)
{
	var routeEvt=1

	switch(evt.type)
	{
		case "keydown":
			switch(evt.which)
			{
				case 9:	 //tab
					if(!(top.document.mutex & tabPressMutexValue))
					{
						top.document.mutex=top.document.mutex | tabPressMutexValue
					
						if(!(top.document.index==null))
							LoadFocalIndex("index")
						else
							FindNextIndexedFocus("next")
					}
					routeEvt=0;
					break;

				case 13: //enter
					if(!(top.document.mutex & enterPressMutexValue))
						top.document.mutex=top.document.mutex | enterPressMutexValue
					break;

				case 16: //shift
					top.document.modifiers = top.document.modifiers | Event.SHIFT_MASK;
					break;

				case 17: //ctrl
					top.document.modifiers = top.document.modifiers | Event.CONTROL_MASK;
					break;

				case 18: //alt
					top.document.modifiers = top.document.modifiers | Event.ALT_MASK;
					break;

				case 33: //page up
					top.document.currentWin.scrollBy(0,-top.document.currentWin.innerHeight)
					break;

				case 34: //page down
					top.document.currentWin.scrollBy(0,top.document.currentWin.innerHeight)
					break;

				case 35: //end
					if(!(top.document.mutex & endPressMutexValue))
						top.document.mutex=top.document.mutex | endPressMutexValue
					if(!top.document.modifiers)
					{
						var lastOffset
						do
						{
							lastOffset=top.document.currentWin.pageYOffset
							top.document.currentWin.scrollBy(0,top.document.currentWin.innerHeight)
						}while(top.document.currentWin.pageYOffset != lastOffset)
					}
					break;

				case 36: //home
					if(!(top.document.mutex & homePressMutexValue))
						top.document.mutex=top.document.mutex | homePressMutexValue
					if(!top.document.modifiers)
						top.document.currentWin.scrollTo(0,0)
					break;

				case 37: //left arrow
					top.document.currentWin.scrollBy(-25,0)
					break;

				case 38: //up arrow
					if(!(top.document.mutex & upArrowPressMutexValue))
						top.document.mutex=top.document.mutex | upArrowPressMutexValue
					if(!top.document.modifiers)
						top.document.currentWin.scrollBy(0,-25)
					break;

				case 39: //right arrow
					top.document.currentWin.scrollBy(25,0)
					break;

				case 40: //down arrow
					if(!(top.document.mutex & downArrowPressMutexValue))
						top.document.mutex=top.document.mutex | downArrowPressMutexValue
					if(!top.document.modifiers)
						top.document.currentWin.scrollBy(0,25)
					break;
			}
			break;
		case "keyup":		
			switch(evt.which)
			{
				case 9:  //tab
					if(top.document.mutex & tabPressMutexValue)
					{
						if(top.document.focusTable)
						{
							var node=top.document.focusTable[top.document.focusTable.currentIndex]
						 	if(node && node.nodeType==Node.ELEMENT_NODE)
							{
								node.focus()
								if(node.nodeName=="A")
									node.blur()
							}
						}
				  		else if(peekFS())
					  	{
					  		var current=peekFS()
							if(current.nodeType == Node.ELEMENT_NODE)
						  		current.focus()
						}
						top.document.mutex=top.document.mutex-tabPressMutexValue
					}
					break;

				case 13: //enter
					if(top.document.mutex & enterPressMutexValue)
					{
				  		var current=top.document.focusTable?top.document.focusTable[top.document.focusTable.currentIndex]:peekFS()
						if(current)
						{							
							var cmd=current.getAttribute("onclick");
							var href=current.getAttribute("href");

							if(href)
							{
								if(href[0]!="#")
								{
									top.location=href
									top.document.mutex=top.document.mutex-enterPressMutexValue
								}
							}
							else if(cmd)
							{
								cmd=cmd.replace(/(\(|,)\s*this\s*(,|\))/g,"$1top.document.focusTable[top.document.focusTable.currentIndex]$2")
								eval(cmd);							
								top.document.mutex=top.document.mutex-enterPressMutexValue
							}
							else if(current.onclick)
							{
								current.onclick()
								top.document.mutex=top.document.mutex-enterPressMutexValue
							}
						}

						if(current && current.nodeType == Node.ELEMENT_NODE && current.nodeName=="A")
						{
							var href=current.getAttribute("href")
							if(href && href[0]=="#")
							{
								if(top.document.focusTable)
									FindNextIndexedFocus("match",href.slice(1))
								else
									FindNextFocus(href.slice(1))
							}						 
						}
					}
				  	break;

				case 16: //shift
					if(top.document.modifiers & Event.SHIFT_MASK)
						top.document.modifiers = top.document.modifiers - Event.SHIFT_MASK;
					break;

				case 17: //ctrl
					if(top.document.modifiers & Event.CONTROL_MASK)
						top.document.modifiers = top.document.modifiers - Event.CONTROL_MASK;
					break;

				case 18: //alt
					if(top.document.modifiers & Event.ALT_MASK)
						top.document.modifiers = top.document.modifiers - Event.ALT_MASK;
					break;

				case 35: //end
					if(top.document.mutex & endPressMutexValue)
					{
						if(top.document.modifiers & Event.SHIFT_MASK)
						{
							if(top.document.screenReaderText==null)
								LoadFocalIndex("index|screen-read")

							if(top.document.screenReaderText)
								top.document.screenReaderIndex=top.document.screenReaderText.length;
							routeEvt=0;
						}
						top.document.mutex=top.document.mutex-endPressMutexValue
					}
					break;

				case 36: //home
					if(top.document.mutex & homePressMutexValue)
					{
						if(top.document.modifiers & Event.SHIFT_MASK)
						{
							if(top.document.screenReaderText==null)
								LoadFocalIndex("index|screen-read")

							if(top.document.screenReaderText)
								top.document.screenReaderIndex=0;
							routeEvt=0;
						}
						top.document.mutex=top.document.mutex-homePressMutexValue
					}
					break;

				case 38: //up arrow
					if(top.document.mutex & upArrowPressMutexValue)
					{
						if(top.document.modifiers & Event.SHIFT_MASK)
						{
							if(top.document.screenReaderText==null)
								LoadFocalIndex("index|screen-read")

							if(top.document.screenReaderText && top.document.screenReaderIndex > 0)
							{
								var index=top.document.screenReaderIndex-1

								while(index && top.document.screenReaderText[index] !="\n")
									index--

								SetScreenReaderText(top.document.screenReaderText.slice(index,top.document.screenReaderIndex))

								top.document.screenReaderIndex=index;
							}
							routeEvt=0;
						}
						top.document.mutex=top.document.mutex-upArrowPressMutexValue
					}
					break;

				case 40: //down arrow
					if(top.document.mutex & downArrowPressMutexValue)
					{
						if((top.document.modifiers & Event.CONTROL_MASK) || (top.document.modifiers & Event.SHIFT_MASK))
						{
							if(top.document.screenReaderText==null)
								LoadFocalIndex("index|screen-read")

							if(top.document.screenReaderText)
							{
								if((top.document.modifiers - (Event.CONTROL_MASK | Event.SHIFT_MASK))==0)
									SetScreenReaderText(top.document.screenReaderText)
								else if(top.document.screenReaderIndex < top.document.screenReaderText.length)
								{
									var index=top.document.screenReaderText.indexOf("\n",top.document.screenReaderIndex + 1)
									var text=""

									if(index == -1)
									{
										text=top.document.screenReaderText.slice(top.document.screenReaderIndex)									
										top.document.screenReaderIndex = top.document.screenReaderText.length
									}
									else
									{
										text=top.document.screenReaderText.slice(top.document.screenReaderIndex,index)
										top.document.screenReaderIndex=index
									}

									if(text)
										SetScreenReaderText(text)
								}								
							}
							routeEvt=0;
						}
						top.document.mutex=top.document.mutex-downArrowPressMutexValue
					}
					break;

				case 72:
				case 104:
					if((top.document.modifiers & Event.CONTROL_MASK) && (top.document.modifiers & Event.SHIFT_MASK))
						SetScreenReaderText("$help$");
					break;					 
			}		 
			break;

		case "click":
			if(FindWindow(top,evt.target.ownerDocument)!=top.document.currentWin)
			{
				SetWindowFilters(FindWindow(top,evt.target.ownerDocument),"filter")
				if(top.document.focusTable)
					FindNextIndexedFocus("winobj",top.document.currentWin)
			}

			if(top.document.focusTable)
				FindNextIndexedFocus("object",evt.target)
			else
				CheckFocusDisplay(peekFS(),"blur")
			break;

		case "focus":
			if(evt.target.toString() == "[object HTMLDocument]")
			{							   
				if(evt.target!=top.document.currentWin.document.documentElement.parentNode)
					top.document.currentWin.focus()
			}
			break;
	}

	if(routeEvt)
		routeEvent(evt);

	return true;
} 

function KBInvoke(evt,method,hotkey,modifier)
{
	if(top.document.mutex & enterPressMutexValue)
	{
		var invoke=0
		if(KBInvoke.arguments.length == 2)
		{
			if(evt.which==13)
				invoke=1
		}
		else if(KBInvoke.arguments.length > 2)
		{
			if(evt.which==hotkey)
			{
				if(KBInvoke.arguments.length > 3)
				{
					if(top.document.modifiers & modifier)
						invoke=1
				}
				else
					invoke=1	
			}
		}
		
		if(invoke)
		{
			method=method.replace(/(\(|,)\s*this\s*(,|\))/g,"$1top.document.focusTable[top.document.focusTable.currentIndex]$2")
			eval(method)
		}
	
		top.document.mutex=top.document.mutex-enterPressMutexValue
	}
}

function FindWindow(win,target)
{
	var retval=null

	if(target.toString()=="[object Window]")
	{
		if(win==target)
		{
			if(win==top)
				return null
			else
				return "Set Parent Window"
		}
	}
	else
	{
		if(win.document==target)
			return win
	}

	if(retval==null && win.frames.length)
	{
		for(var i=0;i<win.frames.length;i++)
		{
			retval=FindWindow(win.frames[i],target)

			if(retval)
			{
				if(retval=="Set Parent Window")
					retval=win
				break
			}
		}
	}

	return retval
}

function SetWindowFilters(win,mode)
{
	if(win.toString()!="[object Window]")
		return
	
	if(mode=="init")
	{
		win.captureEvents(Event.CLICK | Event.FOCUS)
		win.onclick=EventFilter;
		win.onfocus=EventFilter;

		if(win.frames.length)
		{
			for(var i=0;i<win.frames.length;i++)
				SetWindowFilters(win.frames[i],mode)
		}
	}
	else if(mode=="filter")
	{
		if(win!=top.document.currentWin)
		{
			if(top.document.currentWin)
				SetWindowFilters(top.document.currentWin,"release")
			win.captureEvents(Event.KEYDOWN | Event.KEYUP );
			win.onkeydown=EventFilter;
			win.onkeyup=EventFilter;
			top.document.currentWin=win
		}
	}
	else if(mode=="release")
	{
		win.releaseEvents(Event.KEYDOWN | Event.KEYUP)
		top.document.currentWin=null
	}
	else if(mode=="releaseall")
	{
		win.releaseEvents(Event.KEYDOWN | Event.KEYUP)

		if(win.frames.length)
		{
			for(var i=0;i<win.frames.length;i++)
				SetWindowFilters(win.frames[i],mode)
		}

		top.document.currentWin=null
	}
}

function GetExpandValue(macro)
{
    var outString = new Object();
	var returnValue=new Object();

	UtilBroker.HPExpandString(macro,outString,returnValue);
	return outString.value;
}

// Turns background window on behind dugout
function EnableBackground()
{
	return GetExpandValue("$EnableBackground,true,0x996600$")
}

// Turns background window off behind dugout
function DisableBackground()
{
	return GetExpandValue("$EnableBackground,false,0$")
}
