////////////////////////////////////////////////////////////////////////////////
// Setup
////////////////////////////////////////////////////////////////////////////////

var UtilBroker = Components.classes["component://netscape/utilitybroker"].createInstance();
UtilBroker = UtilBroker.QueryInterface(Components.interfaces.hpIUtilityBroker);

var HpfInst = Components.classes["@dugout/infield/instservice;1"].getService(Components.interfaces.IInstService);

////////////////////////////////////////////////////////////////////////////////
// Setup some global values
////////////////////////////////////////////////////////////////////////////////
var strTempPath = new String();
HpfInst.GetProcessString( "master.hpi", "2", strTempPath);
var HPIFile = strTempPath.value+"master.hpi";

var PES_MACROS  = 1;
var PES_ESCAPES = 2;
var PES_FIELDS  = 4;
var PES_ALL     = PES_MACROS | PES_ESCAPES | PES_FIELDS;
var Timeout     = 60;

var strDriverName = new String();
HpfInst.GetProcessString( HPIFile, "printerdriver", strDriverName);

var bResult = Object();

////////////////////////////////////////////////////////////////////////////////
// More or less Global functions
////////////////////////////////////////////////////////////////////////////////

//HpfInst.InitProcess( null, true);

function OutputToLogFile( message)
{
	var now = new Date();
	HpfInst.OutputToLogFile( "[" + now.toString() + "] " + message);
}

// log HTML page URL
OutputToLogFile( document.URL);

function ConvertStringToBool( strInput, bDefault)
{
	var sInput = strInput.toLowerCase();
	var result = bDefault;

	if ( "true" == sInput)
	{
		result = true;
	}
	else if ( "false" == sInput)
	{
		result = false;
	}

	return result;
}

// Its unnecessary to call setport after a call to FindDeviceOnPort
// because that function will set these macros
function setPort( port)
{
	// passes in port and may have a colon on the end
	HpfInst.SetProcessString( "port", port);

	// remove colon on end for sport macro
	var sport = port.split( ":");
	HpfInst.SetProcessString( "sport", sport[0]);
}

////////////////////////////////////////////////////////////////////////////////
// exitApp()
// general exit function applied to all pages before installation is 'successful'
////////////////////////////////////////////////////////////////////////////////

function exitApp(){
	location='exitDialog.html'; //driver is not completely installed; user should not exit out		
}

////////////////////////////////////////////////////////////////////////////////
// exitApp2()
// general exit function applied after/during print sample page
////////////////////////////////////////////////////////////////////////////////

function exitApp2(){
	location='exitDialog2.html'; //driver is installed; would just perfer if user did not exit out		
}

////////////////////////////////////////////////////////////////////////////////
//  functions for exitDialog.html
////////////////////////////////////////////////////////////////////////////////
//

function onloadExit()
{  
	MM_preloadImages('images/medBtn1.gif','#9617633300');
      MM_preloadImages('images/medBtn2.gif','#9617633301');
	MM_preloadImages('images/largeBtn1.gif','#9617633302');
      MM_preloadImages('images/largeBtn2.gif','#9617633303');
	MM_preloadImages('images/smallBtn1.gif','#9617633304');
      MM_preloadImages('images/smallBtn2.gif','#9617633305');
 	MM_preloadImages('images/background.gif','#9617633306');
	MM_preloadImages('images/blue01circle.gif','#9617633307');
}


function onunloadExit(){
}

function exitDialogBack(){
	window.back();
}

//from cancelConfirmed()
function exitDialogNext(){
      cancelConfirmed();
}


////////////////////////////////////////////////////////////////////////////////
//  functions for noUsbSupport.html
////////////////////////////////////////////////////////////////////////////////
//

function onloadNoUsbSupport()
{  
	MM_preloadImages('images/medBtn1.gif','#9617633300');
      MM_preloadImages('images/medBtn2.gif','#9617633301');
	MM_preloadImages('images/largeBtn1.gif','#9617633302');
      MM_preloadImages('images/largeBtn2.gif','#9617633303');
	MM_preloadImages('images/smallBtn1.gif','#9617633304');
      MM_preloadImages('images/smallBtn2.gif','#9617633305');
	MM_preloadImages('images/background.gif','#9617633306');
	MM_preloadImages('images/blue01circle.gif','#9617633307');
}


function onunloadNoUsbSupport(){
}

function noUsbSupportBack(){
	window.back();
}

//from cancelConfirmed()
function noUsbSupportNext(){
      cancelConfirmed();
}

////////////////////////////////////////////////////////////////////////////////
//  functions for privacyStatement.html
////////////////////////////////////////////////////////////////////////////////
//NOTE: This page will be ported completely into the VPM architecture; was given late with localized text already
//in each individual localized file

function eregPrivacyBack()
{
	window.back();
}

////////////////////////////////////////////////////////////////////////////////
//  functions for whatToDo.html
////////////////////////////////////////////////////////////////////////////////
// NOTE THAT THIS IS A DUMMY PAGE TO ALLOW TIME FOR THE CHARSET TO LOAD & TO CHECK FOR OS COMPATIBILITY
// Requirements on entry:
//
// Requirements on exit:
//

function onloadWhatTemp()
{
	// turn on logging - check with JP to move this to first HTML page
	HpfInst.InitProcess( null, true);

	//conduct OSs checks 
	var strProduct = new String(); 
	HpfInst.GetProcessString(HPIFile, "product", strProduct);
	var strOS = new String(); 
	HpfInst.GetProcessString(HPIFile, "os", strOS);
	
	if ((strProduct.value.toLowerCase() == "825c") || (strProduct.value.toLowerCase() == "845c") || (strProduct.value.toLowerCase() == "656c"))
	{
		if ((strOS.value.toLowerCase() == "winnt4") || (strOS.value.toLowerCase() == "win95"))
		{
			location="noUsbSupport.html";
		}
	}
	if (strProduct.value.toLowerCase() == "995c")
	{
		if ((strOS.value.toLowerCase() == "winnt4") || (strOS.value.toLowerCase() == "win95"))
		{
			location="noJeeniSupport.html";
		}
	}

	setTimeout("goToStartProcess();",500);
}

function goToStartProcess()
{
	location="pleaseWait.html";
}


function onunloadWhatTemp()
{
}

////////////////////////////////////////////////////////////////////////////////
//  functions for pleaseWait.html
////////////////////////////////////////////////////////////////////////////////
// 
// Requirements on entry:
//
// Requirements on exit:
//
function onloadPleaseWait(){

	// cement browser down
      var returnValue = new Object();
      var outString = new Object();	
      var inString = "$DisableMoveWindow$"; 

	UtilBroker.HPExpandString( inString, outString, returnValue);
 
	var strTemp = new String();
	var glueInstalledDriver;
	var hw1st;
	var result;
	var bPnp;
	var bUsb;

	EnableBackground();
	
	HpfInst.GetProcessString( HPIFile, "pnp", strTemp);
	bPnp = ConvertStringToBool( strTemp.value, false);

	HpfInst.GetProcessString( HPIFile, "usb", strTemp);
	bUsb = ConvertStringToBool( strTemp.value, false);

	hw1st = bPnp || bUsb;
	if ( hw1st)
	{
		HpfInst.SetProcessString( "hw1st", "true");
	}
	else
	{
		HpfInst.SetProcessString( "hw1st", "false");
	}
	
	//HpfInst.DidWMChangeHappen( bResult);
	//if( bResult.value)
	//{
	//	HpfInst.WaitOnGlueFinish( Timeout, bResult);
	//}

	HpfInst.DidGlueRun( bResult);
	if( bResult.value)
	{
		HpfInst.WaitOnGlueFinish( Timeout, bResult);
	}

	var strInstalledPort = new String();
	HpfInst.GlueInstalledDriver( strDriverName.value, strInstalledPort, bResult);
	if( bResult.value)
	{
		glueInstalledDriver = true;
		HpfInst.SetProcessString( "GlueInstalledDriver", "true");
		setPort( strInstalledPort.value);
	}
	else
	{
		glueInstalledDriver = false;
		HpfInst.SetProcessString( "GlueInstalledDriver", "false");
	}

	if ( hw1st || glueInstalledDriver)
	{
		// Next screen is Install Progress
		// the port/sport macros have been set by the cmdline or by the return value
		// from GlueInstalledDriver(...) above
		HpfInst.SetProcessString( "assist_install", "false");
		HpfInst.SetProcessString( "unassist_install_done", "n/a");
		HpfInst.SetProcessString( "io_connect", "unknown");
		HpfInst.SetProcessString( "in_troubleshoot", "false");
		HpfInst.SetProcessString( "bluetooth_install_to_file", "n/a"); 
		if (hw1st)
		{
			setTimeout("toDriverCopy();", 10000);
		}
		else
		{
			location="driverCopy.html";
		}
	}
	else
	{
		location="whatToDo2.html";
	}
	
}

function toDriverCopy()
{
	location="driverCopy.html";
}

function onunloadPleaseWait()
{
}


////////////////////////////////////////////////////////////////////////////////
//  functions for whatToDo2.html
////////////////////////////////////////////////////////////////////////////////
//
// Requirements on entry:
//
// Requirements on exit:
//

function onloadWhat()
{
	MM_preloadImages('images/medBtn1.gif','#9617633300');
      MM_preloadImages('images/medBtn2.gif','#9617633301');
	MM_preloadImages('images/largeBtn1.gif','#9617633302');
      MM_preloadImages('images/largeBtn2.gif','#9617633303');
	MM_preloadImages('images/smallBtn1.gif','#9617633304');
      MM_preloadImages('images/smallBtn2.gif','#9617633305');
	MM_preloadImages('images/background.gif','#9617633306');
	MM_preloadImages('images/blue01circle.gif','#9617633307');
}

function onunloadWhat(){
}

function tutorial(){
	//used to allow installation of the driver from troubleshootSoft.html only if it is the install 'check list' for unassisted
	HpfInst.SetProcessString( "unassist_install_done", "false"); 
	//used to denote if we know what connect the user wants
	HpfInst.SetProcessString( "io_connect", "unknown");
	//used to determine if the user is currently in troubleshooting
	HpfInst.SetProcessString( "in_troubleshoot", "false");
	//used to denote what path user is taking
      HpfInst.SetProcessString( "assist_install", "true");
	//used for bth install to file
	HpfInst.SetProcessString( "bluetooth_install_to_file", "false"); 
	//used to determine if user has clicked 'locate printer' button
	HpfInst.SetProcessString( "locate_retry", "false");

	var strProduct = new String(); 
	HpfInst.GetProcessString(HPIFile, "product", strProduct);
	var strOS = new String(); 
	HpfInst.GetProcessString(HPIFile, "os", strOS);

	if (strProduct.value.toLowerCase() != "995c") 
	{	
		location="haveEverything.html";
	}
	else
	{
		if ((strOS.value.toLowerCase() == "winme") || (strOS.value.toLowerCase() == "win98") || (strOS.value.toLowerCase() == "win98se"))
		{
			HpfInst.SetProcessString( "io_connect", "usb");
			location="haveEverything.html";		
		}
		else
		{
			location="whichCable.html";
		}
	}
}

function softwareOnly(){

	var strProduct = new String(); 
	HpfInst.GetProcessString(HPIFile, "product", strProduct);
	var strOS = new String(); 
	HpfInst.GetProcessString(HPIFile, "os", strOS);

	//used for bth install to file
	HpfInst.SetProcessString( "bluetooth_install_to_file", "false"); 
	HpfInst.SetProcessString( "io_connect", "unknown")
	HpfInst.SetProcessString( "locate_retry", "false");

	if (strProduct.value.toLowerCase() == "995c") // eliminates the choice of usb if OS does not support it  	
	{	
		if ((strOS.value.toLowerCase() == "winme") || (strOS.value.toLowerCase() == "win98") || (strOS.value.toLowerCase() == "win98se"))
		{
			HpfInst.SetProcessString( "io_connect", "usb");
		}
	}	
	else
	{
		if ((strOS.value.toLowerCase() == "winnt4") || (strOS.value.toLowerCase() == "win95"))
		{
			HpfInst.SetProcessString( "io_connect", "parallel");
		}
		else if ((strProduct.value.toLowerCase() == "825c") || (strProduct.value.toLowerCase() == "845c") || (strProduct.value.toLowerCase() == "656c"))
		{
			HpfInst.SetProcessString( "io_connect", "usb");
		}
	}

	//used to allow installation of the driver from troubleshootSoft.html only if it is the install 'check list' for unassisted
	HpfInst.SetProcessString( "unassist_install_done", "false"); 
	//used to determine if the user is currently in troubleshooting
	HpfInst.SetProcessString( "in_troubleshoot", "false");
	//used to denote what path user is taking
      HpfInst.SetProcessString( "assist_install", "false");

	location="troubleshootSoft.html";
}


////////////////////////////////////////////////////////////////////////////////
//  functions for haveDuplexer.html
////////////////////////////////////////////////////////////////////////////////
//

function onloadDuplexer(){
}

function onunloadDuplexer(){
}

function duplexerBack(){
	window.back();
}

function duplexerYes(){
	location="attachDuplexer.html";
}

function duplexerNo(){
	location="whichCable.html";
}

////////////////////////////////////////////////////////////////////////////////
//  functions for haveEverything.html
////////////////////////////////////////////////////////////////////////////////
//

function onloadEverything()
{  
	MM_preloadImages('images/medBtn1.gif','#9617633300');
      MM_preloadImages('images/medBtn2.gif','#9617633301');
	MM_preloadImages('images/largeBtn1.gif','#9617633302');
      MM_preloadImages('images/largeBtn2.gif','#9617633303');
	MM_preloadImages('images/smallBtn1.gif','#9617633304');
      MM_preloadImages('images/smallBtn2.gif','#9617633305');
	MM_preloadImages('images/background.gif','#9617633306');
	MM_preloadImages('images/blue01circle.gif','#9617633307');
}


function onunloadEverything(){
}

function everythingBack(){
	window.back();
}

function everythingYes()
{
	var strProduct = new String(); 	//to support products with USBonly; may change to prod number
	HpfInst.GetProcessString(HPIFile, "product", strProduct);
	var strOS = new String(); 		//to remove USB as an option for NT and 95 OSs
	HpfInst.GetProcessString(HPIFile, "os", strOS);

	if ((strProduct.value.toLowerCase() == "825c") || (strProduct.value.toLowerCase() == "845c") || (strProduct.value.toLowerCase() == "656c")) 	//list USBonly products
	{
		HpfInst.SetProcessString( "io_connect", "usb");
		location="connectUSB.html";
	}
	else if (strProduct.value.toLowerCase() == "995c") 
	{
			location = "attachDuplexer.html";
	}
	else if ((strOS.value.toLowerCase() == "win95") || (strOS.value.toLowerCase() == "winnt4")) 	//list USBonly products
	{
		HpfInst.SetProcessString( "io_connect", "parallel");
		location="connectParallel.html";
	}
	else
	{
		location="whichCable.html";
	}
}

function everythingNo(){
	location="notEverything.html";
}

////////////////////////////////////////////////////////////////////////////////
//  functions for whichCable.html
////////////////////////////////////////////////////////////////////////////////
//

function onloadCable()
{  
	MM_preloadImages('images/medBtn1.gif','#9617633300');
      MM_preloadImages('images/medBtn2.gif','#9617633301');
	MM_preloadImages('images/largeBtn1.gif','#9617633302');
      MM_preloadImages('images/largeBtn2.gif','#9617633303');
	MM_preloadImages('images/smallBtn1.gif','#9617633304');
      MM_preloadImages('images/smallBtn2.gif','#9617633305');
	MM_preloadImages('images/background.gif','#9617633306');
	MM_preloadImages('images/blue01circle.gif','#9617633307');
}

function onunloadCable()
{
}

function whichCableBack()
{
	window.back();
}

function cableInstallUSB()
{
      HpfInst.SetProcessString( "io_connect", "usb");
	
	var strProduct = new String(); 	//to support products with USBonly; may change to prod number
	HpfInst.GetProcessString(HPIFile, "product", strProduct);
	
	var strInTrouble = new String(); 	//to support products with USBonly; may change to prod number
	HpfInst.GetProcessString(HPIFile, "in_troubleshoot", strInTrouble);

	if ((strProduct.value.toLowerCase() != "995c") || (strInTrouble.value.toLowerCase() == "true")) 
	{ 
		location="connectUSB.html";
	}
	else
	{
		location="haveEverything.html";
	}
}

function cableInstallParallel()
{
	HpfInst.SetProcessString( "io_connect", "parallel");
	location="connectParallel.html";
}

function cableInstallBluetooth()
{
	var PortArray = new String();
	var NumPorts = new Number();
	var strInstalledPort = new String();

	//used to determine if BTH install has to be to file or to BTH port
	HpfInst.FindDeviceOnPortEx( HPIFile, "BTH:", PortArray, NumPorts, strInstalledPort, "BTH", 1, bResult);

	var strProduct = new String(); 	//to support products with USBonly; may change to prod number
	HpfInst.GetProcessString(HPIFile, "product", strProduct);

	var strInTrouble = new String(); 	//to support products with USBonly; may change to prod number
	HpfInst.GetProcessString(HPIFile, "in_troubleshoot", strInTrouble);

	if (NumPorts == 0)
	{
		HpfInst.SetProcessString( "bluetooth_install_to_file", "true");
		setPort("FILE:");
	}

      HpfInst.SetProcessString( "io_connect", "bluetooth");

	if ((strProduct.value.toLowerCase() != "995c") || (strInTrouble.value.toLowerCase() == "true")) 
	{
		location="powerCord.html";
	}
	else
	{
		location="haveEverything.html";
	}
}

function helpMe(){
	location="helpMeChoose.html";

}

function tellMeMore1(){
	location="helpMeChoose2.html";

}

function tellMeMore2(){
	location="helpMeChoose.html";

}



////////////////////////////////////////////////////////////////////////////////
//  functions for connectParallel.html
////////////////////////////////////////////////////////////////////////////////
//

function onloadParallel()
{  
	MM_preloadImages('images/medBtn1.gif','#9617633300');
      MM_preloadImages('images/medBtn2.gif','#9617633301');
	MM_preloadImages('images/largeBtn1.gif','#9617633302');
      MM_preloadImages('images/largeBtn2.gif','#9617633303');
	MM_preloadImages('images/smallBtn1.gif','#9617633304');
      MM_preloadImages('images/smallBtn2.gif','#9617633305');
	MM_preloadImages('images/background.gif','#9617633306');
	MM_preloadImages('images/blue01circle.gif','#9617633307');
}


function onunloadParallel(){
}

function connectParallelBack(){	
		window.back();
}

function connectParallelNext(){
		location="powerCord.html";
}


////////////////////////////////////////////////////////////////////////////////
//  functions for connectBluetooth.html
////////////////////////////////////////////////////////////////////////////////
//

function onloadBluetooth()
{  
	MM_preloadImages('images/medBtn1.gif','#9617633300');
      MM_preloadImages('images/medBtn2.gif','#9617633301');
	MM_preloadImages('images/largeBtn1.gif','#9617633302');
      MM_preloadImages('images/largeBtn2.gif','#9617633303');
	MM_preloadImages('images/smallBtn1.gif','#9617633304');
      MM_preloadImages('images/smallBtn2.gif','#9617633305');
	MM_preloadImages('images/background.gif','#9617633306');
	MM_preloadImages('images/blue01circle.gif','#9617633307');
}


function onunloadBluetooth(){
}

function connectBluetoothBack(){	
		window.back();
}

function connectBluetoothNext(){
		location="powerCord.html";
}



////////////////////////////////////////////////////////////////////////////////
//  functions for connectUSB.html
////////////////////////////////////////////////////////////////////////////////
//

function onloadUSB()
{  
	MM_preloadImages('images/medBtn1.gif','#9617633300');
      MM_preloadImages('images/medBtn2.gif','#9617633301');
	MM_preloadImages('images/largeBtn1.gif','#9617633302');
      MM_preloadImages('images/largeBtn2.gif','#9617633303');
	MM_preloadImages('images/smallBtn1.gif','#9617633304');
      MM_preloadImages('images/smallBtn2.gif','#9617633305');
	MM_preloadImages('images/background.gif','#9617633306');
	MM_preloadImages('images/blue01circle.gif','#9617633307');
}


function onunloadUSB(){
}

function connectUSBBack(){
	window.back();
}

function connectUSBNext(){
	location="powerCord.html";
}
////////////////////////////////////////////////////////////////////////////////
//  functions for powerCord.html
////////////////////////////////////////////////////////////////////////////////
//

function onloadPower()
{  
	MM_preloadImages('images/medBtn1.gif','#9617633300');
      MM_preloadImages('images/medBtn2.gif','#9617633301');
	MM_preloadImages('images/largeBtn1.gif','#9617633302');
      MM_preloadImages('images/largeBtn2.gif','#9617633303');
	MM_preloadImages('images/smallBtn1.gif','#9617633304');
      MM_preloadImages('images/smallBtn2.gif','#9617633305');
	MM_preloadImages('images/background.gif','#9617633306');
	MM_preloadImages('images/blue01circle.gif','#9617633307');
}


function onunloadPower(){
}

function powerCordBack(){
	window.back();
}

function powerCordNext()
{
	installProcess();
}

////////////////////////////////////////////////////////////////////////////////
//  functions for driverCopy.html
////////////////////////////////////////////////////////////////////////////////
//

//from Functions for Progress Dialog 

function onloadDriver()
{
	var strCheckConnect = new String();
	HpfInst.GetProcessString( "master.hpi", "io_connect", strCheckConnect);
	if (strCheckConnect.value == "usb")
	{
		setTimeout( "conductInstallProgress();", 30000);
	}
	else
	{
		setTimeout( "conductInstallProgress();", 5000);
	}
}

function conductInstallProgress()
{	
	var strHW1ST = new String();
	var glueInstalledDriver;
	var hw1st;
	var result;

	HpfInst.BeginWaitCursor();
	HpfInst.GetProcessString( HPIFile, "hw1st", strHW1ST);
	hw1st = ConvertStringToBool( strHW1ST.value, false);

	var strInstalledPort = new String();
	HpfInst.GlueInstalledDriver( strDriverName.value, strInstalledPort, bResult);

	if ( !hw1st && !bResult.value)
	{
		HpfInst.ProcessAndWait( HPIFile, "call_run_glue_install");
		HpfInst.WaitOnGlueFinish( Timeout, bResult);
	}

	HpfInst.ProcessAndWait( HPIFile, "install");
	HpfInst.EndWaitCursor();
	afterInstall();			
}

// make conditional dependent on release
function afterInstall()
{
	var strIsAssist = new String();
	HpfInst.GetProcessString( "master.hpi", "assist_install", strIsAssist);

	var strPort = new String();
	HpfInst.GetProcessString( "master.hpi", "port", strPort);

	var strProduct = new String(); 
	HpfInst.GetProcessString(HPIFile, "product", strProduct);
	
	if (strIsAssist.value.toLowerCase() == "true")
	{	
		location = "loadPaper.html";
	}
	else
	{
		if ((strPort.value.toLowerCase() == "file:") && (strProduct.value.toLowerCase() == "995c"))
		{
			location = "installToFile.html";
		}
		else
		{
			location = "printSample.html";
		}
	}
}

function writeProgressPlugin()
{
	document.write( '<embed type="application/x-instprogress" height="45" width="463" debug="4" success_target="">');
}

function onunloadDriver(){
}


////////////////////////////////////////////////////////////////////////////////
//  functions for usbDialog.html
////////////////////////////////////////////////////////////////////////////////
//

//from enterUSB
function onloadUSBDialog()
{
     continueWhenUSBAttached(); 
}

function continueWhenUSBAttached()
{
	HpfInst.IsGlueFinished( bResult);
	if ( bResult.value)
	{
		location = "driverCopy.html"; //return to calling function; need to replace w/robust solution (see above comment)
	}
	else
	{
		setTimeout( "continueWhenUSBAttached();", 1000);
	}
}

function onunloadUSBDialog(){
}


function usbDialogStep1(){
	location="connectUSB.html";
}

function usbDialogBack(){
	window.back();
}

function toSelectScreen(){
      var strProduct = new String(); 	//to support products with USB only; may change to prod number
	HpfInst.GetProcessString(HPIFile, "product", strProduct);
	if ((strProduct.value.toLowerCase() == "825c") || (strProduct.value.toLowerCase() == "845c") || (strProduct.value.toLowerCase() == "656c")) 	//list USB only products
	{
		location="moreUSBHelp.html"; //goes to page with more USB help for the user of USB-only products
	}
	else
	{
      	var strPath = new String();
		HpfInst.GetProcessString( "master.hpi","assist_install", strPath);
		if (strPath.value.toLowerCase() == "true")
		{
			location="whichCable.html";
		}
		else
		{
			location="portDialog.html";
		}
	}
}

////////////////////////////////////////////////////////////////////////////////
//  functions for bluetoothDialog.html
////////////////////////////////////////////////////////////////////////////////
//

function onloadBluetoothDialog()
{
	MM_preloadImages('images/background.gif','#9617633306');
}


function onunloadBluetoothDialog()
{
}


function bluetoothDialogNext()
{
}

function bluetoothDialogBack()
{
	window.back();
}


////////////////////////////////////////////////////////////////////////////////
//  functions for loadPaper.html
////////////////////////////////////////////////////////////////////////////////
//

function onloadPaper()
{  
	MM_preloadImages('images/medBtn1.gif','#9617633300');
      MM_preloadImages('images/medBtn2.gif','#9617633301');
	MM_preloadImages('images/largeBtn1.gif','#9617633302');
      MM_preloadImages('images/largeBtn2.gif','#9617633303');
	MM_preloadImages('images/smallBtn1.gif','#9617633304');
      MM_preloadImages('images/smallBtn2.gif','#9617633305');
	MM_preloadImages('images/background.gif','#9617633306');
	MM_preloadImages('images/blue01circle.gif','#9617633307');
}


function onunloadPaper(){
}

function loadPaperBack(){
	window.back();
}

function loadPaperNext(){
	location="prepareCartridges.html";
}

function whyWhitePaper(){
	location="whyWhitePaper.html";
}


////////////////////////////////////////////////////////////////////////////////
//  functions for prepareCartridges.html
////////////////////////////////////////////////////////////////////////////////
//

function onloadPrepareCartridges()
{  
	MM_preloadImages('images/medBtn1.gif','#9617633300');
      MM_preloadImages('images/medBtn2.gif','#9617633301');
	MM_preloadImages('images/largeBtn1.gif','#9617633302');
      MM_preloadImages('images/largeBtn2.gif','#9617633303');
	MM_preloadImages('images/smallBtn1.gif','#9617633304');
      MM_preloadImages('images/smallBtn2.gif','#9617633305');
	MM_preloadImages('images/background.gif','#9617633306');
	MM_preloadImages('images/blue01circle.gif','#9617633307');
}


function onunloadPrepareCartridges(){
}

function prepareCartridgesBack(){
	window.back();
}

function prepareCartridgesNext(){

	location="installCartridges.html";
}



////////////////////////////////////////////////////////////////////////////////
//  functions for installCartridges.html
////////////////////////////////////////////////////////////////////////////////
//

function onloadCartridges()
{  
	MM_preloadImages('images/medBtn1.gif','#9617633300');
      MM_preloadImages('images/medBtn2.gif','#9617633301');
	MM_preloadImages('images/largeBtn1.gif','#9617633302');
      MM_preloadImages('images/largeBtn2.gif','#9617633303');
	MM_preloadImages('images/smallBtn1.gif','#9617633304');
      MM_preloadImages('images/smallBtn2.gif','#9617633305');
	MM_preloadImages('images/background.gif','#9617633306');
	MM_preloadImages('images/blue01circle.gif','#9617633307');
}


function onunloadCartridges(){
}

function installCartridgesBack(){
	window.back();
}

function installCartridgesNext(){

	var strInstallToFile = new String(); 	
	HpfInst.GetProcessString(HPIFile, "bluetooth_install_to_file", strInstallToFile);	
	var strProduct = new String();
	HpfInst.GetProcessString(HPIFile, "product", strProduct);

	if (strInstallToFile.value.toLowerCase() == "true")
	{
		location="installToFile.html";
	} 
	else
	{
		location="printSample.html";
	}
}

////////////////////////////////////////////////////////////////////////////////
//  functions for calibration.html
////////////////////////////////////////////////////////////////////////////////
//

function onloadCalibration(){
}

function onunloadCalibration(){
}

function calibrationBack(){
	window.back();
}

function calibrationNext(){
	location="printSample.html";
}

function calibrationYes(){
	location="printSample.html";
}

function calibrationNo(){
	location="troubleshootCalibration.html";
}

////////////////////////////////////////////////////////////////////////////////
//  functions for printSample.html
////////////////////////////////////////////////////////////////////////////////
//

//from Functions for Driver Done Dialog 
function onloadSample()
{
	HpfInst.InstRestoreSourcePath();
	MM_preloadImages('images/medBtn1.gif','#9617633300');
      MM_preloadImages('images/medBtn2.gif','#9617633301');
	MM_preloadImages('images/largeBtn1.gif','#9617633302');
      MM_preloadImages('images/largeBtn2.gif','#9617633303');
	MM_preloadImages('images/smallBtn1.gif','#9617633304');
      MM_preloadImages('images/smallBtn2.gif','#9617633305');
	MM_preloadImages('images/background.gif','#9617633306');
	MM_preloadImages('images/blue01circle.gif','#9617633307');
}

function onunloadSample(){
}

function printSampleBack(){
	window.back();
}

function printSampleNext()
{
	var strLang = new String();
	HpfInst.GetProcessString(HPIFile, "lang", strLang);

	if (strLang.value.toLowerCase() == "jpn" || CheckERegMacro()==0)
	{ 
		location="installComp.html";
	}	
	else
	{
		location="doEreg.html";
	}
}

function printSampleYes(){
      MM_callJS('PrintDemoPage(1)'); //from exitDriverDoneAndPrint
	location="confirmSample.html";
}


////////////////////////////////////////////////////////////////////////////////
//  functions for attachDuplexer.html
////////////////////////////////////////////////////////////////////////////////
//

function onloadAttachDuplexer(){
}

function onunloadAttachDuplexer(){
}

function attachDuplexerBack(){
	window.back();
}

function attachDuplexerNext()
{
	var strConnect = new String(); 	
	HpfInst.GetProcessString(HPIFile, "io_connect", strConnect);

	if (strConnect.value.toLowerCase() == "bluetooth")
	{
		location="powerCord.html";
	}
	else
	{
		location="connectUsb.html";
	}
}

////////////////////////////////////////////////////////////////////////////////
//  functions for doEreg.html
////////////////////////////////////////////////////////////////////////////////
//

//from Functions for Driver Done Dialog 
function onloadEreg()
{  
	MM_preloadImages('images/medBtn1.gif','#9617633300');
      MM_preloadImages('images/medBtn2.gif','#9617633301');
	MM_preloadImages('images/largeBtn1.gif','#9617633302');
      MM_preloadImages('images/largeBtn2.gif','#9617633303');
	MM_preloadImages('images/smallBtn1.gif','#9617633304');
      MM_preloadImages('images/smallBtn2.gif','#9617633305');
	MM_preloadImages('images/background.gif','#9617633306');
	MM_preloadImages('images/blue01circle.gif','#9617633307');
}


function onunloadEreg(){
}

function eregBack(){
	window.back();
}

function eregNext(){
	HpfInst.SetProcessString( "goto_ereg", "false");
	location="installComp.html";
}

function eregYes(){
      HpfInst.SetProcessString( "goto_ereg", "true");
	location="installComp.html";
}

function readPrivacy(){
	location="eregPrivacy.html";
}


////////////////////////////////////////////////////////////////////////////////
//  functions for confirmSample.html
////////////////////////////////////////////////////////////////////////////////
//

function onloadConfirmSample()
{  
	MM_preloadImages('images/medBtn1.gif','#9617633300');
      MM_preloadImages('images/medBtn2.gif','#9617633301');
	MM_preloadImages('images/largeBtn1.gif','#9617633302');
      MM_preloadImages('images/largeBtn2.gif','#9617633303');
	MM_preloadImages('images/smallBtn1.gif','#9617633304');
      MM_preloadImages('images/smallBtn2.gif','#9617633305');
	MM_preloadImages('images/background.gif','#9617633306');
	MM_preloadImages('images/blue01circle.gif','#9617633307');
}


function onunloadConfirmSample(){
}

function confirmSampleBack(){
	window.back();
}

function confirmSampleNext()
{
	var strLang = new String();
	HpfInst.GetProcessString(HPIFile, "lang", strLang);

	if (strLang.value.toLowerCase() == "jpn" || CheckERegMacro()==0)
	{ 
		location="installComp.html";
	}	
	else
	{
		location="doEreg.html";
	}
}

function confirmSampleYes()
{
	confirmSampleNext();
}


function confirmSampleNo(){
	location="troubleshootSoft.html";
}

function confirmSampleAgain(){
	printSampleYes();
}


////////////////////////////////////////////////////////////////////////////////
//  functions for portDialog.html
////////////////////////////////////////////////////////////////////////////////
//

function onloadPortDialog()
{  	
	continueWhenUSBAttached();
	MM_preloadImages('images/medBtn1.gif','#9617633300');
      MM_preloadImages('images/medBtn2.gif','#9617633301');
	MM_preloadImages('images/largeBtn1.gif','#9617633302');
      MM_preloadImages('images/largeBtn2.gif','#9617633303');
	MM_preloadImages('images/smallBtn1.gif','#9617633304');
      MM_preloadImages('images/smallBtn2.gif','#9617633305');
	MM_preloadImages('images/background.gif','#9617633306');
	MM_preloadImages('images/blue01circle.gif','#9617633307');
}


function onunloadPortDialog(){
}

var mutexOnTryToLocate = false; //from Functions for Select Port Dialog

function portDialogStep1(){
      // block if still processing a call to onTryToLocate()
	if ( mutexOnTryToLocate)
	{
		return;
	}
	mutexOnTryToLocate = true;

	var strInstalledPort = new String();
	var PortArray = new String();
	var NumPorts = new Number();

	HpfInst.SetProcessString( "locate_retry", "true");

	//to determine what 'ports' to display
	var strCheckConnect = new String();
	HpfInst.GetProcessString( "master.hpi", "io_connect", strCheckConnect);
	var strInstallToFile = new String();
	HpfInst.GetProcessString( "master.hpi", "bluetooth_install_to_file", strInstallToFile);
	var strProduct = new String(); 
	HpfInst.GetProcessString(HPIFile, "product", strProduct);
	var strIsAssist = new String();
	HpfInst.GetProcessString( "master.hpi", "assist_install", strIsAssist);

	HpfInst.BeginWaitCursor();

	if (strInstallToFile.value.toLowerCase() == "true")
	{
		var portName = new String();
		HpfInst.FindBT3ComPort(portName, bResult);
		
	   	if (bResult.value)
		{
			HpfInst.SetProcessString( "bluetooth_install_to_file", "false");
			setPort(portName.value.toLowerCase());
			location="driverCopy.html";
		}
		else
		{
			if (strIsAssist.value.toLowerCase() == "true")
			{
				setPort("FILE:");
				location="driverCopy.html";
			}	
			else
			{
				var PortArray = new String();
				var NumPorts = new Number();
				var strInstalledPort = new String();
				HpfInst.FindDeviceOnPortEx( HPIFile, "FILE:", PortArray, NumPorts, strInstalledPort, "*", 1, bResult);
				//Setup for Port Chooser screens
				HpfInst.SetProcessString( "PortArray", PortArray.value);
				mutexExitStart = false;
				location="portDialog.html";
			}	
		}	
	}
	else if ((strCheckConnect.value.toLowerCase() == "parallel") && (strIsAssist.value.toLowerCase() == "true"))
	{
		HpfInst.FindDeviceOnPortEx( HPIFile, "LPT1:", PortArray, NumPorts, strInstalledPort, "LPT", 1, bResult);
	}
	else if ((strCheckConnect.value.toLowerCase() == "usb") && (strIsAssist.value.toLowerCase() == "true"))
	{
		HpfInst.FindDeviceOnPortEx( HPIFile, "USB:", PortArray, NumPorts, strInstalledPort, "USB", 1, bResult);
	}
	else if ((strCheckConnect.value.toLowerCase() == "bluetooth")&& (strIsAssist.value.toLowerCase() == "true"))
	{
		HpfInst.FindDeviceOnPortEx( HPIFile, "BTH:", PortArray, NumPorts, strInstalledPort, "BTH FILE", 1, bResult);
	}
	else
	{
		if ((strProduct.value.toLowerCase() == "825c")||(strProduct.value.toLowerCase() == "845c")||(strProduct.value.toLowerCase() == "656c"))
		{
			HpfInst.FindDeviceOnPortEx( HPIFile, "USB:", PortArray, NumPorts, strInstalledPort, "*", 1, bResult);
		}
		else if (strProduct.value.toLowerCase() == "995c")
		{
			HpfInst.FindDeviceOnPortEx( HPIFile, "FILE:", PortArray, NumPorts, strInstalledPort, "*", 1, bResult);
		}
		else
		{
			HpfInst.FindDeviceOnPortEx( HPIFile, "LPT1:", PortArray, NumPorts, strInstalledPort, "*", 1, bResult);
		}
	}

	HpfInst.EndWaitCursor();
	if ( bResult.value)
	{
		mutexOnTryToLocate = false;
		location="driverCopy.html";
	}
	else
	{
		HpfInst.SetProcessString( "PortArray", PortArray.value);
//		alert( "try to locate failed");
		mutexOnTryToLocate = false;
		location="portDialog.html";	// force a refresh of the screen to update the port select form
	}
}

function portDialogBack(){
	window.back();
}

function portDialogNext(){

	var strInstallToFile = new String();
	HpfInst.GetProcessString( "master.hpi", "bluetooth_install_to_file", strInstallToFile);

	var port = new String();
	HpfInst.GetProcessString( HPIFile, "port", port);

	var strProduct = new String(); 
	HpfInst.GetProcessString(HPIFile, "product", strProduct);
	
	if ( "usb:" == port.value.toLowerCase())
	{
		location="usbDialog.html";
	}
	else if (( "file:" == port.value.toLowerCase())&& (strProduct.value.toLowerCase() == "995c"))
	{
		var portName = new String();
		HpfInst.FindBT3ComPort(portName, bResult);
		if (bResult.value)
		{
			HpfInst.SetProcessString( "bluetooth_install_to_file", "false");
			setPort(portName.value.toLowerCase());
		}
		else
		{
			setPort("FILE:");
		}
		location="driverCopy.html";
 	}
	else if ( "file:" == port.value.toLowerCase())
	{
		setPort("FILE:");
		location="driverCopy.html";
	}
	else if ( "bth:" == port.value.toLowerCase())
	{
		location="bluetoothDialog.html";
	}
	else
	{
		location="driverCopy.html";
	}
}


function writePortDropdown()
{
	var param=writePortDropdown.arguments.length?writePortDropdown.arguments[0]:null;
	var PortArray = new String();
	HpfInst.GetProcessString( HPIFile, "PortArray", PortArray);

	var strPortArray = PortArray.value.split(";");

	var port = new String();
	HpfInst.GetProcessString( HPIFile, "port", port);

	if(param!="options")
	{
		document.write('<form name="PortSelect" method="post" action="">');
		document.write('<select name="ConnectSelect" onchange="setPort(document.PortSelect.ConnectSelect.value);">')
	}
	for ( var i in strPortArray)
	{
		if ( strPortArray[i].toLowerCase()==port.value.toLowerCase())
		{
			document.write("<option SELECTED> " + strPortArray[i]);
		}
		else
		{
			document.write("<option> " + strPortArray[i]);
		}
	}
	if(param!="options")
	{
		document.write('</select>');
		document.write('</form>');
	}
}



////////////////////////////////////////////////////////////////////////////////
//  functions for installToFile.html
////////////////////////////////////////////////////////////////////////////////
//

function onloadInstallToFile()
{  
	MM_preloadImages('images/medBtn1.gif','#9617633300');
      MM_preloadImages('images/medBtn2.gif','#9617633301');
	MM_preloadImages('images/largeBtn1.gif','#9617633302');
      MM_preloadImages('images/largeBtn2.gif','#9617633303');
	MM_preloadImages('images/smallBtn1.gif','#9617633304');
      MM_preloadImages('images/smallBtn2.gif','#9617633305');
	MM_preloadImages('images/background.gif','#9617633306');
	MM_preloadImages('images/blue01circle.gif','#9617633307');
}


function onunloadInstallToFile()
{
}

function installToFileBack()
{
	window.back();
}

function installToFileNext()
{
}

function gotoUsb()
{
	location="whichCable.html";
}



////////////////////////////////////////////////////////////////////////////////
//  functions for troubleshootSoft.html (also leveraged in troubleshootCartridges.html)
////////////////////////////////////////////////////////////////////////////////
//

function onloadTroubleshootSoft()
{
      //used to limit browsing the entire install path from the troubleshooting pages
	HpfInst.SetProcessString( "in_troubleshoot", "true");

	MM_preloadImages('images/medBtn1.gif','#9617633300');
      MM_preloadImages('images/medBtn2.gif','#9617633301');
	MM_preloadImages('images/largeBtn1.gif','#9617633302');
      MM_preloadImages('images/largeBtn2.gif','#9617633303');
	MM_preloadImages('images/smallBtn1.gif','#9617633304');
      MM_preloadImages('images/smallBtn2.gif','#9617633305');
	MM_preloadImages('images/background.gif','#9617633306');
	MM_preloadImages('images/blue01circle.gif','#9617633307');
}

function onunloadTroubleshootSoft(){
}

function troubleshootSoftBack(){
	HpfInst.SetProcessString( "in_troubleshoot", "false");
	window.back();
}

function troubleshootSoftNext(){

	HpfInst.SetProcessString( "in_troubleshoot", "false");

	var strIsAssist = new String();
	HpfInst.GetProcessString( "master.hpi", "assist_install", strIsAssist);

      var strUnAssistInstallDone = new String();
	HpfInst.GetProcessString( HPIFile, "unassist_install_done", strUnAssistInstallDone);

 	var strProdNum = new String();
	HpfInst.GetProcessString( HPIFile, "product", strProdNum);

	if ((strIsAssist.value.toLowerCase() == "false")&&(strUnAssistInstallDone.value.toLowerCase() == "false")) 
	{
		//so no installation can occur from print sample confirm page
		HpfInst.SetProcessString( "unassist_install_done", "true");
		if (strProdNum.value.toLowerCase() == "995c")
		{
			HpfInst.DidGlueRun( bResult);
			if( bResult.value)
			{
				HpfInst.WaitOnGlueFinish( Timeout, bResult);
			}
			//HpfInst.IsGlueFinished( bResult);
			//if (! bResult.value)
			//{
				HpfInst.SetProcessString( "bluetooth_install_to_file", "true");
			//}
		}
      	installProcess();	
	}
	else
	{
		window.back();
	}
}

function toVerifyCable(){
	var strCheckConnect = new String();
	HpfInst.GetProcessString( "master.hpi", "io_connect", strCheckConnect);
	
	var strProduct = new String(); 	//to support products with USB only; may change to prod number
	HpfInst.GetProcessString(HPIFile, "product", strProduct);
	if ((strProduct.value.toLowerCase() == "825c") || (strProduct.value.toLowerCase() == "845c") || (strProduct.value.toLowerCase() == "656c")) 	//list USB only products
	{
		location="connectUsb.html";
	}
	else if (strCheckConnect.value.toLowerCase() == "unknown")  //don't know what IO path user is on
	{
		location="whichCable.html";
	}
	else //if they have selected a path, we give them the appropriate path
	{
		if (strCheckConnect.value.toLowerCase() == "parallel")	
		{
			location="connectParallel.html";
		}
		if (strCheckConnect.value.toLowerCase() == "usb")
		{
			location="connectUsb.html";
		}
		if (strCheckConnect.value.toLowerCase() == "bluetooth")
		{
			location="attachDuplexer.html";
		}

	}
}

function toVerifyPower(){
	location="powerCord.html";
}

function toVerifyPaper(){
	location="loadPaper.html";
}

function toVerifyTape(){
	location="prepareCartridges.html";
}

function toVerifyCartridges(){
	location="installCartridges.html";
}

function toVerifyDuplexer(){
	location="attachDuplexer.html";
}

////////////////////////////////////////////////////////////////////////////////
//  functions for notEverything.html
////////////////////////////////////////////////////////////////////////////////
//

function onloadNotEverything()
{  
	MM_preloadImages('images/medBtn1.gif','#9617633300');
      MM_preloadImages('images/medBtn2.gif','#9617633301');
	MM_preloadImages('images/largeBtn1.gif','#9617633302');
      MM_preloadImages('images/largeBtn2.gif','#9617633303');
	MM_preloadImages('images/smallBtn1.gif','#9617633304');
      MM_preloadImages('images/smallBtn2.gif','#9617633305');
	MM_preloadImages('images/background.gif','#9617633306');
	MM_preloadImages('images/blue01circle.gif','#9617633307');
}


function onunloadNotEverything()
{
}

function notEverythingBack()
{
	window.back();
}

function notEverythingNext()
{
      location="exitDialog.html";
}

function toMoreBluetooth()
{
	location="bluetoothInformation.html";
}	

////////////////////////////////////////////////////////////////////////////////
//  functions for moreUSBHelp.html
////////////////////////////////////////////////////////////////////////////////
//

function onloadUSBHelp(){
	continueWhenUSBAttached();
}

function onunloadUSBHelp(){
}

function usbHelpBack(){
	window.back();
}

function usbHelpNext(){
      location="exitDialog.html";
}



////////////////////////////////////////////////////////////////////////////////
//  functions for helpMeChoose.html
////////////////////////////////////////////////////////////////////////////////
//

function onloadHelpChoose()
{  
	MM_preloadImages('images/medBtn1.gif','#9617633300');
      MM_preloadImages('images/medBtn2.gif','#9617633301');
	MM_preloadImages('images/largeBtn1.gif','#9617633302');
      MM_preloadImages('images/largeBtn2.gif','#9617633303');
	MM_preloadImages('images/smallBtn1.gif','#9617633304');
      MM_preloadImages('images/smallBtn2.gif','#9617633305');
	MM_preloadImages('images/background.gif','#9617633306');
	MM_preloadImages('images/blue01circle.gif','#9617633307');
}


function onunloadHelpChoose(){
}

function helpChooseBack(){
	window.back();
}

function helpChooseNext(){
}

////////////////////////////////////////////////////////////////////////////////
//  functions for helpMeChoose2.html
////////////////////////////////////////////////////////////////////////////////
//

function onloadHelpChoose2()
{  
	MM_preloadImages('images/medBtn1.gif','#9617633300');
      MM_preloadImages('images/medBtn2.gif','#9617633301');
	MM_preloadImages('images/largeBtn1.gif','#9617633302');
      MM_preloadImages('images/largeBtn2.gif','#9617633303');
	MM_preloadImages('images/smallBtn1.gif','#9617633304');
      MM_preloadImages('images/smallBtn2.gif','#9617633305');	
	MM_preloadImages('images/background.gif','#9617633306');
	MM_preloadImages('images/blue01circle.gif','#9617633307');
}


function onunloadHelpChoose2(){
}

function helpChoose2Back(){
	window.back();
}

function helpChoose2Next(){
}



////////////////////////////////////////////////////////////////////////////////
//  functions for bluetoothInformation.html
////////////////////////////////////////////////////////////////////////////////
//

function onloadBluetoothInformation()
{  
	MM_preloadImages('images/medBtn1.gif','#9617633300');
      MM_preloadImages('images/medBtn2.gif','#9617633301');
	MM_preloadImages('images/largeBtn1.gif','#9617633302');
      MM_preloadImages('images/largeBtn2.gif','#9617633303');
	MM_preloadImages('images/smallBtn1.gif','#9617633304');
      MM_preloadImages('images/smallBtn2.gif','#9617633305');
	MM_preloadImages('images/background.gif','#9617633306');
	MM_preloadImages('images/blue01circle.gif','#9617633307');
}


function onunloadBluetoothInformation()
{
}

function bluetoothInformationBack()
{
	window.back();
}

function bluetoothInformationNext()
{
}


////////////////////////////////////////////////////////////////////////////////
//  functions for noBluetoothSupport.html
////////////////////////////////////////////////////////////////////////////////
//

function onloadNoBluetoothSupport()
{  
	MM_preloadImages('images/medBtn1.gif','#9617633300');
      MM_preloadImages('images/medBtn2.gif','#9617633301');
	MM_preloadImages('images/largeBtn1.gif','#9617633302');
      MM_preloadImages('images/largeBtn2.gif','#9617633303');
	MM_preloadImages('images/smallBtn1.gif','#9617633304');
      MM_preloadImages('images/smallBtn2.gif','#9617633305');
	MM_preloadImages('images/background.gif','#9617633306');
	MM_preloadImages('images/blue01circle.gif','#9617633307');
}


function onunloadNoBluetoothSupport()
{
}

function noBluetoothSupportBack()
{
	window.back();
}


////////////////////////////////////////////////////////////////////////////////
//  functions for whyWhitePaper.html
////////////////////////////////////////////////////////////////////////////////
//

function onloadWhitePaper()
{  
	MM_preloadImages('images/medBtn1.gif','#9617633300');
      MM_preloadImages('images/medBtn2.gif','#9617633301');
	MM_preloadImages('images/largeBtn1.gif','#9617633302');
      MM_preloadImages('images/largeBtn2.gif','#9617633303');
	MM_preloadImages('images/smallBtn1.gif','#9617633304');
      MM_preloadImages('images/smallBtn2.gif','#9617633305');
	MM_preloadImages('images/background.gif','#9617633306');
	MM_preloadImages('images/blue01circle.gif','#9617633307');
}


function onunloadWhitePaper(){
}

function whitePaperBack(){
	window.back();
}

function whitePaperNext(){
}



////////////////////////////////////////////////////////////////////////////////
//  functions for installComp.html
////////////////////////////////////////////////////////////////////////////////
//

function onloadComp()
{
	setTimeout("installCleanup();",100);

	MM_preloadImages('images/medBtn1.gif','#9617633300');
      MM_preloadImages('images/medBtn2.gif','#9617633301');
	MM_preloadImages('images/largeBtn1.gif','#9617633302');
      MM_preloadImages('images/largeBtn2.gif','#9617633303');
	MM_preloadImages('images/smallBtn1.gif','#9617633304');
      MM_preloadImages('images/smallBtn2.gif','#9617633305');
	MM_preloadImages('images/background.gif','#9617633306');
	MM_preloadImages('images/blue01circle.gif','#9617633307');
}

function installCleanup()
{
	var temp = new Object();

	HpfInst.ProcessExpandStringEx( HPIFile, "$ereg_langs$", PES_MACROS|PES_ESCAPES, temp, bResult);
	var strEregLangs = new String( temp.value);

	HpfInst.GetProcessString( HPIFile, "lang", temp);
	var strLang = new String( temp.value);

	HpfInst.GetProcessString( HPIFile, "showereg", temp);
	var bShowEreg = ConvertStringToBool( temp.value, false);

	var indexVal = strEregLangs.toLowerCase().indexOf( strLang.toLowerCase());

	var strGoToEreg = new String();
	HpfInst.GetProcessString( "master.hpi", "goto_ereg", strGoToEreg);

	if ( bShowEreg && (-1 != indexVal) && (strGoToEreg.value.toLowerCase() == "true"))
	{
		var oProduct = new Object();
		var returnValue = new Object();
		var outString = new Object();
		var inString = "$HideWindow$"; 

		// hide browser
		UtilBroker.HPExpandString( inString, outString, returnValue);

		// retrieve serial number for ereg
        	var eregSerial = new String();
        	eregSerial = ProcessSysInfoItem("PrinterInfo");       
        
       var SnField = eregSerial.indexOf( "SN#=" );
        if( SnField != -1 )
        {
            eregSerial = eregSerial.slice( SnField+4, SnField+14 );
            HpfInst.SetProcessString( "eregserial", eregSerial);
        }

		// launch ereg
		HpfInst.ProcessAndWait( HPIFile, "doereg_check_and_run");
		HpfInst.GetProcessString( HPIFile, "product", oProduct);

		// wait until ereg done
		HpfInst.WaitUntilEregFinished( oProduct.value);

        // determine if need to install barnes and noble
        HpfInst.Process( HPIFile, "doereg_barnes_noble_check" );
        
		returnValue = new Object();
		outString = new Object();
		inString = "$ShowWindow$"; 
		UtilBroker.HPExpandString( inString, outString, returnValue);
	}
}

function onunloadComp(){
}

function installCompNext(){
  
    //this used to be ProcessAndWait(...)
    DisableBackground();

    // uncement browser
    var returnValue = new Object();
  	var outString = new Object();	
   	var inString = "$EnableMoveWindow$"; 
	UtilBroker.HPExpandString( inString, outString, returnValue);	

    // setTimeout is used because the browser was freezing
    // either on installComp.html OR while loading dugout_home.html
    setTimeout("location=\"dugout_home.html\";",100);
}

function installCompBack(){
	window.back();
}


var mutexExitStart = false; 

function installProcess()
{
 // block if we're already processing a call to exitStart()
	if ( mutexExitStart)
	{
		return "#";
	}
	mutexExitStart = true;

	var strTemp = new String();
	var glueInstalledDriver;
	var hw1st;
	var result;
	var bPnp;
	var bUsb;

	HpfInst.GetProcessString( HPIFile, "pnp", strTemp);
	bPnp = ConvertStringToBool( strTemp.value, false);

	HpfInst.GetProcessString( HPIFile, "usb", strTemp);
	bUsb = ConvertStringToBool( strTemp.value, false);

	var strIsAssist = new String();
	HpfInst.GetProcessString( "master.hpi", "assist_install", strIsAssist);

	hw1st = bPnp || bUsb;
	if ( hw1st)
	{
		HpfInst.SetProcessString( "hw1st", "true");
	}
	else
	{
		HpfInst.SetProcessString( "hw1st", "false");
	}

	//HpfInst.DidWMChangeHappen( bResult);
	//if( bResult.value)
	//{
	//	HpfInst.WaitOnGlueFinish( Timeout, bResult);
	//}

	HpfInst.DidGlueRun( bResult);
	if( bResult.value)
	{
		HpfInst.WaitOnGlueFinish( Timeout, bResult);
	}

	var strInstallToFile = new String();
	HpfInst.GetProcessString( "master.hpi", "bluetooth_install_to_file", strInstallToFile);
	var strInstalledPort = new String();
	HpfInst.GlueInstalledDriver( strDriverName.value, strInstalledPort, bResult);
	if( bResult.value)
	{
		glueInstalledDriver = true;
		HpfInst.SetProcessString( "GlueInstalledDriver", "true");
		setPort( strInstalledPort.value);
	}
	else
	{
		glueInstalledDriver = false;
		HpfInst.SetProcessString( "GlueInstalledDriver", "false");
	}

	if ( hw1st || glueInstalledDriver)
	{
		// Next screen is Install Progress
		// the port/sport macros have been set by the cmdline or by the return value
		// from GlueInstalledDriver(...) above
		   location="driverCopy.html";
	}
	else if (strInstallToFile.value.toLowerCase() == "true")
	{
		var portName = new String();
		HpfInst.FindBT3ComPort(portName, bResult);
		
	   	if (bResult.value)
		{
			HpfInst.SetProcessString( "bluetooth_install_to_file", "false");
			setPort(portName.value.toLowerCase());
			location="driverCopy.html";
		}
		else
		{
			if (strIsAssist.value.toLowerCase() == "true")
			{
				setPort("FILE:");
				location="driverCopy.html";
			}	
			else
			{
				var PortArray = new String();
				var NumPorts = new Number();
				var strInstalledPort = new String();
				HpfInst.FindDeviceOnPortEx( HPIFile, "FILE:", PortArray, NumPorts, strInstalledPort, "*", 1, bResult);
				//Setup for Port Chooser screens
				HpfInst.SetProcessString( "PortArray", PortArray.value);
				mutexExitStart = false;
				location="portDialog.html";
			}		
		}
	}
	else
	{
		var PortArray = new String();
		var NumPorts = new Number();
		var strInstalledPort = new String();

	//to determine what 'ports' to display
	var strCheckConnect = new String();
	HpfInst.GetProcessString( "master.hpi", "io_connect", strCheckConnect);
	var strProduct = new String(); 
	HpfInst.GetProcessString(HPIFile, "product", strProduct);
	var strIsAssist = new String();
	HpfInst.GetProcessString( "master.hpi", "assist_install", strIsAssist);

	HpfInst.BeginWaitCursor();

	if ((strCheckConnect.value.toLowerCase() == "parallel") && (strIsAssist.value.toLowerCase() == "true"))
	{
		HpfInst.FindDeviceOnPortEx( HPIFile, "LPT1:", PortArray, NumPorts, strInstalledPort, "LPT", 1, bResult);
	}
	else if ((strCheckConnect.value.toLowerCase() == "usb")&& (strIsAssist.value.toLowerCase() == "true"))
	{
		HpfInst.FindDeviceOnPortEx( HPIFile, "USB:", PortArray, NumPorts, strInstalledPort, "USB", 1, bResult);
	}
	else if ((strCheckConnect.value.toLowerCase() == "bluetooth")&& (strIsAssist.value.toLowerCase() == "true"))
	{
		HpfInst.FindDeviceOnPortEx( HPIFile, "BTH:", PortArray, NumPorts, strInstalledPort, "BTH FILE", 1, bResult);
	}
	else
	{
		if ((strProduct.value.toLowerCase() == "825c")||(strProduct.value.toLowerCase() == "845c")||(strProduct.value.toLowerCase() == "656c"))
		{
			HpfInst.FindDeviceOnPortEx( HPIFile, "USB:", PortArray, NumPorts, strInstalledPort, "*", 1, bResult);
		}
		else if (strProduct.value.toLowerCase() == "995c")
		{
			HpfInst.FindDeviceOnPortEx( HPIFile, "FILE:", PortArray, NumPorts, strInstalledPort, "*", 1, bResult);
		}
		else
		{
			HpfInst.FindDeviceOnPortEx( HPIFile, "LPT1:", PortArray, NumPorts, strInstalledPort, "*", 1, bResult);
		}
	}
		HpfInst.EndWaitCursor();
		if ( bResult.value)
		{
			mutexExitStart = false;
			location="driverCopy.html";
		}
		else
		{
			//Setup for Port Chooser screens
			HpfInst.SetProcessString( "PortArray", PortArray.value);
			mutexExitStart = false;
			location="portDialog.html";
		}
	}

	mutexExitStart = false;
}


function cancelConfirmed(){
        DisableBackground();
	HpfInst.InstRestoreSourcePath();

	var inString = "$CloseApp$"; 
	var returnValue = new Object();
	var outString = new Object();

	UtilBroker.HPExpandString(inString,outString,returnValue);
}

function determineTotalSteps()
{
	var strCheckConnect = new String();
	HpfInst.GetProcessString( "master.hpi", "io_connect", strCheckConnect);

	var strProductCheck = new String(); 
	HpfInst.GetProcessString(HPIFile, "product", strProductCheck);

	var strInstallToFile = new String();
	HpfInst.GetProcessString( "master.hpi", "bluetooth_install_to_file", strInstallToFile);

	var strLang = new String();
	HpfInst.GetProcessString( "master.hpi", "lang", strLang);
	
	if (strProductCheck.value.toLowerCase() == "995c")
	{
		if (strCheckConnect.value.toLowerCase() == "bluetooth")
		{
			if (strInstallToFile.value.toLowerCase() == "true")
			{
				return "5";
			}
			else
			{	
				if (strLang.value.toLowerCase() == "jpn")
				{
					return "6";
				}
				else
				{
					return "7";
				}
			}
		}
		else 
		{
	 		if (strLang.value.toLowerCase() == "jpn")
			{
				return "7";
			}
			else
			{
				return "8";
			}
		}
	}
	else
	{
		if (strLang.value.toLowerCase() == "jpn")
		{
			return "6";
		}
		else
		{
			return "7";
		}
	}
}

function whyNoBth()
{
	location = "noBluetoothSupport.html";     
}

function LoadJumpURLFromVPM()
{
	// assume first parameter is the action and if 
	// there is a second parameter that it is the manufacturer
	var retVal=new Object();

	//get all of the URL params
	var actionStr=LoadJumpURL.arguments[0];
	var mfgStr=LoadJumpURL.arguments[1];
	var prodStr = new Object();
	var langStr = new Object();
    
	UtilBroker.HPGetMacro("PROD",prodStr, retVal);
	UtilBroker.HPGetMacro("LANG",langStr,retVal);

	LogMessage("Jumpstation: action=" + actionStr + " mfg=" + (mfgStr?mfgStr:"default"))

	if(JumpstationSupportsLang(actionStr,langStr))
	{
		var serverStr=new Object();
		UtilBroker.HPGetMacro("JUMPSERVER",serverStr,retVal);

		if(serverStr.value == "")
			serverStr.value="hpdjjs.com"

		//set manufacturer if none specified
		if(!mfgStr || mfgStr == "")
		{
			var mfgStrContainer=new Object();
			UtilBroker.HPGetMacro("MFG",mfgStrContainer,retVal);

			if(mfgStrContainer.value == "")
				mfgStr = "HP";
			else
				mfgStr = mfgStrContainer.value;
		}

		//create new URL
		var JumpStationURL="http://" + serverStr.value + "/jumpstation?action=" + actionStr + "&mfg=" + mfgStr + "&lang=" + langStr.value + "&product=" + prodStr.value;

		//convert white spaces to '+' to be valid in a URL and then load the URL
		var re=/\s+/;
		LoadOutsideURLFromVPM(JumpStationURL.replace(re,"+"));
	}
	else
		parent.location.href = "support_language_mismatch.html";
}


function LoadOutsideURLFromVPM()
{ 
	//first see if there is a default browser
	var retString=new Object();
	var retVal=new Object();
	var inString= "$DefaultBrowser$";
	
	UtilBroker.HPExpandString(inString,retString,retVal);

	if(retString != "")
	{
		//check to see if they are connected to the Internet
		inString="$InetConnectionStatus$";
		UtilBroker.HPExpandString(inString,retString,retVal);
		
		if(retString.value != "")
		{
			//launch browser with URL
			inString="$run," + LoadOutsideURL.arguments[0] + "$";
			UtilBroker.HPExpandString(inString,retString,retVal);
		}
		else
			parent.location.href = "nowebsupport.html";
	}
	else
	{
		// uh-oh do we have an html page in case they don't have a default broweser?
		parent.location.href = "nowebsupport.html";
	}     
}

