
//////////////////////////
//English Localized File//
//////////////////////////

//TRANSLATORS/LOCALIZERS:  please read the comments included in this file; although localization was definitely
//kept in mind when this project was created, there are still a couple of potential troublespots; these strings are
//denoted with "//please try to keep localized version short"; severe measures do not have to be taken to keep them
//short, but please keep space in mind for these strings 
//
//the text that needs to be translated is within single or double quotes; only this text should be changed and all quotes kept
//in each respective localized file; typically, this string comes after "var *** = "; do not translate anything between <>" or any "var *** =";
//if there is a question or unconsistency, then please contact the HP localization contact
//
//please respect the spaces in (and at the end of) strings
//
//all edits should be made in a text editor (wordpad, notepad, etc.) that does not insert formatting
//
//thanks!!!

//////////////
//doCalibration
var doCalibrationTitle = "calibrate print cartridges ";
var doCalibrationTextOne = "Complete the following calibration steps to ensure optimal print quality: ";
var doCalibrationTextTwo = "make sure white paper is in the tray ";
var doCalibrationTextThree = "click right arrow button to continue ";
var doCalibrationTextFour = 'Click "skip calibration" to do this task later in the hp printer assistant. ';
var noCalibrationLabel = "skip calibration ";

//////////////
//checkCalibration
var checkCalibrationTitle = "check confirmation page ";
var checkCalibrationTextOne = "Use the page that is printing to check the calibration. "
var checkCalibrationTextTwo = "If the lines in the cross and the square look straight, click the right arrow button to continue. "
var checkCalibrationTextThree = 'If not, click "calibrate again". ';
var reCalibrationLabel = "calibrate again ";


//////////////
//answerQuestions
var answerQuestionsTitle = "complete calibration ";
var answerQuestionsSubtitle = "Use printed calibration page. "
var answerQuestions1 = "1. Choose the letter closest to the lower line. ";
var answerQuestions2 = "2. Choose the letter closest to the red line. ";
var answerQuestions3 = "3. Choose the letter closest to the lower line. ";
var answerQuestions4 = "4. Choose the letter closest to the lower line. ";
var answerQuestions5 = "5. Choose the bar and arrow closest to the edge without going over. ";

/////////
//general
var replayLabel = "replay";
var exitTrouble = "exit troubleshooting";
var one = "1";
var two = "2";
var three = "3";
var four = "4";
var five = "5";
var six = "6";
var seven = "7";
var eight = "8";
var nine = "9";

//////////
//whatToDo
var wantHelp = "do you want help? ";
var yesOrNo = "Choose yes or no. ";
var yes = "yes ";
var recommendation = " (recommended) ";
var yesExplanation = "Help me set up my printer and install my printer software. ";
var no= "no ";
var noExplanation = "My printer is already set up and connected. Install my printer software now. "; 

////////////
//driverCopy
var pleaseWait = "please wait... ";
var waitStatementOne = "Files are copying onto your system.  ";
var waitStatementThree = "This may take a few minutes and multiple messages may appear. Do <b>not</b> click cancel on any screen. ";//do NOT translate anything within <>
var waitStatementTwo = "Printer set up will continue when file copying is complete. ";

///////////
//usbDialog
var usbTitle = "you have selected USB ";
var usbText = "To continue installing using USB, you must connect your printer to your computer with a USB cable. ";
var chooseText = "choose parallel instead ";
var usbOnlyText = "To continue installing, you must connect your printer to your computer with a USB cable. ";//keep as short as possible
var usbVerify = "Verify the following: ";
var usbVerifyOne = "your computer has a USB port ";
var usbVerifyTwo = "the USB cable is securely connected to the computer and printer ";//keep as short as possible
var usbRetry = "If the printer is properly connected and installation will not continue, try reconnecting the USB cable to the computer. ";//keep as short as possible
var usbHelp = "need more help? ";

///////////
//usbHelp
var usbHelpTitle = "more help ";
var usbHelpText = "If the printer is properly connected and installation will still not continue, contact your computer's manufacturer for information on configuring the computer's BIOS for USB. ";

///////////
//bluetoothDialog
var bluetoothDialogTitle = "verify Bluetooth connection ";
var bluetoothDialogText = "To continue, the printer must be turned on and placed within 10 meters of your computer. ";
var bluetoothOptions = 'If installation still will not continue, press and hold the power button for three seconds. If the blue light does not flash, click "go to web" for more information. ';
var chooseContinueText = "go to web ";

//////////////
//noBluetoothSupport
var noBluetoothTitle = "Bluetooth not available ";
var noBluetoothText = "A Bluetooth connection was not detected.  Do one of the following ";
var bluetoothOptionOne = "click the right arrow button to continue with the printer software installation "; 
var bluetoothOptionTwo = 'click "choose USB instead" to do a USB installation instead of Bluetooth '; //keep in single quotes
var chooseUSBText = "choose USB instead ";

///////////////////
//installToFileDialog
var installToFileTitle = "Bluetooth information ";
var installToFileTextOne = "The printer software has been successfully installed, however, a Bluetooth printer port could not be detected. Printing cannot occur until a Bluetooth port is configured. ";
var installToFileTextTwo = 'Click "go to web" for Bluetooth port configuration instructions.';
var chooseGoToWeb = "go to web ";
var chooseUsbInstead = "choose USB instead ";

////////////		
//portDialog
var portDialogTitle1 = "which port are you using? ";//please try to keep localized version short
var portDialogTitle2 = "is the printer connected? ";//please try to keep localized version short
var portTextOne = "The installer was unable to locate your printer. "; 
var portTextTwo = "Verify that the printer is connected to your computer. ";              
var portTextThree = 'Then click the "locate printer" button, or select from the available choices and click the right arrow button. '; //this string HAS to be left in SINGLE quotes	
var choiceText = "available choices ";//please try to keep localized version short
var locateText = "locate printer ";//please try to keep localized version short

////////////
//exitDialog
var exitTitle = "warning... ";
var cautionTitle = "caution... ";
var exitTextOne = "You are about to exit the install process and may not be able to use your printer. ";
var exitTextTwo = "Click the left arrow button to continue installing. ";
var exitTextThree = "You are about to exit without completing all recommended steps. ";
var exitTextFour = "Click the left arrow button to continue. ";

////////////////
//haveEverything
var everythingTitle = "do you have everything? ";
//yesOrNo from whatToDo			
var titleOne = "included in the box: ";//please try to keep localized version short
var titleTwo = "purchased separately: ";//please try to keep localized version short
var printerLabel = "printer ";
var powerLabel = "power cord ";
var cartridgeLabel = "print cartridges ";
var cartridgeSingleLabel = "print cartridge ";
var cableLabel = "printer cable ";
var usbCableLabel = "USB printer cable ";
var usbLabel = "USB ";
var computerLabel = "computer with Bluetooth support ";
var orLabel = "or ";
var parallelLabel = "parallel ";
var paperLabel = "white paper ";
// yes and no footer choices from whatToDo

////////////// 
//haveDuplexer
var duplexerTitle = "do you have an automatic two-sided printing module? ";
//chooseText from whatToDo			
var duplexerText = "The Automatic Two-Sided Printing Module is an optional accessory that enables the printer to automatically print on both sides of the page. ";
// yes and no footer choices from whatToDo	

////////////
//whichCable
var cableTitle = "which cable are you using? ";//please try to keep localized version short
var cableTitleTwo = "how are you connecting? ";//please try to keep localized version short
var parallelOrUsb = "Choose USB or parallel. ";
var bluetoothOrUsb = "Choose Bluetooth or USB. ";
var bluetoothLabel = "Bluetooth ";
//usbLabel from haveEverything
//parallelLabel from haveEverything
var helpLabel = "help me choose ";
var tellMeMoreLabel = "tell me more ";
				
////////////
//helpChoose
var chooseTitle = "help me choose ";
//tellMeMoreLabel from whichCable
var usbRequirement = "USB requires: ";
var usbOne = "an available USB port on the computer ";//please try to keep localized version short
var usbTwo = "Windows 98, 2000, Me or XP ";
var usbTwo2 = "Windows 98, 2000, or Me ";
var usbThree = "any USB cable ";
var parallelRequirement = "Parallel requires: ";
var parallelOne = "an available parallel port on the computer ";//please try to keep localized version short
var parallelTwo = "Windows 95, 98, 2000, Me, XP or NT 4.0 ";
var parallelThree = "an IEEE-1284 bi-directional parallel cable ";//please try to keep localized version short

////////////
//helpChoose2
//tellMeMoreLabel from whichCable
var tellMeBlueOne = "Bluetooth is a new wireless technology that allows you to print, without cables, from laptops, PDA's, cell phones and other Bluetooth devices up to 10 meters away. ";
var tellMeBlueOne2 = "Bluetooth is a new wireless technology that allows you to print, without cables, from laptops, PDA's, mobile phones and other Bluetooth devices up to 10 meters away. ";
var bluetoothRequirement = "Bluetooth requires: ";
var bluetoothOne = "laptop or PC with a built-in or accessory Bluetooth card ";
var bluetoothTwo = "Windows 2000 or XP ";
var bluetoothThree = "Windows 2000 ";

////////////
//whitePaper
var whyTitle = "why white paper? ";
var whyOne = "The printer will automatically calibrate and print a calibration page after the print cartridges are installed. ";
var whyTwo = "White paper must be loaded in order for the printer to do an accurate calibration. ";
			
////////////////
//attachDuplexer
var attachDuplexerTitle = "attach automatic two-sided printing module ";
var attachDuplexerOne = "<li value=1>Turn knob on printer's Rear Access Door counter-clockwise, then remove door. ";
var attachDuplexerTwo = "<li value=2>Firmly snap module into back of printer.  Make sure module's access door is closed. ";

//////////////
//connectCable
var usbTitle = "connect USB cable ";
var parallelTitle = "connect parallel cable ";
var connectCableOne = "<li value=1>Plug printer cable into printer, and snap both clips into notches on connector. ";
var connectCableTwo = "<li value=2>Plug printer cable into computer, and tighten screws on connector. ";
var connectCableThree = "<li value=1>Plug printer cable firmly into printer until it stops.";
var connectCableFour = "<li value=2>Plug printer cable into computer. ";
var connectCableWarning = "(<b>NOTE: </b> HP recommends that you use an IEEE-1284 compliant cable.) ";//do NOT translate anything within <>
	
///////////			
//powerCord
var powerTitle = "plug in power cord ";
var powerBluetoothOne = "<li value=1>Place printer within 10 meters of computer. ";
var powerBluetoothTwo = "<li value=2>Plug power cord into printer. ";
var powerBluetoothThree = "<li value=3>Plug power cord into an electrical outlet. ";
var powerBluetoothFour ="<li value=4>Turn on printer. ";
var powerCordOne = "<li value=1>Plug power cord into printer. ";
var powerCordTwo = "<li value=2>Plug power cord into an electrical outlet. ";
var powerCordThree ="<li value=3>Turn on printer. ";
			
///////////
//loadPaper		
var paperTitle = "load white paper ";
var loadPaperOne = "<li value=1>Pull out paper tray. ";
var loadPaperTwo = "<li value=2>Place white paper into paper tray and push paper forward until it stops. ";
var loadPaperThree = "<li value=3>Push in paper tray. ";
var whyLabel = "why white paper? ";
var loadPaperOneF = "<li value=1>Lower the paper tray and press down until it snaps into place. ";
var loadPaperTwoF = "<li value=2>Pull out paper tray. ";
var loadPaperThreeF ="<li value=3>Place white paper into paper tray and push paper forward until it stops. ";
var loadPaperFourF= "<li value=4>Push paper guide forward to the edge of the paper. ";
var loadPaperOneFBolt = "<li value=1>Lower the paper tray. ";
				
///////////////////
//prepareCartridges
var prepareTitle = "prepare print cartridges ";
var prepareCartridgesOne = "<li value=1>Remove print cartridges from packaging. ";
var prepareCartridgesTwo = "<li value=2>Carefully remove vinyl tape from both print cartridges. ";
var prepareWarning = "(<b>NOTE: </b> Do <b>not</b> touch or remove copper strip on print cartridges.) ";//do NOT translate anything within <>
var prepareTitle1 = "prepare print cartridge ";
var prepareCartridgesOne1 = "<li value=1>Remove print cartridge from packaging. ";
var prepareCartridgesTwo1 = "<li value=2>Carefully remove vinyl tape from print cartridge. ";
var prepareWarning1 = "(<b>NOTE: </b> Do <b>not</b> touch or remove copper strip on print cartridge.) ";//do NOT translate anything within <>
var preparePurchaseBlackPen = "For crisp black text, you can purchase the optional <b>" + penBlackNum() + "</b> Black print cartridge. ";//do NOT translate anything within <> and only inbetween quotes
var preparePurchaseColorPen = "For color printing, you can purchase the optional <b>" + penColorNum() + "</b> Color print cartridge. ";//do NOT translate anything within <> and only inbetween quotes

///////////////////
//installCartridges
var installTitle = "install print cartridges ";
var installCartridgesOne = "<li value=1>Open top cover. ";
var installCartridgesTwo = "<li value=2>Lift cradle latches, then insert print cartridges. ";
var installCartridgesThree = "<li value=3>Firmly press down cradle latches until they snap into place. ";
var installCartridgesFour = "<li value=4>Close top cover. ";
var installWarning = "(<b>NOTE: </b> Printer will print a calibration page.) ";//do NOT translate anything within <>
var installWarning2 = "(<b>NOTE: </b> Printer will automatically generate and print a calibration page.) ";//do NOT translate anything within <>
var installTitle1 = "install print cartridge ";
var installCartridgesTwoR1 = "<li value=2>Lift right cradle latch, then insert print cartridge. ";
var installCartridgesThreeR1 = "<li value=3>Firmly press down right cradle latch until it snaps into place. ";
var installCartridgesTwoL1 = "<li value=2>Lift left cradle latch, then insert print cartridge. ";
var installCartridgesThreeL1 = "<li value=3>Firmly press down left cradle latch until it snaps into place. ";
var installCartridgesTwoOld = "<li value=2>Insert print cartridges. ";
var installCartridgesThreeOld = "<li value=3>Press cartridges down and forward until they snap into place. ";

/////////////
//calibration
var calibrationTitle = "confirm calibration page ";
var calibrationText = "Did a calibration page print? ";
// yes and no footer choices from whatToDo	
				
/////////////
//printSample
var printTitle = "print a sample page ";
var printSampleOne = "You have successfully installed your printer. ";
var printSampleTwo = "Print a photo sample to see how your HP printer can create the look and feel of professional printing. ";
var printSampleThree = "You can print this sample on plain paper or on the paper that came with your printer. ";
var printLabel = "print a sample page ";
var printSampleUsb = "You have successfully installed your USB printer. ";
var printSampleBluetooth = "You have successfully installed your Bluetooth printer. ";
				
///////////////
//confirmSample
var confirmTitle = "confirm print sample ";
var confirmText = "Is a sample page printing? ";
// yes and no footer choices from whatToDo
var againLabel = "try to print a sample again "

////////
//doEreg
var eregTitle = "register printer ";
var doEregOne = "Registration is fast and easy, and will give you these exclusive benefits: ";
var doEregTwo = "Your information will be kept strictly confidential. ";
var doEregSubOne = "Faster expert technical support ";
var doEregSubTwo = "Early notice of product and software upgrades ";
var doEregSubThree = "Online tips and tricks ";
var registerLabel = "register my printer ";
var privacyLabel = "read privacy statement ";

/////////////
//eregPrivacy
var privacyTitle = "hp privacy statement ";

/////////////
//installComp
var installCompTitle = "what's next... ";
var installCompOne = "We've included the hp printer assistant to help you with easy access to printer information, online ordering, hp support and printer problem solutions. ";
var installCompTwo = "You can get to the hp printer assistant any time by double-clicking the icon that is now on your computer desktop. ";
var assistantLabel = prodNum() + // do NOT translate this function name (prodNum())
		     "c printer assistant";
		
//////////////////
//troubleshootSoft
var troubleTitle = "verify the following... ";
var troubleSubTitle = "Click any button for help. ";
var troubleConnection = "Bluetooth light is on OR USB cable is properly connected. ";//please try to keep localized version short
var troubleBluetooth = "Bluetooth light is on. ";
var troubleConnection2 = "Bluetooth connection is established OR USB cable is properly connected. ";//please try to keep localized version short
var troubleBluetooth2 = "Bluetooth connection is established. ";
var troubleCable = "Cable is properly connected to printer and computer. ";//please try to keep localized version short
var troublePower = "Printer is plugged in and turned on. ";
var troublePaper = "Paper is loaded and paper tray is pushed in all the way. ";//please try to keep localized version short
var troubleTape = "Tape has been removed from the print cartridges. ";//please try to keep localized version short
var troubleCartridges = "Print cartridges are installed correctly. ";
var troubleInstall = "...and click the right arrow button to install ";	
var troubleContinue = "...and click the right arrow button when you are finished ";
var troubleSingleTape = "Tape has been removed from the print cartridge. ";//please try to keep localized version short			
var troubleTray = "Paper tray is completely lowered and paper is loaded. ";//please try to keep localized version short
var troubleCartridge = "Print cartridge is installed correctly. ";
var troubleDuplexer = "Automatic two-sided printing module is attached. ";
var troubleDuplexer2 = "Two-sided printing module is attached. ";


///////////////			
//notEverything
var notEverythingTitle = "something is missing... ";
var notEverythingOne = "HP recommends that you do not continue. ";
var notEverythingTwo = "If the missing item(s) should have been included in the box, call HP support. See quick reference guide for phone numbers. ";//please try to keep localized version short
var notEverythingThree = "Otherwise, purchase the missing item(s) before continuing. ";
var notEverythingFour = "Click the left arrow button to continue installing. ";

//////////////////
//noUsbSupport
var noUsbSupportTitle = "printer not supported ";
var noUsbSupportOne = "This printer requires a USB connection that is not supported by Windows 95 or NT. ";
var noUsbSupportTwo = "Do one of the following: ";
var noUsbSupportThree = "upgrade your operating system to Windows 98, 2000, Me, or XP ";
var noUsbSupportFour = "exchange this printer for an HP printer that uses a parallel (IEEE-1284) connection ";

//////////////////
//noJeeniSupport
var noJeeniSupportTitle = "printer not supported ";
var noJeeniSupportOne = "This printer is not supported by Windows 95 or NT. ";
var noJeeniSupportTwo = "Do one of the following: "; 
var noJeeniSupportThree = "upgrade your operating system to Windows 98, ME or 2000 (Bluetooth printing is only supported in Windows 2000) ";
var noJeeniSupportFour = "exchange this printer for an HP printer that is supported by Windows 95 or NT ";
var noJeeniSupportThreeXP = "upgrade your operating system to Windows 98, ME, 2000 or XP (Bluetooth printing is only supported in Windows 2000 and XP) ";

//////////////////
//noBluetoothSupport
var noBluetoothSupportTitle = "why not Bluetooth? ";
var noBluetoothSupportOne = "This printer cannot use Bluetooth with Windows 98 or Me. ";
var noBluetoothSupportTwo = "Do one of the following: ";
var noBluetoothSupportThree = "upgrade your operating system to Windows 2000 ";
var noBluetoothSupportFour = "continue this installation with a USB connection ";
var noBluetoothSupportThreeXP = "upgrade your operating system to Windows 2000 or XP ";	

//////////////////
//noWebSupport
var noWebSupportTitle = "internet access required ";
var noWebSupportOne = "Internet access is required to configure this printer for a Bluetooth connection. ";
var noWebSupportTwo = "Do one of the following: ";
var noWebSupportThree = "obtain internet access to continue with Bluetooth configuration (this can be done anytime from any computer at " + BthUrl() + ") ";
var noWebSupportFour = "repeat this installation with a USB connection ";

/////////////////
//additional
var loadPaperOne2 = "<li value=1>Remove tape from printer. ";
var loadPaperTwo2 = "<li value=2>Pull out paper tray. ";
var loadPaperThree2 = "<li value=3>Place white paper into paper tray and push paper forward until it stops. ";
var loadPaperFour2 = "<li value=4>Push in paper tray. ";
var installQuestion = "how do you want to install? ";
var installChoose = "choose one ";
var installAssisted = "Show me how to set up my printer, then install printer software. ";
var installUnassisted = "My printer is already set up. Install printer software now. "; 

//////////////////
//whatNext
var whatNextTitle = "installation complete ";
var whatNextSubtitle = "What's next? "
var whatExitLabel = "exit now ";
var printerAssistantText = "The hp printer assistant provides access to free online manuals, printing ideas and more. ";
var eregText = "The hp quick registration provides software upgrade notification and fast access to phone support. ";
var ispText = "Learn about great offers for dial-up, DSL, cable internet services and more. ";
var printerAssistantLabel = "printer assistant ";
var eregLabel = "register ";
var ispLabel = "preview offers "; 	

////////////////////////////////////////////////////////////////////////////////
//  function for progressive steps
////////////////////////////////////////////////////////////////////////////////
//NOTE:step and totalSteps (those not in "") are variables; this returns a count of how many steps the user
//    has completed toward installation completion; the order may have to change depending upon the country;
//	but do NOT translate these variables; keep spaces around translated words;
//	please try to keep this translation short in length, not much room for growth

function stepProgress(step){
	return "step " 
	       + step + 
	       " of " 
	       + determineTotalSteps();
}

////////////////////////////////////////////////////////////////////////////////
//  function for stepCount
////////////////////////////////////////////////////////////////////////////////
//NOTE:step(in "") is a variable; this returns a count of how many steps the user
//    has completed toward installation completion; the order may have to change depending upon the country;
//	but do NOT translate these variables; keep spaces around translated words;
//	please try to keep this translation short in length, not much room for growth

function stepCount(step){
	return "step " 
	       + step; 
}
var UtilBroker = Components.classes["component://netscape/utilitybroker"].createInstance();
UtilBroker = UtilBroker.QueryInterface(Components.interfaces.hpIUtilityBroker);

var HpfInst = Components.classes["@dugout/infield/instservice;1"].getService(Components.interfaces.IInstService);


// FYI --  
// will allow us to change the animation from Flash to Shock or whatever; if 
// different countries want different animation types, then it can be pulled into a localized file
function animationType()
{
  return 'TYPE="application/x-shockwave-flash" PLUGINSPAGE="http://www.macromedia.com/shockwave/download/index.cgi?P1_Prod_Version=ShockwaveFlash"';
}

function prodNum()
{
    var outString = new Object();
	UtilBroker.HPGetMacro("PROD",outString);
	
	s = new String(outString.value);
	return s.substring(0,3);
}

//function getAnimationType()
//{
//	var strProduct = new String(); //to support products with USBonly; may change to prod number
//	HpfInst.GetProcessString(HPIFile, "product", strProduct);

//	if (strProduct.value.toLowerCase() == "990c")
//	{
//		return "swf";
//	}
//	else
//	{
//		return "gif";
//	}
//}


function penBlackNum()
{
	return "15";
}
function penColorNum()
{
	return "23";
}

////////////////////////////////////////////////////////////////////
// Function names correspond to respective html file with few
// exceptions 

function whatToDo(part){
	switch(part){
		case "title":
			document.write(wantHelp);
			break;
		case "subtitle":
			document.write(yesOrNo);
			break;
		case "tutorial":
			document.write(yes + recommendation);
			break;
		case "tutorialText":
			document.write(yesExplanation);
			break;
		case "software":
			document.write(no);
			break;
		case "softwareText":
			document.write(noExplanation);
			break;
		case "tutorialBtn":
			document.write('<div id="tutorialButton">');
			document.write('<a class="link" onClick="tutorial();" onMouseOver="SwapImageEx(this,0,\'images/largeBtn2.gif\')" onMouseOut="SwapImageEx(this)">');
			document.write('<img name="tutorialBtn" src="images/largeBtn1.gif" border="0"></a>');
			document.write('</div>');
			break;
		case "softwareBtn":
			document.write('<div id="softwareButton">');
			document.write('<a class="link" onClick="softwareOnly();" onMouseOver="SwapImageEx(this,0,\'images/largeBtn2.gif\')" onMouseOut="SwapImageEx(this)">');
			document.write('<img name="softwareBtn" src="images/largeBtn1.gif" border="0"></a>');
			document.write('</div>');
			break;
		case "nextBtn":
			break;
		case "backBtn":
			break;
		case "exitBtn":
			break;
	}
}

function driverCopy(part){

	switch(part) {
		case "title":
			document.write("<blink>" + pleaseWait + "</blink>");
			break;
		//Note: make conditional for parallel vs USB	
		case "text":
			document.write(waitStatementOne + waitStatementThree + "<br><br>" + waitStatementTwo);
			break;	
		case "nextBtn":
			break;
		case "backBtn":
			break;	
	}
}

function usbDialog(part){

	var strProduct = new String(); //to support products with USBonly; may change to prod number
	HpfInst.GetProcessString(HPIFile, "product", strProduct);
	switch(part) {
		case "title":
			document.write(usbTitle);
			break;	
		case "text":
			if ((strProduct.value.toLowerCase() == "825c") || (strProduct.value.toLowerCase() == "845c") || (strProduct.value.toLowerCase() == "656c"))
			{
			 	document.write(usbOnlyText);
				document.write(usbVerify);
				document.write('<br>');
				document.write("<ul><li>" + usbVerifyOne);
				document.write('<br>');
				document.write("<li>" + usbVerifyTwo + "</ul>");
				document.write('<p>');
			}
			else
			{
				document.write(usbText);
				document.write('<p>');
			}
			document.write(usbRetry);
			break;
		case "chooseLabel":
			if (strProduct.value.toLowerCase() == "995c")
			{
			}
			else 	if ((strProduct.value.toLowerCase() == "825c") || (strProduct.value.toLowerCase() == "845c") || (strProduct.value.toLowerCase() == "656c"))
			{
				document.write(usbHelp);
			}
			else
			{
				document.write(chooseText);
			}
			break;
		case "chooseBtn":
			if (strProduct.value.toLowerCase() == "995c")
			{
			}
			else
			{
				document.write('<div id="chooseButton">');
				document.write('<a class="link" onClick="toSelectScreen();" onMouseOver="SwapImageEx(this,0,\'images/smallBtn2.gif\')" onMouseOut="SwapImageEx(this)">');
				document.write('<img name="chooseBtn" src="images/smallBtn1.gif" border="0"></a>');
				document.write('</div>');
			}
			break;
		case "nextBtn":
			writeDiaNext('invisible','','White');
			break;
		case "backBtn":
			writeDiaBack('active','usbDialogBack()','Blue','one');
			break;	
	}
}


function bluetoothDialog(part){

	var strProduct = new String(); //to support products with USBonly; may change to prod number
	HpfInst.GetProcessString(HPIFile, "product", strProduct);

	switch(part) {
		case "title":
			document.write(bluetoothDialogTitle);
			break;	
		case "text":
			document.write(bluetoothDialogText);
			break;
		case "chooseLabel": 
			document.write(chooseContinueText);
			break;
		case "chooseBtn":
			document.write('<div id="chooseButton">');
			document.write('<a class="link" onClick="LoadJumpURLFromVPM(\'techsupport\',\'Bluetooth-Install\');cancelConfirmed();"; onMouseOver="SwapImageEx(this,0,\'images/smallBtn2.gif\')" onMouseOut="SwapImageEx(this)">');
			document.write('<img name="chooseBtn" src="images/smallBtn1.gif" border="0"></a>');
			document.write('</div>');
			break;
		case "nextBtn":
			writeDiaNext('invisible','','White');
			break;
		case "backBtn":
			writeDiaBack('active','bluetoothDialogBack()','Blue','one');
			break;	
	}
}

function portDialog(part){

	var strIsAssist = new String();
	HpfInst.GetProcessString( "master.hpi", "assist_install", strIsAssist);
	var strIsRetry = new String();
	HpfInst.GetProcessString( "master.hpi", "locate_retry", strIsRetry);

	switch(part) {
		case "title":
			if (strIsAssist.value.toLowerCase() == "true")
			{
				document.write(portDialogTitle1);
			}
			else {document.write(portDialogTitle2);}
			break;	
		case "text":
			document.write(portTextOne); 
                  document.write(portTextTwo);              
                  document.write(portTextThree);			
                  break;	
		case "portTitle":
          		document.write(choiceText);
                  break;
		case "locate":
			document.write(locateText);
			break;
		case "nextBtn":
			writeDiaNext('active','portDialogNext()','White');
			break;
		case "backBtn":
			if ((strIsAssist.value.toLowerCase() == "true") && (strIsRetry.value.toLowerCase() == "false"))
			{
				writeDiaBack('active','portDialogBack()','Blue','two');	
			}
			else
			{
				writeDiaBack('invisible','','Blue','one');
			}
			break;	
	}
}

function installToFile(part){

	var strIsAssist = new String();
	HpfInst.GetProcessString( "master.hpi", "assist_install", strIsAssist);
	
	var strOS = new String();
	HpfInst.GetProcessString( "master.hpi", "os", strOS);

	switch(part) {
		case "title":
			document.write(installToFileTitle);
			break;	
		case "text":
			document.write(installToFileTextOne);
			document.write('<p>'); 
                  document.write(installToFileTextTwo);              	
                  break;
		case "chooseLabel": 
			document.write(chooseGoToWeb);
			break;
		case "chooseUsbLabel":
			break;
		case "chooseBtn":
			document.write('<div id="chooseButton">');
			document.write('<a class="link" onClick="LoadJumpURL(\'techsupport\',\'Bluetooth-Install\');cancelConfirmed();"; onMouseOver="SwapImageEx(this,0,\'images/smallBtn2.gif\')" onMouseOut="SwapimageEx(this)">');
			document.write('<img name="chooseBtn" src="images/smallBtn1.gif" border="0"></a>');
			document.write('</div>');
			break;
		case "chooseUsbBtn":
			break;
		case "nextBtn":
			writeExitNext('active','exitDialogNext()','Blue');
			break;
		case "backBtn":
			if (strIsAssist.value.toLowerCase() == "true")
			{
				writeDiaBack('active','installToFileBack()','Blue','two');
			}
			break;
	}
}


//for exitDialog and exitDialog2
function exitDialog(part){

	switch(part) {
		case "title":
			document.write(exitTitle);
			break;
		case "title2":
			document.write(cautionTitle);
			break;
		case "text":
			document.write(exitTextOne);
			document.write('<p>');
			document.write(exitTextTwo);
			break;
		case "text2":
			document.write(exitTextThree);
			document.write('<p>');
			document.write(exitTextFour);
			break;
		case "nextBtn":
			writeExitNext('active','exitDialogNext()','Blue');
			break;
		case "backBtn":
			writeDiaBack('active','exitDialogBack()','White','two');
			break;	
	}
}

//for noUsbSupport
function noUsbSupport(part){

	switch(part) {
		case "title":
			document.write(noUsbSupportTitle);
			break;
		case "text":
			document.write(noUsbSupportOne);
			document.write(noUsbSupportTwo);
			document.write("<ul><li>" + noUsbSupportThree);
			document.write('<br>');
			document.write("<li>" + noUsbSupportFour + "</ul>");
			break;
		case "nextBtn":
			writeExitNext('active','exitDialogNext()','Blue');
			break;
		case "backBtn":
			writeDiaBack('invisible','exitDialogBack()','White','one');
			break;	
	}
}

//for noJeeniSupport
function noJeeniSupport(part){

	switch(part) {
		case "title":
			document.write(noJeeniSupportTitle);
			break;
		case "text":
			document.write(noJeeniSupportOne);
			document.write(noJeeniSupportTwo);
			document.write("<ul><li>" + noJeeniSupportThree);
			document.write('<br>');
			document.write("<li>" + noJeeniSupportFour + "</ul>");
			break;
		case "nextBtn":
			writeExitNext('active','exitDialogNext()','Blue');
			break;
		case "backBtn":
			writeDiaBack('invisible','exitDialogBack()','White','one');
			break;	
	}
}

//for noBluetoothSupport
function noBluetoothSupport(part){

	switch(part) {
		case "title":
			document.write(noBluetoothSupportTitle);
			break;
		case "text":
			document.write(noBluetoothSupportOne);
			document.write(noBluetoothSupportTwo);
			document.write("<ul><li>" + noBluetoothSupportThree);
			document.write('<br>');
			document.write("<li>" + noBluetoothSupportFour + "</ul>");
			break;
		case "nextBtn":
			writeDiaNext('invisible','','Blue');
			break;
		case "backBtn":
			writeDiaBack('active','noBluetoothSupportBack()','White','one');
			break;
	}
}

//for noWebSupport
function noWebSupport(part){

	switch(part) {
		case "title":
			document.write(noWebSupportTitle);
			break;
		case "text":
			document.write(noWebSupportOne);
			document.write(noWebSupportTwo);
			document.write("<ul><li>" + noWebSupportThree);
			document.write('<br>');
			document.write("<li>" + noWebSupportFour + "</ul>");
			break;
		case "nextBtn":
			writeExitNext('active','exitDialogNext()','Blue');
			break;
		case "backBtn":
			writeDiaBack('invisible','exitDialogBack()','White','one');
			break;	
	}
}


function haveEverything(part)
{
	var strProduct = new String(); //to support products with Bluetooth, USB only and one-pen; may change to prod number
	HpfInst.GetProcessString(HPIFile, "product", strProduct);

	var strOS = new String(); //to eliminate USB as an option for NT and 95
	HpfInst.GetProcessString(HPIFile, "os", strOS);

	var strConnect = new String();
	HpfInst.GetProcessString( "master.hpi", "io_connect", strConnect);

	var strLang = new String();
	HpfInst.GetProcessString( "master.hpi", "lang", strLang);

	switch(part) {
		case "leftIdeaImage":
			if (strLang.value.toLowerCase() != "jpn")
			{
				document.write('<img src="images/inventoryIdeaUnit1.gif">');
			}
			break;
		case "rightIdeaImage":
			if (strLang.value.toLowerCase() != "jpn")
			{
				document.write('<img src="images/inventoryIdeaUnit1.gif">');
			}
			break;
		case "leftIdeaImageJpn":
			if (strLang.value.toLowerCase() == "jpn")
			{
				document.write('<img src="images/inventoryIdeaUnit1.gif">');
			}
			break;
		case "rightIdeaImageJpn":
			if (strLang.value.toLowerCase() == "jpn")
			{
				document.write('<img src="images/inventoryIdeaUnit1.gif">');
			}
			break;
		case "title":
			document.write(everythingTitle);
			break;
		case "subtitle":
			document.write(yesOrNo);
			break;
		case "leftTitle":
			if (((strProduct.value.toLowerCase() == "995c") && (strConnect.value.toLowerCase() == "usb")) || (strLang.value.toLowerCase() == "jpn"))
			{
			}
			else
			{
				document.write(titleOne);
			}
			break;
		case "rightTitle":
			if (((strProduct.value.toLowerCase() == "995c") && (strConnect.value.toLowerCase() == "usb")) || (strLang.value.toLowerCase() == "jpn"))
			{
			}
			else
			{
				document.write(titleTwo);
			}		
			break;
		case "leftSubTitle":
			if ((strProduct.value.toLowerCase() == "995c") && (strConnect.value.toLowerCase() == "usb"))
			{
				document.write('<font color=white>' + titleOne + '</font>');
			}
			break;
		case "rightSubTitle":
			if ((strProduct.value.toLowerCase() == "995c") && (strConnect.value.toLowerCase() == "usb"))
			{
				document.write('<font color=white>' + titleOne + '</font>');
			}
			break;
		case "line1Image":
			if (((strProduct.value.toLowerCase() == "995c") && (strConnect.value.toLowerCase() == "usb")) || (strLang.value.toLowerCase() == "jpn"))
			{
			}
			else
			{
				document.write('<img class="blueLine1" src="images/blueDividerLine.gif">');
			}
			break;
		case "line4Image":
			if (((strProduct.value.toLowerCase() == "995c") && (strConnect.value.toLowerCase() == "usb")) || (strLang.value.toLowerCase() == "jpn"))
			{
			}
			else
			{
				document.write('<img class="blueLine1" src="images/blueDividerLine.gif">');
			}
			break;
		case "line5Image":
			if ((strProduct.value.toLowerCase() == "995c") && (strConnect.value.toLowerCase() == "usb"))
			{
				document.write('<img class="blueLine1" src="images/blueDividerLine.gif">');
			}
			else
			{
				document.write('<img class="blueLine2" src="images/blueDividerLine2.gif">');
			}
			break;
		case "printerImage":
			document.write('<img src="images/inventoryPrinter.gif">');
			break;
		case "duplexerImage":
			if (strProduct.value.toLowerCase() == "995c")
			{ 
				document.write('<img src="images/inventoryDuplexer.gif">');
			}
			break;
		case "bluetoothImage":
			if ((strProduct.value.toLowerCase() == "995c") && (strConnect.value.toLowerCase() == "bluetooth"))
			{ 
				document.write('<img src="images/inventoryBluetooth.gif">');
			}
			break;
		case "parallelImage":
			if ((strProduct.value.toLowerCase() == "825c") || (strProduct.value.toLowerCase() == "845c") || (strProduct.value.toLowerCase() == "656c") || (strProduct.value.toLowerCase() == "995c")) 
				{;} //do nothing
			else
			{
				document.write('<img src="images/inventoryParallel.gif">');
			}
			break;
		case "USBImage":
			if ((strConnect.value.toLowerCase() == "bluetooth") || (strOS.value.toLowerCase() == "win95") || (strOS.value.toLowerCase() == "winnt4")) //no USB for these OSs
				{;} //do nothing
			else
			{
				document.write('<img src="images/inventoryUsbCable.gif">');
			}
			break;
		case "printer":
				document.write(printerLabel);
			break;
		case "power":
			document.write(powerLabel);
			break;
		case "cartridge":
			if (strProduct.value.toLowerCase() == "825c")
			{
				document.write(cartridgeSingleLabel);
			}
			else
			{
				document.write(cartridgeLabel);
			}
			break;
		case "choice":
			if (strConnect.value.toLowerCase() == "bluetooth") //Bluetooth
			{
				document.write(computerLabel);
			}
			else if ((strProduct.value.toLowerCase() == "995c") && (strConnect.value.toLowerCase() == "usb")) //Bluetooth
			{
				document.write(usbCableLabel);
			}
			else
			{
				document.write(cableLabel);
			}
			break;
		case "usb":
			if ((strProduct.value.toLowerCase() == "995c") || (strOS.value.toLowerCase() == "winnt4") || (strOS.value.toLowerCase() == "win95")) //no USB for these OSs
				{;}
			else
			{
				document.write(usbLabel);
			}
			break;
		case "or":
			if ((strProduct.value.toLowerCase() == "995c") || (strProduct.value.toLowerCase() == "825c") || (strProduct.value.toLowerCase() == "845c") || (strProduct.value.toLowerCase() == "656c") || (strOS.value.toLowerCase() == "winnt4") || (strOS.value.toLowerCase() == "win95"))
				{;} //do nothing
			else
			{
				document.write("<i>" + orLabel + "</i>");
			}
			break;
		case "parallel":
			if ((strProduct.value.toLowerCase() == "995c") || (strProduct.value.toLowerCase() == "825c") || (strProduct.value.toLowerCase() == "845c") || (strProduct.value.toLowerCase() == "656c")) //list USBonly products
				{;}
			else
			{
				document.write(parallelLabel); //do nothing
			}
			break;
		case "paper":
			if ((strProduct.value.toLowerCase() == "995c") && (strConnect.value.toLowerCase() == "usb"))
			{
				document.write('<font color=white>' + titleTwo + '</font>');
				document.write('<p>');
				document.write(paperLabel);
			}
			else
			{
				document.write(paperLabel);
			}
			break;
		case "notEverythingBtn":
			document.write('<div id="notEverythingButton">');
			document.write('<a class="link" onClick="everythingNo();" onMouseOver="SwapImageEx(this,0,\'images/medBtn2.gif\')" onMouseOut="SwapImageEx(this)">');
			document.write('<img name="notEverythingBtn" src="images/medBtn1.gif" border="0"></a>');
			document.write('</div>');
			break;
		case "yesEverythingBtn":
			document.write('<div id="yesEverythingButton">');
			document.write('<a class="link" onClick="everythingYes();" onMouseOver="SwapImageEx(this,0,\'images/medBtn2.gif\')" onMouseOut="SwapImageEx(this)">');
			document.write('<img name="yesEverythingBtn" src="images/medBtn1.gif" border="0"></a>');
			document.write('</div>');
			break;
		case "nextBtn":
			writeNext('invisible','','White');
			break;
		case "backBtn":
			writeBack('active','everythingBack()','Blue','one');
			break;
		case "exitBtn":
			writeExit('active','before');
			break;
		case "noFooter":
			document.write(no);
			break;
		case "yesFooter":
			document.write(yes);
			break;
	}
}


function haveDuplexer(part){

	switch(part) {
		case "title":
			document.write(duplexerTitle);
			break;
		case "subtitle":
			document.write(yesOrNo);
			break;
		case "instructions":
			document.write(duplexerText);
			break;
		case "nextBtn":
			writeNext('invisible','','White');
			break;
		case "backBtn":
			writeBack('active','everythingBack()','Blue','one');
			break;	
		case "exitBtn":
			writeExit('active','before');
			break;
		case "noFooter":
			document.write(no);
			break;
		case "yesFooter":
			document.write(yes);
			break;
	}
}


function whichCable(part)
{
		var strInTrouble = new String();
		HpfInst.GetProcessString( "master.hpi", "in_troubleshoot", strInTrouble);
		var strProduct = new String(); //to support those products with automatic calibration and/or one pen; may change to prod number (was not available at the time of creation)
		HpfInst.GetProcessString(HPIFile, "product", strProduct);
	
		switch(part) {
			case "title":
				if (strProduct.value.toLowerCase() == "995c") //Bluetooth
				{
					document.write(cableTitleTwo);
				}
				else
				{
					document.write(cableTitle);
				}
				break;
			case "subtitle":
				if (strProduct.value.toLowerCase() == "995c") //Bluetooth
				{
					document.write(bluetoothOrUsb);
				}
				else
				{
					document.write(parallelOrUsb);
				}
				break;
			case "usbLabel": //NOTE: case title misleading
				if (strProduct.value.toLowerCase() == "995c")
				{
					document.write(bluetoothLabel);
				}
				else
				{
					document.write(usbLabel);
				}
				break;
			case "parallelLabel": //NOTE: case title misleading
				if (strProduct.value.toLowerCase() == "995c")
				{
					document.write(usbLabel);
				}
				else
				{
					document.write(parallelLabel);
				}
				break;
			case "imageOne":
				if (strProduct.value.toLowerCase() == "995c")
				{
					document.write('<div id="usbIdeaUnit"><img src="images/installBTHIdeaUnit.gif" border="0"></div>');
				}
				else
				{
					document.write('<div id="usbIdeaUnit"><img src="images/installUSBIdeaUnit.gif" border="0"></div>');
				}
				break;
			case "imageTwo":
				if (strProduct.value.toLowerCase() == "995c")
				{
					document.write('<div id="parallelIdeaUnit"><img src="images/installUSBIdeaUnit.gif" border="0"></div>');
				}
				else
				{
					document.write('<div id="parallelIdeaUnit"><img src="images/installParallelIdeaUnit.gif" border="0"></div>');
				}
				break;
			case "help":
				if (strProduct.value.toLowerCase() != "995c")
				{
					document.write(helpLabel);
				}
				break;
			case "tellMeMore1":
				if (strProduct.value.toLowerCase() == "995c")
				{
					document.write(tellMeMoreLabel);
				}
				break;
			case "tellMeMore2":
				if (strProduct.value.toLowerCase() == "995c")
				{
					document.write(tellMeMoreLabel);
				}
				break;
			case "usbBtn":  //NOTE: case title misleading
				document.write('<div id="usbButton">');
				if (strProduct.value.toLowerCase() == "995c")
				{
					document.write('<a class="link" onClick="cableInstallBluetooth();" onMouseOver="SwapImageEx(this,0,\'images/medBtn2.gif\')" onMouseOut="SwapImageEx(this)">');
					document.write('<img name="paraBtn" src="images/medBtn1.gif" border="0"></a>');
				}
				else
				{
					document.write('<a class="link" onClick="cableInstallUSB();" onMouseOver="SwapImageEx(this,0,\'images/medBtn2.gif\')" onMouseOut="SwapImageEx(this)">');
					document.write('<img name="usbBtn" src="images/medBtn1.gif" border="0"></a>');
				}
				document.write('</div>');
				break;
			case "parallelBtn": //NOTE: case title misleading
				document.write('<div id="parallelButton">');
				if (strProduct.value.toLowerCase() == "995c")
				{
					document.write('<a class="link" onClick="cableInstallUSB();" onMouseOver="SwapImageEx(this,0,\'images/medBtn2.gif\')" onMouseOut="SwapImageEx(this)">');
					document.write('<img name="usbBtn" src="images/medBtn1.gif" border="0"></a>');
				}
				else
				{
					document.write('<a class="link" onClick="cableInstallParallel();" onMouseOver="SwapImageEx(this,0,\'images/medBtn2.gif\')" onMouseOut="SwapImageEx(this)">');
					document.write('<img name="paraBtn" src="images/medBtn1.gif" border="0"></a>');
				}
				document.write('</div>');
				break;
			case "helpBtn":
				if (strProduct.value.toLowerCase() != "995c") //Bluetooth
				{
					document.write('<div id="helpButton">');
					document.write('<a class="link" onClick="helpMe();" onMouseOver="SwapImageEx(this,0,\'images/medBtn2.gif\')" onMouseOut="SwapImageEx(this)">');
					document.write('<img name="helpBtn" src="images/medBtn1.gif" border="0"></a>');
					document.write('</div>');
				}
				break;
			case "tellMeMore1Btn":
				if (strProduct.value.toLowerCase() == "995c") //Bluetooth
				{
					document.write('<div id="tellMeButton1">');
					document.write('<a class="link" onClick="tellMeMore1();" onMouseOver="SwapImageEx(this,0,\'images/smallBtn2.gif\')" onMouseOut="SwapImageEx(this)">');
					document.write('<img name="tellMeMore1Btn" src="images/smallBtn1.gif" border="0"></a>');
					document.write('</div>');
				}
				break;
			case "tellMeMore2Btn":
				if (strProduct.value.toLowerCase() == "995c") //Bluetooth
				{
					document.write('<div id="tellMeButton2">');
					document.write('<a class="link" onClick="tellMeMore2();" onMouseOver="SwapImageEx(this,0,\'images/smallBtn2.gif\')" onMouseOut="SwapImageEx(this)">');
					document.write('<img name="tellMeMore2Btn" src="images/smallBtn1.gif" border="0"></a>');
					document.write('</div>');
				}
				break;
			case "nextBtn":
				writeNext('invisible','','White');
				break;
			case "backBtn":
				writeBack('active','whichCableBack()','Blue','one');
				break;
			case "exitBtn":
				if (strInTrouble.value.toLowerCase() == "false")
				{
					writeExit('active','before');
				}
				break;
		}
}

function helpChoose(part)
{

	var strProduct = new String(); //to support Bluetooth products
	HpfInst.GetProcessString(HPIFile, "product", strProduct);

	switch(part) 
	{
		case "title":
			if (strProduct.value.toLowerCase() == "995c") //Bluetooth products
			{
				document.write(tellMeMoreLabel);
			}
			else
			{
				document.write(chooseTitle);
			}
			break;
		case "text":
			if (strProduct.value.toLowerCase() == "995c") //Bluetooth products
			{
				document.write(usbRequirement);
				document.write("<ul><li>" + usbOne + "<br>");
				document.write("<li>" + usbTwo2 + "<br>");
				document.write("<li>" + usbThree + "</ul>");
			}
			else
			{
				document.write(usbRequirement);
				document.write("<ul><li>" + usbOne + "<br>");
				document.write("<li>" + usbTwo + "<br>");
				document.write("<li>" + usbThree + "</ul>");
				document.write(parallelRequirement);
				document.write("<ul><li>" + parallelOne + "<br>");
				document.write("<li>" + parallelTwo + "<br>");
				document.write("<li>" + parallelThree + "</ul>");
			}
			break;
		case "nextBtn":
			writeDiaNext('invisible','','Blue');
			break;
		case "backBtn":
			writeDiaBack('active','helpChooseBack()','White','one');
			break;	
	}
}



function helpChoose2(part)
{

	var strProduct = new String(); //to support Bluetooth products
	HpfInst.GetProcessString(HPIFile, "product", strProduct);

	switch(part) 
	{
		case "title":
			document.write(tellMeMoreLabel);
			break;
		case "text":
			document.write(tellMeBlueOne);
			document.write(bluetoothRequirement);
			document.write("<ul><li>" + bluetoothOne + "<br>");
			document.write("<li>" + bluetoothThree + "</ul>");
			break;
		case "nextBtn":
			writeDiaNext('invisible','','Blue');
			break;
		case "backBtn":
			writeDiaBack('active','helpChoose2Back()','White','one');
			break;	
	}
}



function bluetoothInformation(part)
{
	switch(part) 
	{
		case "title":
			document.write(bluetoothTitle);
			break;
		case "text":
			document.write(bluetoothText);
			break;
		case "nextBtn":
			writeDiaNext('invisible','','Blue');
			break;
		case "backBtn":
			writeDiaBack('active','bluetoothInformationBack()','White','one');
			break;	
	}
}


function privacyStatement(part){
	switch(part) {

		case "stepTitle":
			document.write(privacyTitle);
			break;
		case "backBtn": 
			writePrivacyBack('eregPrivacyBack()','White');
			break;	
	}
}


function whitePaper(part){
	switch(part) {
		case "title":
			document.write(whyTitle);
			break;
		case "text":
			document.write(whyOne);
			document.write(whyTwo);
			break;
		case "nextBtn":
			writeDiaNext('invisible','','Blue');
			break;
		case "backBtn":
			writeDiaBack('active','whitePaperBack()','White','one');
			break;	
	}
}
	
function exitLabel(){
	document.write('X');
}



function attachDuplexer(part){
		
		//NOTE: This will need tweaking if it is included (conditionals for its and its buttons appearance)
		var color = "blue01";
		var step = one; 

		var strIsAssist = new String();
		HpfInst.GetProcessString( "master.hpi", "assist_install", strIsAssist);

		var strInTrouble = new String();
		HpfInst.GetProcessString( "master.hpi", "in_troubleshoot", strInTrouble);

		switch(part) {
			case "stepNumber":
				if ((strIsAssist.value.toLowerCase() == "true") && (strInTrouble.value.toLowerCase() =="false")) 
				{
					document.write(step);
				}
				break;
			case "stepTitle": 
				document.write(attachDuplexerTitle);
				break;
			case "instructions":
                        document.write("<ol>" + attachDuplexerOne);
				document.write('<p>');
				document.write(attachDuplexerTwo + "</ol>");
				break;		
			case "animation":
				document.write('<img src="animation/duplexer.gif" width="256" height="292" name ="attachDuplexerAnimation">');
				document.write('</img>');
				break;
			case "dot":
                        document.write('<img src="images/' +  color + 'circle.gif">');
				break;
			case "count":
                        if ((strIsAssist.value.toLowerCase() == "true") && (strInTrouble.value.toLowerCase() =="false"))
				{
					document.write(stepProgress(step));
				}
				break;
			case "nextBtn":
				if (strInTrouble.value.toLowerCase() =="false")
				{
					writeNext('active','attachDuplexerNext()','White');
				}
				else
				{
					writeNext('invisible','','White');
				}
				break;
			case "backBtn":
				if (strInTrouble.value.toLowerCase() =="false")
				{
					writeBack('active','attachDuplexerBack()','Blue','two');
				}
				else
				{
					writeBack('active','attachDuplexerBack()','White','one');
				}
				break;	
			case "exitBtn":
				if (strInTrouble.value.toLowerCase() =="false") 
				{
					writeExit('active','before');
				}
				break;
		}
}
	

function connectCable(part){
		
		var color = "blue01";

		var strIsAssist = new String();
		HpfInst.GetProcessString( "master.hpi", "assist_install", strIsAssist);
	
		var strOS = new String(); 
		HpfInst.GetProcessString(HPIFile, "os", strOS);

		var strInTrouble = new String();
		HpfInst.GetProcessString( "master.hpi", "in_troubleshoot", strInTrouble);
		
		var strConnect = new String(); //to support those products with Bluetooth; may change to prod number (was not available at the time of creation)
		HpfInst.GetProcessString(HPIFile, "io_connect", strConnect);

		var strProduct = new String(); //to support products with USBonly; may change to prod number
		HpfInst.GetProcessString(HPIFile, "product", strProduct);

		if ((strProduct.value.toLowerCase() == "995c") && (strConnect.value.toLowerCase() == "usb"))
		{
			var step = two;
		}
		else
		{
			var step = one;
		}

		switch(part) {
			case "stepNumber":
				if ((strIsAssist.value.toLowerCase() == "true") && (strInTrouble.value.toLowerCase() =="false")) 
				{
				document.write(step);
				}
				break;
			case "usbStepTitle": 
				document.write(usbTitle);
				break;
			case "parallelStepTitle": 
				document.write(parallelTitle);
				break;
			case "whyNoBluetooth":
				if (strProduct.value.toLowerCase() == "995c") 
				{
					if ((strOS.value.toLowerCase() == "winme") || (strOS.value.toLowerCase() == "win98") || (strOS.value.toLowerCase() == "win98se"))
					{
						document.write(noBluetoothSupportTitle);
					}
				}
				break;
			case "usbInstructions":
		  		document.write("<ol>" + connectCableThree);
				document.write('<p>');
				document.write(connectCableFour + "</ol>");
				break;
			case "parallelInstructions":
		  		document.write("<ol>" + connectCableOne);
				document.write('<p>');
				document.write(connectCableTwo);
				document.write('<p>');
				document.write('<span class="warning">' + connectCableWarning + '</span></ol>');
				break;
			case "usbAnimation":
				document.write('<img src="animation/USBCord.gif" width="256" height="292" name="connectUsbAnimation">');
				document.write('</img>');
				break;
			case "parallelAnimation":
				document.write('<img src="animation/parallelCord.gif" width="256" height="292" name="connectParallelAnimation">');
				document.write('</img>');
				break;
			case "dot":
				document.write('<img src="images/' +  color + 'circle.gif">');
				break;
			case "count":
				if ((strIsAssist.value.toLowerCase() == "true") && (strInTrouble.value.toLowerCase() =="false")) 
				{
					document.write(stepProgress(step));
				}
				break;
			case "nextBtn":
                        if (strInTrouble.value.toLowerCase() =="false")
				{
					writeNext('active','connectUSBNext()','White');
				}
				else
				{
					writeNext('invisible','','White');
				}
				break;
			case "backBtn":
				if (strInTrouble.value.toLowerCase() =="false")
				{
					writeBack('active','connectUSBBack()','Blue','two');
				}
				else	//there will be no next button to have background for
				{
					writeBack('active','connectUSBBack()','White','one');
				}
				break;	
			case "noBluetoothBtn":
				if (strProduct.value.toLowerCase() == "995c") 
				{
					if((strOS.value.toLowerCase() == "winme") || (strOS.value.toLowerCase() == "win98") || (strOS.value.toLowerCase() == "win98se"))
					{
						document.write('<div id="noBth">');
						document.write('<a class="link" onClick="whyNoBth();" onMouseOver="SwapImageEx(this,0,\'images/medBtn2.gif\')" onMouseOut="SwapImageEx(this)">');
						document.write('<img name="noBthBtn" src="images/medBtn1.gif" border="0"></a>');
						document.write('</div>');
					}
				}
				break;
			case "nextBtnP":
				 if (strInTrouble.value.toLowerCase() =="false")
				{
					writeNext('active','connectParallelNext()','White');
				}
				else
				{
					writeNext('invisible','','White');
				}
				break;
			case "backBtnP":
				if (strInTrouble.value.toLowerCase() =="false")
				{
					writeBack('active','connectParallelBack()','Blue','two');
				}
				else	//there will be no next button to have background for
				{
					writeBack('active','connectParallelBack()','White','one');
				}
				break;
			case "exitBtn":
				if (strInTrouble.value.toLowerCase() =="false")
				{
				writeExit('active','before');
				}
				break;
		}
}

function powerCord(part){

		var color = "blue01";

		var strIsAssist = new String();
		HpfInst.GetProcessString( "master.hpi", "assist_install", strIsAssist);

		var strInTrouble = new String();
		HpfInst.GetProcessString( "master.hpi", "in_troubleshoot", strInTrouble);

		var strConnect = new String(); //to support those products with Bluetooth; may change to prod number (was not available at the time of creation)
		HpfInst.GetProcessString(HPIFile, "io_connect", strConnect);

		var strProduct = new String(); //to support products with USBonly; may change to prod number
		HpfInst.GetProcessString(HPIFile, "product", strProduct);

		if ((strProduct.value.toLowerCase() == "995c") && (strConnect.value.toLowerCase() == "usb"))
		{
			var step = three;
		}
		else
		{
			var step = two;
		}
		
		switch(part) {
			case "stepNumber":
				if ((strIsAssist.value.toLowerCase() == "true") && (strInTrouble.value.toLowerCase() =="false")) 
				{
				document.write(step);
				}
				break;
			case "stepTitle": 
				document.write(powerTitle);
				break;
			case "instructions":
				if (strConnect.value.toLowerCase() == "bluetooth")
				{
					document.write("<ol>" + powerBluetoothOne);
					document.write('<p>');
					document.write(powerBluetoothTwo);
					document.write('<p>');
					document.write(powerBluetoothThree);
					document.write('<p>');
					document.write(powerBluetoothFour + "</ol>");
				}
				else
				{ 	
		  			document.write("<ol>" + powerCordOne);
					document.write('<p>');
					document.write(powerCordTwo);
					document.write('<p>');
					document.write(powerCordThree + "</ol>");
				}
				break;
			case "animation":
				if (strConnect.value.toLowerCase() == "bluetooth")
				{
					document.write('<img src="animation/powerCord_bt.gif" width="256" height="292" name="powerCordAnimation">');
					document.write('</img>');
				}
				else
				{
					document.write('<img src="animation/powerCord.gif" width="256" height="292" name="powerCordAnimation">');
					document.write('</img>');
				}
				break;
			case "dot":
				document.write('<img src="images/' +  color + 'circle.gif">');
				break;
			case "count":
				if ((strIsAssist.value.toLowerCase() == "true") && (strInTrouble.value.toLowerCase() =="false")) 
				{
					document.write(stepProgress(step));
				}
				break;
			case "nextBtn":
				if (strInTrouble.value.toLowerCase() =="false")
				{
					writeNext('active','powerCordNext()','White');
				}
				else
				{
					writeNext('invisible','','White');
				}
				break;
			case "backBtn":
				if (strInTrouble.value.toLowerCase() =="false")
				{
					writeBack('active','powerCordBack()','Blue','two');
				}
				else
				{
					writeBack('active','powerCordBack()','White','one');
				}
				break;
			case "exitBtn":
				if (strInTrouble.value.toLowerCase() =="false")
				{
				writeExit('active','before');
				}
				break;
		}
}


function loadPaper(part){
		
		var color = "blue01";

		var strConnect = new String(); //to support those products with Bluetooth; may change to prod number (was not available at the time of creation)
		HpfInst.GetProcessString(HPIFile, "io_connect", strConnect);

		var strIsAssist = new String();
		HpfInst.GetProcessString( "master.hpi", "assist_install", strIsAssist);

		var strInTrouble = new String();
		HpfInst.GetProcessString( "master.hpi", "in_troubleshoot", strInTrouble);
		
		var strProduct = new String(); //to support those products with flip-up tray; may change to prod number (was not available at the time of creation)
		HpfInst.GetProcessString(HPIFile, "product", strProduct);

		if ((strProduct.value.toLowerCase() == "995c") && (strConnect.value.toLowerCase() == "usb"))
		{
			var step = four;
		}
		else
		{
			var step = three;
		}
	
		switch(part) {
			case "stepNumber":
				if ((strIsAssist.value.toLowerCase() == "true") && (strInTrouble.value.toLowerCase() =="false")) 
				{
				document.write(step);
				}
				break;
			case "stepTitle": 
				document.write(paperTitle);
				break;
			case "instructions":
				if ((strProduct.value.toLowerCase() == "948c")||(strProduct.value.toLowerCase() == "920c")||(strProduct.value.toLowerCase() == "656c")||(strProduct.value.toLowerCase() == "916c"))	
				{
					if (strProduct.value.toLowerCase() == "656c")
					{
						document.write("<ol>" + loadPaperOneFBolt);
					}
					else
					{
						document.write("<ol>" + loadPaperOneF);	
					}
					document.write('<p>');
					document.write(loadPaperTwoF);
					document.write('<p>');
					document.write(loadPaperThreeF);
					document.write('<p>');
					document.write(loadPaperFourF + "</ol>");
				}
				else
				{
					document.write("<ol>" + loadPaperOne);
					document.write('<p>');
					document.write(loadPaperTwo);
					document.write('<p>');
					document.write(loadPaperThree + "</ol>");	
				}
				break;
			case "why":
				if (strProduct.value.toLowerCase() == "995c")
				{
					document.write(whyLabel);
				}
				break;
			case "animation":
				document.write('<img src="animation/insertPaper.gif" width="256" height="292" name="loadPaperAnimation">');
				document.write('</img>');
				break;
			case "dot":
				document.write('<img src="images/' +  color + 'circle.gif">');
				break;
			case "count":
				if ((strIsAssist.value.toLowerCase() == "true") && (strInTrouble.value.toLowerCase() =="false")) 
				{
					document.write(stepProgress(step));
				}
				break;
			case "whyBtn":
				if (strProduct.value.toLowerCase() == "995c")
				{
					document.write('<div id="whyButton">');
					document.write('<a class="link" onClick="whyWhitePaper();" onMouseOver="SwapImageEx(this,0,\'images/medBtn2.gif\')" onMouseOut="SwapImageEx(this)">');
					document.write('<img name="whyBtn" src="images/medBtn1.gif" border="0"></a>');
					document.write('</div>');
				}
				break;
			case "nextBtn":
 				if (strInTrouble.value.toLowerCase() =="false")
				{
					writeNext('active','loadPaperNext()','White');
				}
				else
				{
					writeNext('invisible','','White');
				}
				break;
			case "backBtn": 
				if (strInTrouble.value.toLowerCase() =="false") //don't want users going back to install process
				{
					writeBack('invisible','','Blue','one');
				}
				else
				{
					writeBack('active','loadPaperBack()','White','one'); //want users to go back for troubleshooting

				}
				break;	
			case "exitBtn":
				if (strInTrouble.value.toLowerCase() =="false")
				{
				writeExit('active','before');
				}
				break;
		}
}



function prepareCartridges(part){
		
		var color = "blue01";

		var strIsAssist = new String();
		HpfInst.GetProcessString( "master.hpi", "assist_install", strIsAssist);

		var strInTrouble = new String();
		HpfInst.GetProcessString( "master.hpi", "in_troubleshoot", strInTrouble);

		var strProduct = new String(); //to support those products with one-pen; may change to prod number (was not available at the time of creation)
		HpfInst.GetProcessString(HPIFile, "product", strProduct);

		var strConnect = new String(); //to support those products with Bluetooth; may change to prod number (was not available at the time of creation)
		HpfInst.GetProcessString(HPIFile, "io_connect", strConnect);

		if ((strProduct.value.toLowerCase() == "995c") && (strConnect.value.toLowerCase() == "usb"))
		{
			var step = five;
		}
		else
		{
			var step = four;
		}


		var strProduct = new String(); //to support those products with one-pen; may change to prod number (was not available at the time of creation)
		HpfInst.GetProcessString(HPIFile, "product", strProduct);

		switch(part) {
			case "stepNumber":
				if ((strIsAssist.value.toLowerCase() == "true") && (strInTrouble.value.toLowerCase() =="false")) 
				{
				document.write(step);
				}
				break;
			case "stepTitle": 
				if (strProduct.value.toLowerCase() == "825c") //one-pen products listed here
				{
					document.write(prepareTitle1);
				}
				else
				{
					document.write(prepareTitle);
				}
				break;
			case "instructions":
				if (strProduct.value.toLowerCase() == "825c") //one-pen products listed here
				{
					document.write("<ol>" + prepareCartridgesOne1);
					document.write('<p>');
					document.write(prepareCartridgesTwo1);
					document.write('<p>');
					document.write('<span class="warning">' + prepareWarning1 + '</span>');
					document.write('<p>');
					document.write('<p>');
					document.write(preparePurchaseBlackPen + '</ol>');

				}
				else
				{
					document.write("<ol>" + prepareCartridgesOne);
					document.write('<p>');
					document.write(prepareCartridgesTwo);
					document.write('<p>');
					document.write('<span class="warning">' + prepareWarning + '</span></ol>');
				}
				break;
			case "animation":
				document.write('<img src="animation/prepInk.gif" width="256" height="292" name="prepareCartridgesAnimation">');
				document.write('</img>');
				break;
			case "dot":
				document.write('<img src="images/' +  color + 'circle.gif">');
				break;
			case "count":
				if ((strIsAssist.value.toLowerCase() == "true") && (strInTrouble.value.toLowerCase() =="false")) 
				{
					document.write(stepProgress(step));
				}
				break;
			case "nextBtn":
				if (strInTrouble.value.toLowerCase() =="false")
				{
					writeNext('active','prepareCartridgesNext()','White');
				}
				else
				{
					writeNext('invisible','','White');
				}
				break;
			case "backBtn":
				if (strInTrouble.value.toLowerCase() =="false")
				{
					writeBack('active','prepareCartridgesBack()','Blue','two');
				}
				else
				{
					writeBack('active','prepareCartridgesBack()','White','one'); //want users to go back to troubleshooting
				}
				break;	
			case "exitBtn":
				if (strInTrouble.value.toLowerCase() =="false")
				{
				writeExit('active','before');
				}
				break;
		}
}

function installCartridges(part){
		
		var color = "blue01";

		var strProduct = new String(); //to support those products with automatic calibration and/or one pen; may change to prod number (was not available at the time of creation)
		HpfInst.GetProcessString(HPIFile, "product", strProduct);

		var strIsAssist = new String();
		HpfInst.GetProcessString( "master.hpi", "assist_install", strIsAssist);

		var strInTrouble = new String();
		HpfInst.GetProcessString( "master.hpi", "in_troubleshoot", strInTrouble);

		var strConnect = new String(); //to support those products with Bluetooth; may change to prod number (was not available at the time of creation)
		HpfInst.GetProcessString(HPIFile, "io_connect", strConnect);

		if ((strProduct.value.toLowerCase() == "995c") && (strConnect.value.toLowerCase() == "usb"))
		{
			var step = six;
		}
		else
		{
			var step = five;
		}

		var strProduct = new String(); //to support those products with automatic calibration and/or one pen; may change to prod number (was not available at the time of creation)
		HpfInst.GetProcessString(HPIFile, "product", strProduct);

		switch(part) {
			case "stepNumber":
				if ((strIsAssist.value.toLowerCase() == "true") && (strInTrouble.value.toLowerCase() =="false")) 
				{
				document.write(step);
				}
				break;
			case "stepTitle": 
				if (strProduct.value.toLowerCase() == "825c") //one-pen products listed here
				{
					document.write(installTitle1);
				}
				else
				{
					document.write(installTitle);
				}
				break;
			case "instructions":
				if (strProduct.value.toLowerCase() == "656c")
				{
					document.write("<ol>" + installCartridgesOne);
					document.write('<p>');
					document.write(installCartridgesTwoOld);
					document.write('<p>');
					document.write(installCartridgesThreeOld);
					document.write('<p>');
					document.write(installCartridgesFour);
					document.write('<p>');			
				} 
				else if (strProduct.value.toLowerCase() == "825c") //one-pen products listed here
				{
					document.write("<ol>" + installCartridgesOne);
					document.write('<p>');
					document.write(installCartridgesTwoL1);
					document.write('<p>');
					document.write(installCartridgesThreeL1);
					document.write('<p>');
					document.write(installCartridgesFour);
					document.write('<p>');			
				}		
				else
				{
					document.write("<ol>" + installCartridgesOne);
					document.write('<p>');
					document.write(installCartridgesTwo);
					document.write('<p>');
					document.write(installCartridgesThree);
					document.write('<p>');
					document.write(installCartridgesFour);
					document.write('<p>');
				}
				if (strProduct.value.toLowerCase() == "990c") //list those printers that have automatic calibration
				{
					document.write('<span class="warning">' + installWarning + '</span></ol>');
				}
				else if (strProduct.value.toLowerCase() == "995c") //list those printers that have automatic calibration & Bluetooth
				{
					document.write('<span class="warning">' + installWarning2 + '</span></ol>');
				}
				break;
			case "animation":
				document.write('<img src="animation/insertInk.gif" width="256" height="292" name="installCartridgesAnimation">');
				document.write('</img>');
				break;
			case "dot":
				document.write('<img src="images/' +  color + 'circle.gif">');
				break;
			case "count":
				if ((strIsAssist.value.toLowerCase() == "true") && (strInTrouble.value.toLowerCase() =="false")) 
				{
					document.write(stepProgress(step));
				}
				break;
			case "nextBtn":
				if (strInTrouble.value.toLowerCase() =="false") 
				{
					writeNext('active','installCartridgesNext()','White');
				}
				else
				{
					writeNext('invisible','','White');
				}
				break;
			case "backBtn":
				if (strInTrouble.value.toLowerCase() =="false")
				{
					writeBack('active','installCartridgesBack()','Blue','two');
				}
				else
				{
					writeBack('active','installCartridgesBack()','White','one'); //want users to go back to troubleshooting
				}
				break;	
			case "exitBtn":
				if (strInTrouble.value.toLowerCase() =="false")
				{
				writeExit('active','before');
				}
				break;
		}
}

function calibration(part){
		
		var color = "blue01";
		
		switch(part) {
			case "stepTitle": 
				document.write(calibrationTitle);
				break;
			case "confirmation":
		  		document.write(calibrationText);
				break;
			case "yes":
		  		document.write(yes);
				break;	
			case "no":
		  		document.write(no);
				break;					
			case "animation":
				document.write('<img src="animation/confirmCalibration.gif" width="256" height="292" name="calibrationAnimation">');
				document.write('</img>');
				break;
			case "dot":
				document.write('<img src="images/' +  color + 'circle.gif">');
				break;
			case "nextBtn":
				writeNext('active','calibrationNext()','White');
				break;
			case "backBtn":
				writeBack('active','calibrationBack()','Blue','two');
				break;	
			case "exitBtn":
				writeExit('active','before');
				break;
		}
}

function printSample(part){
		
		var color = "blue01";

		var strIsAssist = new String();
		HpfInst.GetProcessString( "master.hpi", "assist_install", strIsAssist);

		var strConnect = new String(); //to support those products with Bluetooth; may change to prod number (was not available at the time of creation)
		HpfInst.GetProcessString(HPIFile, "io_connect", strConnect);

		var strIsAssist = new String();
		HpfInst.GetProcessString( "master.hpi", "assist_install", strIsAssist);

		var strProduct = new String();
		HpfInst.GetProcessString(HPIFile, "product", strProduct);

		if ((strProduct.value.toLowerCase() == "995c") && (strConnect.value.toLowerCase() == "usb"))
		{
			var step = seven;
		}
		else
		{
			var step = six;
		}

		var strProduct = new String(); //to eliminate text reference to those products w/o sample paper inbox; may change to prod number
		HpfInst.GetProcessString(HPIFile, "product", strProduct);
		switch(part) {
			case "stepNumber":
				if (strIsAssist.value.toLowerCase() == "true")
				{
				document.write(step);
				}
				break;
			case "stepTitle": 
				document.write(printTitle);
				break;
			case "instructions":
				if ((strProduct.value.toLowerCase() == "995c") && (strConnect.value.toLowerCase() == "usb"))	
				{
					document.write(printSampleUsb);
				}
				else if ((strProduct.value.toLowerCase() == "995c") && (strConnect.value.toLowerCase() == "bluetooth"))	
				{
					document.write(printSampleBluetooth);
				}
				else
				{
                        	document.write(printSampleOne);
				}
                        document.write('<p>');
		  	      document.write(printSampleTwo);
				//document.write('<p>');
				//if ((strProduct.value.toLowerCase() != "920c") || (strProduct.value.toLowerCase() != "940c") || (strProduct.value.toLowerCase() != "948c")) //list products w/o paper samples in the box
				//document.write(printSampleThree);
				break;
			case "print":
		  	      document.write(printLabel);
				break;
			case "animation":
				document.write('<img src="animation/confirmSample.gif" width="256" height="292" name="confirmSampleAnimation">');
				document.write('</img>');
				break;
			case "dot":
                        document.write('<img src="images/' +  color + 'circle.gif">');
				break;
			case "count":
                        if (strIsAssist.value.toLowerCase() == "true"){document.write(stepProgress(step));}
				break;
			case "printBtn":
				document.write('<div id="print">');
				document.write('<a class="link" onClick="printSampleYes();" onMouseOver="SwapImageEx(this,0,\'images/medBtn2.gif\')" onMouseOut="SwapImageEx(this)">');
				document.write('<img name="printBtn" src="images/medBtn1.gif" border="0"></a>');
				document.write('</div>');
				break;
			case "nextBtn":
				writeNext('active','printSampleNext()','White');
				break;
			case "backBtn":
				if (strIsAssist.value.toLowerCase() == "true")
				{
				writeBack('active','printSampleBack()','Blue','two');//in assisted path and user may want to double check something
				}
				else
				{
				writeBack('invisible','','Blue','one'); //in unassisted path and do not want to return to install
				}
				break;	
			case "exitBtn":
				writeExit('active','after');
				break;
		}
}

function confirmSample(part){
		
		var color = "blue01";
		
		switch(part) {
			case "stepTitle": 
				document.write(confirmTitle);
				break;
			case "confirmation":
		  	document.write(confirmText);
				break;
			case "yes":
		  	document.write(yes);
				break;	
			case "no":
		  	document.write(no);
				break;
			case "again":
		  	document.write(againLabel);
				break;							
			case "animation":
				document.write('<img src="animation/confirmSample.gif" width="256" height="292" name="confirmSampleAnimation">');
				document.write('</img>');
				break;
			case "dot":
				document.write('<img src="images/' +  color + 'circle.gif">');
				break;
			case "yesBtn":
				document.write('<div id="yes">');
				document.write('<a class="link" onClick="confirmSampleYes();" onMouseOver="SwapImageEx(this,0,\'images/medBtn2.gif\')" onMouseOut="SwapImageEx(this)">');
				document.write('<img name="yesBtn" src="images/medBtn1.gif" border="0"></a>');
				document.write('</div>');
				break;
			case "noBtn":
				document.write('<div id="no">');
				document.write('<a class="link" onClick="confirmSampleNo();" onMouseOver="SwapImageEx(this,0,\'images/medBtn2.gif\')" onMouseOut="SwapImageEx(this)">');
				document.write('<img name="noBtn" src="images/medBtn1.gif" border="0"></a>');
				document.write('</div>');
				break;
			case "againBtn":
				document.write('<div id="again">');
				document.write('<a class="link" onClick="confirmSampleAgain();" onMouseOver="SwapImageEx(this,0,\'images/medBtn2.gif\')" onMouseOut="SwapImageEx(this)">');
				document.write('<img name="againBtn" src="images/medBtn1.gif" border="0"></a>');
				document.write('</div>');
				break;
			case "nextBtn":
				writeNext('active','confirmSampleNext()','White');
				break;
			case "backBtn":
				writeBack('active','confirmSampleBack()','Blue','two');
				break;
			case "exitBtn":
				writeExit('active','after');
				break;
		}
}


function doEreg(part){
		
		var color = "blue01";

		var strConnect = new String(); //to support those products with Bluetooth; may change to prod number (was not available at the time of creation)
		HpfInst.GetProcessString(HPIFile, "io_connect", strConnect);

		var strIsAssist = new String();
		HpfInst.GetProcessString( "master.hpi", "assist_install", strIsAssist);
	
		var strProduct = new String();
		HpfInst.GetProcessString(HPIFile, "product", strProduct);  

		if ((strProduct.value.toLowerCase() == "995c") && (strConnect.value.toLowerCase() == "usb"))
		{
			var step = eight;
		}
		else
		{
			var step = seven;
		}

		switch(part) {
			case "stepNumber":
				if (strIsAssist.value.toLowerCase() == "true")
				{
				document.write(step);
				}
				break;
			case "stepTitle":
				document.write(eregTitle);
				break;
			case "eregInstructions":
				document.write('<p>');
				document.write(doEregOne + "<br>");
				document.write("<ul><li>" + doEregSubOne + "<br>");
				document.write("<li>" + doEregSubTwo + "<br>");
				document.write("<li>" + doEregSubThree + "</ul>");
				document.write('<p>');
				document.write('<p>');
				document.write(doEregTwo + "<br>");
				break;
			case "ereg":
		  	      document.write(registerLabel);
				break;
			case "privacy":
				document.write(privacyLabel);
				break;					
			case "dot":
                        document.write('<img src="images/' +  color + 'circle.gif">');
				break;
			case "count":
                        if (strIsAssist.value.toLowerCase() == "true"){document.write(stepProgress(step));}
				break;
			case "eregBtn":
				document.write('<div id="ereg">');
				document.write('<a class="link" onClick="eregYes();" onMouseOver="SwapImageEx(this,0,\'images/medBtn2.gif\')" onMouseOut="SwapImageEx(this)">');
				document.write('<img name="eregBtn" src="images/medBtn1.gif" border="0"></a>');
				document.write('</div>');
				break;
			case "privacyBtn":
				document.write('<div id="privacy">');
				document.write('<a class="link" onClick="readPrivacy();" onMouseOver="SwapImageEx(this,0,\'images/medBtn2.gif\')" onMouseOut="SwapImageEx(this)">');
				document.write('<img name="privacyBtn" src="images/medBtn1.gif" border="0"></a>');
				document.write('</div>');
				break;
			case "nextBtn":
				writeNext('active','eregNext()','White');
				break;
			case "backBtn":
				writeBack('active','eregBack()','Blue','two');
				break;
			case "exitBtn":
				writeExit('active','after');
				break;
		}
}



function installComp(part){
	switch(part){
		case "title":
			document.write(installCompTitle);
			break;
		case "text":
			document.write(installCompOne);
			document.write('<p>');
			document.write(installCompTwo);
      		break;
		case "product":
			document.write(assistantLabel);
			break;
		case "nextBtn":
			writeNext('active','installCompNext()','White');
			break;
		case "backBtn":
			writeBack('active','installCompBack()','Blue','two');
			break;
		case "exitBtn":
			break;
	}
}

function whatNext(part){
	switch(part){
		case "title":
			document.write(whatNextTitle);
			break;
		case "subtitle":
			document.write(whatNextSubtitle);
			break;
		case "oneText":
			document.write(printerAssistantText);
      		break;
		case "twoText":
			document.write(eregText);
      		break;
		case "threeText":
			document.write(ispText);
      		break;
		case "oneLabel":
			document.write(printerAssistantLabel);
      		break;
		case "twoLabel":
			document.write(eregLabel);
      		break;
		case "threeLabel":
			document.write(ispLabel);
      		break;
		case "exitLabel":
			document.write(whatExitLabel);
      		break;
		case "oneBtn":
			document.write('<div id="oneButton">');
			document.write('<a class="link" onClick="toPrinterAssistant();" onMouseOver="SwapImageEx(this,0,\'images/smallBtn2.gif\');" onMouseOut="SwapImageEx(this)">');
			document.write('<img name="oneBtn" src="images/smallBtn1.gif" border="0"></a>');
			document.write('</div>');
			break;
		case "twoBtn":
			document.write('<div id="twoButton">');
			document.write('<a class="link" onClick="toEreg();" onMouseOver="SwapImageEx(this,0,\'images/smallBtn2.gif\');" onMouseOut="SwapImageEx(this)">');
			document.write('<img name="twoBtn" src="images/smallBtn1.gif" border="0"></a>');
			document.write('</div>');
			break;
		case "threeBtn":
			document.write('<div id="threeButton">');
			document.write('<a class="link" onClick="toISP();" onMouseOver="SwapImageEx(this,0,\'images/smallBtn2.gif\');" onMouseOut="SwapImageEx(this)">');
			document.write('<img name="threeBtn" src="images/smallBtn1.gif" border="0"></a>');
			document.write('</div>');
			break;
		case "exitNextBtn":
			document.write('<div id="exitNext">');
			document.write('<a class="link" onClick="exitNext();" onMouseOver="SwapImageEx(this,0,\'images/medBtn2.gif\');" onMouseOut="SwapImageEx(this)">');
			document.write('<img name="exitNextBtn" src="images/medBtn1.gif" border="0"></a>');
			document.write('</div>');
			break;
		case "exitBtn":
			writeExit('active','after');
			break;
	}
}


function troubleshootSoft(part){

		var strProduct = new String(); //to support those products with one pen and/or flip-up tray; may change to prod number (was not available at the time of creation)
		HpfInst.GetProcessString(HPIFile, "product", strProduct);
		
		var strConnect = new String(); //to support those products with Bluetooth; may change to prod number (was not available at the time of creation)
		HpfInst.GetProcessString(HPIFile, "io_connect", strConnect);

		var strIsAssist = new String();
		HpfInst.GetProcessString( "master.hpi", "assist_install", strIsAssist);

		switch(part) {
			case "title":
				document.write(troubleTitle);
				break;
			case "subtitle":
				document.write(troubleSubTitle);
				break;
			case "verifyCable":
				if (strProduct.value.toLowerCase() == "995c")
				{
					if (strConnect.value.toLowerCase() == "bluetooth")
					{
						document.write(troubleDuplexer);
					}
					else if (strConnect.value.toLowerCase() == "usb")
					{
						document.write(troubleCable);
					}
					else
					{
						document.write(troubleConnection);
					}
				}
				else
				{
					document.write(troubleCable);
				}
				break;
			case "verifyPower":
				document.write(troublePower);
				break;
			case "verifyPaper":
				if ((strProduct.value.toLowerCase() == "948c")||(strProduct.value.toLowerCase() == "920c")||(strProduct.value.toLowerCase() == "656c")||(strProduct.value.toLowerCase() == "916c"))
				{
					document.write(troubleTray);
				}
				else
				{
					document.write(troublePaper);
				}
				break;
			case "verifyTape":
				if (strProduct.value.toLowerCase() == "825c")
				{
				 	document.write(troubleSingleTape);
				}
				else
				{
					document.write(troubleTape);
				}
				break;
			case "verifyCartridges":
				if (strProduct.value.toLowerCase() == "825c")
				{
					document.write(troubleCartridge);
				}
				else
				{
					document.write(troubleCartridges);
				}
				break;
			case "verifyDuplexer":
				if ((strProduct.value.toLowerCase() == "995c") && (strConnect.value.toLowerCase() != "bluetooth"))
				{
					document.write(troubleDuplexer);
				}
				break;
	            case "footer":
				var strUnAssistInstallDone = new String();
	                  HpfInst.GetProcessString( HPIFile, "unassist_install_done", strUnAssistInstallDone);
				if ((strIsAssist.value.toLowerCase() == "false")&&(strUnAssistInstallDone.value.toLowerCase() == "false")) 
				{
					document.write(troubleInstall);			
				}
				else
				{
					document.write(troubleContinue);
				}
	                  break;
			case "verify1Btn":
				document.write('<div id="verify1Button">');
				document.write('<a class="link" onClick="toVerifyCable();" onMouseOver="SwapImageEx(this,0,\'images/smallBtn2.gif\')" onMouseOut="SwapImageEx(this)">');
				document.write('<img name="ver1Btn" src="images/smallBtn1.gif" border="0"></a>');
				document.write('</div>');
				break;
			case "verify2Btn":
				document.write('<div id="verify2Button">');
				document.write('<a class="link" onClick="toVerifyPower();" onMouseOver="SwapImageEx(this,0,\'images/smallBtn2.gif\')" onMouseOut="SwapImageEx(this)">');
				document.write('<img name="ver2Btn" src="images/smallBtn1.gif" border="0"></a>');
				document.write('</div>');
				break;
			case "verify3Btn":
				document.write('<div id="verify3Button">');
				document.write('<a class="link" onClick="toVerifyPaper();" onMouseOver="SwapImageEx(this,0,\'images/smallBtn2.gif\')" onMouseOut="SwapImageEx(this)">');
				document.write('<img name="ver3Btn" src="images/smallBtn1.gif" border="0"></a>');
				document.write('</div>');
				break;
			case "verify4Btn":
				document.write('<div id="verify4Button">');
				document.write('<a class="link" onClick="toVerifyTape();" onMouseOver="SwapImageEx(this,0,\'images/smallBtn2.gif\')" onMouseOut="SwapImageEx(this)">');
				document.write('<img name="ver4Btn" src="images/smallBtn1.gif" border="0"></a>');
				document.write('</div>');
				break;
			case "verify5Btn":
				document.write('<div id="verify5Button">');
				document.write('<a class="link" onClick="toVerifyCartridges();" onMouseOver="SwapImageEx(this,0,\'images/smallBtn2.gif\');" onMouseOut="SwapImageEx(this)">');
				document.write('<img name="ver5Btn" src="images/smallBtn1.gif" border="0"></a>');
				document.write('</div>');
				break;
			case "verify6Btn":
				if ((strProduct.value.toLowerCase() == "995c") && (strConnect.value.toLowerCase() != "bluetooth"))
				{
					document.write('<div id="verify6Button">');
					document.write('<a class="link" onClick="toVerifyDuplexer();" onMouseOver="SwapImageEx(this,0,\'images/smallBtn2.gif\')" onMouseOut="SwapImageEx(this)">');
					document.write('<img name="ver6Btn" src="images/smallBtn1.gif" border="0"></a>');
					document.write('</div>');
				}
				break;
			case "nextBtn":
				writeNext('active','troubleshootSoftNext()','White');
				break;
			case "backBtn":
				writeBack('active','troubleshootSoftBack()','Blue','two');
				break;
			case "exitBtn":
				writeExit('active','before');
				break;
		}
}		

function notEverything(part){

	var strLang = new String();
	HpfInst.GetProcessString( "master.hpi", "lang", strLang);

	switch(part){
		case "title":
			document.write(notEverythingTitle);
			break;
		case "text":
			if (strLang.value != "jpn")
			{
				document.write(notEverythingOne);
		      	document.write(notEverythingTwo);
				document.write(notEverythingThree);
				document.write('<br><br>');
				document.write(notEverythingFour);
			}
			else
			{
				document.write(notEverythingTitle2);
				document.write("<ul><li>" + notEverythingOne2 + "<br>");
		      	document.write("<li>" + notEverythingTwo2 + "</ul>");
				document.write(notEverythingThree2);				
				document.write("<ul><li>" + notEverythingFour2 + "<br>");
				document.write("<li>" + notEverythingFive2 + "</ul>");			
				document.write(notEverythingSix2);	
			}
			break;
		case "nextBtn":
			writeExitNext('active','notEverythingNext()','Blue');
			break;
		case "backBtn":
			writeDiaBack('active','notEverythingBack()','White','two');
			break;	
	}
}

function moreUSBHelp(part){
	switch(part){
		case "title":
			document.write(usbHelpTitle);
			break;
		case "text":
			document.write(usbHelpText);
			break;
		case "nextBtn":
			writeExitNext('active','usbHelpNext()','Blue');
			break;
		case "backBtn":
			writeDiaBack('active','usbHelpBack()','White','two');
			break;	
	}
}


////////////////////////////////////////////////////////////////////////////////
//  functions for button appearance
////////////////////////////////////////////////////////////////////////////////
//

function writeExitNext(state, func, color){
	switch (state){
		case "active":
			document.write('<div id="nextExitLabel">');
			document.write('<a tabindex=OFF class="link" onClick="' + func + ';">');
			document.write('<img src="images/bigX.gif" border="0"></a>');
			document.write('</div>');
			
			document.write('<div id="nextExitStep">');
			document.write('<a class="link" onClick="' + func + ';" onMouseOver="SwapImageEx(this,0,\'images/largeBtn2.gif\')" onMouseOut="SwapImageEx(this)">');
			document.write('<img name="nextBtn" src="images/largeBtn1.gif" border="0"></a>');
			document.write('</div>');
			break;
		case "disabled":
			document.write('<div id="nextExitLabel">');
			document.write('<img name="nextBtn" src="images/bigX.gif" border="0">');
			document.write('</div>');
			
			document.write('<div id="nextExitStep">');
			document.write('<img name="nextBtn" src="images/largeBtn3.gif" border="0">');
			document.write('</div>');
			break;
		case "invisible":
			break;
	}
}


function writeDiaNext(state, func, color){
	switch (state){
		case "active":
			document.write('<div id="nextDiaLabel">');
			document.write('<a tabindex=OFF class="link" onClick="' + func + ';">');
			document.write('<img src="images/rt' + color + 'Arrow1.gif" border="0"></a>');
			document.write('</div>');
			
			document.write('<div id="nextDiaStep">');
			document.write('<a class="link" onClick="' + func + ';" onMouseOver="SwapImageEx(this,0,\'images/largeBtn2.gif\')" onMouseOut="SwapImageEx(this)">');
			document.write('<img name="nextBtn" src="images/largeBtn1.gif" border="0"></a>');
			document.write('</div>');
			break;
		case "disabled":
			document.write('<div id="nextDiaLabel">');
			document.write('<img name="nextBtn" src="images/rt' + color + 'Arrow3.gif" border="0">');
			document.write('</div>');
			
			document.write('<div id="nextDiaStep">');
			document.write('<img name="nextBtn" src="images/largeBtn3.gif" border="0">');
			document.write('</div>');
			break;
		case "invisible":
			break;
	}
}


//NOTE: buttonCount should be a parameter for the other back button in case there is no forward button; may be no need for 
//disabled as current Human Factors movement is that 'greyed' out buttons cause confusion
function writeDiaBack(state, func, color, buttonCount){
	switch (state){
		case "active":
			switch (buttonCount){
				case "one":
					//so it takes the 'next' position its absence (may want to rename 'nextDiaLabel')
					document.write('<div id="nextDiaLabel">'); 
					document.write('<a tabindex=OFF class="link" onClick="' + func + ';">');
					document.write('<img src="images/lt' + color + 'Arrow1.gif" border="0"></a>');
					document.write('</div>');
			
					//so it takes the 'next' position its absence
					document.write('<div id="nextDiaStep">'); 
					document.write('<a class="link" onClick="' + func + ';" onMouseOver="SwapImageEx(this,0,\'images/largeBtn2.gif\')" onMouseOut="SwapImageEx(this)">');
					document.write('<img name="backBtn" src="images/largeBtn1.gif" border="0"></a>');
					document.write('</div>');
				break;
				case "two":
					document.write('<div id="backDiaLabel">');
					document.write('<a tabindex=OFF class="link" onClick="' + func + ';">');
					document.write('<img src="images/lt' + color + 'Arrow1.gif" border="0"></a>');
					document.write('</div>');
			
					document.write('<div id="backDiaStep">');
					document.write('<a class="link" onClick="' + func + ';" onMouseOver="SwapImageEx(this,0,\'images/largeBtn2.gif\')" onMouseOut="SwapImageEx(this)">');
					document.write('<img name="backBtn" src="images/largeBtn1.gif" border="0"></a>');
					document.write('</div>');
				break;
			}
			break;
		case "disabled":
			document.write('<div id="backDiaLabel">');
			document.write('<img name="backBtn" src="images/lt' + color + 'Arrow3.gif" border="0">');
			document.write('</div>');
			
			document.write('<div id="backDiaStep">');
			document.write('<img name="backBtn" src="images/largeBtn3.gif" border="0">');
			document.write('</div>');
			break;
		case "invisible":
			break;
	}
	//NOTE: I really do not like having the button background functionality attached to the back button.  Will be creating a more
	//robust back/next button function once accessibility concerns are also included.
	writeBtnBackgnd(buttonCount);
}

function writeNext(state, func, color){
	switch (state){
		case "active":
			document.write('<div id="nextLabel">');
			document.write('<a tabindex=OFF class="link" onClick="' + func + ';">');
			document.write('<img src="images/rt' + color + 'Arrow1.gif" border="0"></a>');
			document.write('</div>');
			
			document.write('<div id="nextStep">');
			document.write('<a class="link" onClick="' + func + ';" onMouseOver="SwapImageEx(this,0,\'images/largeBtn2.gif\')" onMouseOut="SwapImageEx(this)">');
			document.write('<img name="nextBtn" src="images/largeBtn1.gif" border="0"></a>');
			document.write('</div>');
			break;
		case "disabled":
			document.write('<div id="nextLabel">');
			document.write('<img name="nextBtn" src="images/rt' + color + 'Arrow3.gif" border="0">');
			document.write('</div>');
			
			document.write('<div id="nextStep">');
			document.write('<img name="nextBtn" src="images/largeBtn3.gif" border="0">');
			document.write('</div>');
			break;
		case "invisible":
			break;
	}
}

function writeBack(state, func, color, buttonCount){
	switch (state){
		case "active":
			switch(buttonCount){
				case "one":
					//so it take the next position in its absence (rename nextLabel and nextStep as they were originally created
					//by Fitch with an assumption that the next button would always hold this position)
					document.write('<div id="nextLabel">');
					document.write('<a tabindex=OFF class="link" onClick="' + func + ';">');
					document.write('<img src="images/lt' + color + 'Arrow1.gif" border="0"></a>');
					document.write('</div>');
			
					document.write('<div id="nextStep">');
					document.write('<a class="link" onClick="' + func + ';" onMouseOver="SwapImageEx(this,0,\'images/largeBtn2.gif\')" onMouseOut="SwapImageEx(this)">');
					document.write('<img name="backBtn" src="images/largeBtn1.gif" border="0"></a>');
					document.write('</div>');
					break;
				case "two":
					//so it take the next position in its absence (rename 'thing' again)
					document.write('<div id="backLabel">');
					document.write('<a tabindex=OFF class="link" onClick="' + func + ';">');
					document.write('<img src="images/lt' + color + 'Arrow1.gif" border="0"></a>');
					document.write('</div>');
					
					document.write('<div id="backStep">');
					document.write('<a class="link" onClick="' + func + ';" onMouseOver="SwapImageEx(this,0,\'images/largeBtn2.gif\')" onMouseOut="SwapImageEx(this)">');
					document.write('<img name="backBtn" src="images/largeBtn1.gif" border="0"></a>');
					document.write('</div>');
				break;
			}
			break;
		case "disabled":
			document.write('<div id="backLabel">');
			document.write('<img name="backBtn" src="images/lt' + color + 'Arrow3.gif" border="0">');
			document.write('</div>');
			
			document.write('<div id="backStep">');
			document.write('<img name="backBtn" src="images/largeBtn3.gif" border="0">');
			document.write('</div>');
			break;
		case "invisible":
			break;
	}
	writeBtnBackgnd(buttonCount);
}

function writeBtnBackgnd(size){
	switch (size){
		case "two":
			document.write('<div id="seGrey">');
			document.write('<img src="images/seCorner.gif">');
			document.write('</div>');
			break;
		case "one":
			document.write('<div id="seCorner3">');
			document.write('<img src="images/seCorner3.gif">');
			document.write('</div>');
			break;
		case "zero":
			break;
	}
}

//Presently hardcoded into vpm_footer; given localized files last minute; when time permits will be changed
//function writePrivacyBack(func, color){
//	
//	document.write('<div id="privacyBackLabel">');
//	document.write('<a class="link" tabindex=OFF onKeyUp="KeyboardInvoke(event,\'' + func + '\')" onClick="' + func + ';" onMouseOver="MM_swapImage(\'document.layers[backStep].document.backBtn\',\'\',\'images/largeBtn2.gif\',0);" onMouseOut="SwapImageEx(this)">');
//	document.write('<img src="images/lt' + color + 'Arrow1.gif" border="0"></a>');
//	document.write('</div>');
			
//	document.write('<div id="privacyBackStep">');
//	document.write('<a class="link" onKeyUp="KeyboardInvoke(event,\'' + func + '\')" onClick="' + func + ';" onMouseOver="MM_swapImage(\'document.layers[backStep].document.backBtn\',\'\',\'images/largeBtn2.gif\',0);" onMouseOut="SwapImageEx(this)">');
//	document.write('<img name="backBtn" src="images/largeBtn1.gif" border="0"></a>');
//	document.write('</div>');					
//				
//}


//for the upper exit button
//NOTE: should create invisible state
function writeExit(state, when){
	switch(state){
		case "active":
			switch(when){
				//installation is not 'complete'; stronger warning to not exit
				case "before":
					document.write('<div id="exitLabel">');
					document.write('<a tabindex=OFF class="link" onClick="exitApp();">');
					document.write('<script type="text/javascript" language="JavaScript">exitLabel();</script></a>');
					document.write('</div>');

					document.write('<div id="exitApp">');
					document.write('<a class="link" onClick="exitApp();"  onMouseOver="SwapImageEx(this,0,\'images/smallBtn2.gif\')" onMouseOut="SwapImageEx(this)">');
					document.write('<img name="exitBtn" src="images/smallBtn1.gif" border="0"></a>');
					document.write('</div>');
					break;
				//installation is complete; just prefer that user continue on with VPM
				case "after":
					document.write('<div id="exitLabel">');
					document.write('<a tabindex=OFF class="link" onClick="exitApp2();" onMouseOver="SwapImageEx(this,0,\'images/smallBtn2.gif\')" onMouseOut="SwapImageEx(this)">');
					document.write('<script type="text/javascript" language="JavaScript">exitLabel();</script></a>');
					document.write('</div>');

					document.write('<div id="exitApp">');
					document.write('<a class="link" onClick="exitApp2();"  onMouseOver="SwapImageEx(this,0,\'images/smallBtn2.gif\')" onMouseOut="SwapImageEx(this)">');
					document.write('<img name="exitBtn" src="images/smallBtn1.gif" border="0"></a>');
					document.write('</div>');
					break;
				}
			break;
		case "disabled":
			document.write('<div id="exitLabel">');
			document.write('<script type="text/javascript" language="JavaScript">exitLabel();</script>');
			document.write('</div>');

			document.write('<div id="exitApp">');
			document.write('<img name="exitBtn" src="images/smallBtn3.gif" border="0"></a>');
			document.write('</div>');
			break;		
	}
	
	document.write('<div id="neGrey">');
	document.write('<img src="images/neCorner.gif">');
	document.write('</div>');
}


////////////////////////////////////////////////////////////////////////////////
//  generic alert dialog
////////////////////////////////////////////////////////////////////////////////
//

function alertDialog(part){
	switch(part){
		case "title":
			document.write('generic alert');
			break;
		case "text":
			break;
		case "nextBtn":
			writeDiaNext('active','alertDialogNext()','Blue');
			break;
		case "backBtn":
			writeDiaBack('active','alertDialogBack()','White','two');
			break;	
	}
}

////////////////////////////////////////////////////////////////////////////////
//  generic error dialog
////////////////////////////////////////////////////////////////////////////////
//

function errorDialog(part){
	switch(part){
		case "title":
			document.write('generic error');
			break;
		case "text":
			break;
		case "nextBtn":
			writeDiaNext('active','errortDialogNext()','Blue');
			break;
		case "backBtn":
			writeDiaBack('active','errorDialogBack()','White','two');
			break;	
	}
}

function replayAnimation(part, page)
{
	switch(part){
		case "replayBtn":
			document.write('<div id="replayButton">');
			switch(page){
				case "powerCord":
					document.write('<a class="link" onClick="replayPowerAnimation();" onMouseOver="SwapImageEx(this,0,\'images/medBtn2.gif\')" onMouseOut="SwapImageEx(this)">');
					break;
				case "installCartridges":
					document.write('<a class="link" onClick="replayInstallAnimation();" onMouseOver="SwapImageEx(this,0,\'images/medBtn2.gif\')" onMouseOut="SwapImageEx(this)">');
					break;
				case "confirmSample":
					document.write('<a class="link" onClick="replayConfirmAnimation();" onMouseOver="SwapImageEx(this,0,\'images/medBtn2.gif\')" onMouseOut="SwapImageEx(this)">');
					break;
				case "printSample":
					document.write('<a class="link" onClick="replayConfirmAnimation();" onMouseOver="SwapImageEx(this,0,\'images/medBtn2.gif\')" onMouseOut="SwapImageEx(this)">');
					break;
				case "attachDuplexer":
					document.write('<a class="link" onClick="replayAttachAnimation();" onMouseOver="SwapImageEx(this,0,\'images/medBtn2.gif\')" onMouseOut="SwapImageEx(this)">');
					break;
				case "loadPaper":
					document.write('<a class="link" onClick="replayLoadAnimation();" onMouseOver="SwapImageEx(this,0,\'images/medBtn2.gif\')" onMouseOut="SwapImageEx(this)">');
					break;
				case "prepareCartridges":
					document.write('<a class="link" onClick="replayPrepareAnimation();" onMouseOver="SwapImageEx(this,0,\'images/medBtn2.gif\')" onMouseOut="SwapImageEx(this)">');
					break;
				case "calibration":
					document.write('<a class="link" onClick="replayCalibrationAnimation();" onMouseOver="SwapImageEx(this,0,\'images/medBtn2.gif\')" onMouseOut="SwapImageEx(this)">');
					break;
				case "connectUsb":
					document.write('<a class="link" onClick="replayUsbAnimation();" onMouseOver="SwapImageEx(this,0,\'images/medBtn2.gif\')" onMouseOut="SwapImageEx(this)">');
					break;
				case "connectParallel":
					document.write('<a class="link" onClick="replayParallelAnimation();" onMouseOver="SwapImageEx(this,0,\'images/medBtn2.gif\')" onMouseOut="SwapImageEx(this)">');
					break;
			}
			document.write('<img name="animationBtn" src="images/medBtn1.gif" border="0"></a>');
			document.write('</div>');
			break;
		case "replayTxt":
			document.write(replayLabel);
			break;
	}
}

function MM_findObj(n, d) { //v4.01
  var p,i,x;  if(!d) d=document; if((p=n.indexOf("?"))>0&&parent.frames.length) {
    d=parent.frames[n.substring(p+1)].document; n=n.substring(0,p);}
  if(!(x=d[n])&&d.all) x=d.all[n]; for (i=0;!x&&i<d.forms.length;i++) x=d.forms[i][n];
  for(i=0;!x&&d.layers&&i<d.layers.length;i++) x=MM_findObj(n,d.layers[i].document);
  if(!x && d.getElementById) x=d.getElementById(n); return x;
}

function MM_changeProp(objName,x,theProp,theValue) { //v3.0
  var obj = MM_findObj(objName);
  if (obj && (theProp.indexOf("style.")==-1 || obj.style)) eval("obj."+theProp+"='"+theValue+"'");
}


function replayPowerAnimation()
{	
	MM_changeProp('powerCordAnimation','','src','animation/blank.gif','IMG');
	MM_changeProp('powerCordAnimation','','src','animation/powerCord.gif','IMG');
}

function replayInstallAnimation()
{	
	MM_changeProp('installCartridgesAnimation','','src','animation/blank.gif','IMG');
	MM_changeProp('installCartridgesAnimation','','src','animation/insertInk.gif','IMG');
}

function replayConfirmAnimation()
{	
	MM_changeProp('confirmSampleAnimation','','src','animation/blank.gif','IMG');
	MM_changeProp('confirmSampleAnimation','','src','animation/confirmSample.gif','IMG');
}

function replayAttachAnimation()
{	
	MM_changeProp('attachDuplexerAnimation','','src','animation/blank.gif','IMG');
	MM_changeProp('attachDuplexerAnimation','','src','animation/duplexer.gif','IMG');
}

function replayLoadAnimation()
{	
	MM_changeProp('loadPaperAnimation','','src','animation/blank.gif','IMG');
	MM_changeProp('loadPaperAnimation','','src','animation/insertPaper.gif','IMG');
}

function replayPrepareAnimation()
{	
	MM_changeProp('prepareCartridgesAnimation','','src','animation/blank.gif','IMG');
	MM_changeProp('prepareCartridgesAnimation','','src','animation/prepInk.gif','IMG');
}

function replayCalibrationAnimation()
{	
	MM_changeProp('calibrationAnimation','','src','animation/blank.gif','IMG');
	MM_changeProp('calibrationAnimation','','src','animation/calibration.gif','IMG');
}

function replayUsbAnimation()
{	
	MM_changeProp('connectUsbAnimation','','src','animation/blank.gif','IMG');
	MM_changeProp('connectUsbAnimation','','src','animation/usbCord.gif','IMG');
}

function replayParallelAnimation()
{	
	MM_changeProp('connectParallelAnimation','','src','animation/blank.gif','IMG');
	MM_changeProp('connectParallelAnimation','','src','animation/parallelCord.gif','IMG');
}

function BthUrl()
{
	return "www.hp.com/support/bluetooth";

}
function doCalibration(part){
		
		var color = "blue01";

		var strIsAssist = new String();
		HpfInst.GetProcessString( "master.hpi", "assist_install", strIsAssist);

		var step = six;
		switch(part) {
			case "stepNumber":
				document.write(step);
				break;
			case "stepTitle":
				document.write(doCalibrationTitle);
				break;
			case "instructions":
				document.write(doCalibrationTextOne);
				document.write("<ol><li>" + doCalibrationTextTwo + "</li>");
				document.write("<li>" + doCalibrationTextThree + "</li></ol>");
				document.write(doCalibrationTextFour);
				break;
			case "yesCalibration":
				document.write(doCalibrationLabel);
				break;		
			case "noCalibration":
				document.write(noCalibrationLabel);
				break;					
			case "dot":
                        document.write('<img src="images/' +  color + 'circle.gif">');
				break;
			case "count":
                        if (strIsAssist.value.toLowerCase() == "true"){document.write(stepProgress(step));}
				break;
			case "yesCalibrationBtn":
				document.write('<div id="privacy">');
				document.write('<a class="link" onClick="readPrivacy();" onMouseOver="SwapImageEx(this,0,\'images/medBtn2.gif\')" onMouseOut="SwapImageEx(this)">');
				document.write('<img name="privacyBtn" src="images/medBtn1.gif" border="0"></a>');
				document.write('</div>');
				break;
			case "noCalibrationBtn":
				document.write('<div id="ereg">');
				document.write('<a class="link" onClick="eregYes();" onMouseOver="SwapImageEx(this,0,\'images/medBtn2.gif\')" onMouseOut="SwapImageEx(this)">');
				document.write('<img name="eregBtn" src="images/medBtn1.gif" border="0"></a>');
				document.write('</div>');
				break;
			case "nextBtn":
				writeNext('active','eregNext()','White');
				break;
			case "backBtn":
				writeBack('active','eregBack()','Blue','two');
				break;
			case "exitBtn":
				writeExit('active','after');
				break;
		}
}

function answerQuestions(part){
		
		var color = "blue01";

		switch(part) {
			case "title":
				document.write(answerQuestionsTitle);
				break;
			case "subtitle":
				document.write(answerQuestionsSubtitle);
				break;
			case "chicletOneText":
				document.write(answerQuestions1 + "<br><br>" + '<form><input type=radio name=One value="A"> A ');
				document.write('<input type=radio name=One value="B"> B ');
				document.write('<input type=radio name=One value="C"> C ');
				document.write('<input type=radio name=One value="D"> D ');
				document.write('<input type=radio name=One value="E"> E ');
				document.write('<input type=radio name=One value="F"> F ');
				document.write('<input type=radio name=One value="G"> G ');
				document.write('<input type=radio name=One value="H"> H ');
				document.write('<input type=radio name=One value="I"> I </form>');
				break;
			case "chicletTwoText":
				document.write(answerQuestions2 + "<br><br>" + '<form><input type=radio name=Two value="J"> J ');
				document.write('<input type=radio name=Two value="K"> K ');
				document.write('<input type=radio name=Two value="L"> L ');
				document.write('<input type=radio name=Two value="M"> M ');
				document.write('<input type=radio name=Two value="N"> N </form>');
				break;
			case "chicletThreeText":
				document.write(answerQuestions3 + "<br><br>" + '<form><input type=radio name=Three value="O"> O ');	
				document.write('<input type=radio name=Three value="P"> P ');
				document.write('<input type=radio name=Three value="Q"> Q ');
				document.write('<input type=radio name=Three value="R"> R ');
				document.write('<input type=radio name=Three value="S"> S </form>');
				break;
			case "chicletFourText":
				document.write(answerQuestions4 + "<br><br>" + '<form><input type=radio name=Four value="T"> T ');
				document.write('<input type=radio name=Four value="U"> U ');
				document.write('<input type=radio name=Four value="V"> V ');
				document.write('<input type=radio name=Four value="W"> W ');
				document.write('<input type=radio name=Four value="X"> X </form>');
				break;
			case "chicletFiveText":
				document.write(answerQuestions5 + "<br><br>" + '<form><input type=radio name=Five value="1"> 1 ');
				document.write('<input type=radio name=Five value="2"> 2 ');
				document.write('<input type=radio name=Five value="3"> 3 ');
				document.write('<input type=radio name=Five value="4"> 4 ');
				document.write('<input type=radio name=Five value="5"> 5 ');
				document.write('<input type=radio name=Five value="6"> 6 ');
				document.write('<input type=radio name=Five value="7"> 7 ');
				document.write('<input type=radio name=Five value="8"> 8 </form>');
				break;
			case "dot":
                        document.write('<img src="images/' +  color + 'circle.gif">');
				break;
			case "nextBtn":
				writeNext('active','eregNext()','White');
				break;
			case "backBtn":
				writeBack('active','eregBack()','Blue','two');
				break;
			case "exitBtn":
				writeExit('active','after');
				break;
		}
}


function checkCalibration(part){
		
		var color = "blue01";

		var strConnect = new String(); //to support those products with Bluetooth; may change to prod number (was not available at the time of creation)
		HpfInst.GetProcessString(HPIFile, "io_connect", strConnect);

		var strIsAssist = new String();
		HpfInst.GetProcessString( "master.hpi", "assist_install", strIsAssist);
	
		var strProduct = new String();
		HpfInst.GetProcessString(HPIFile, "product", strProduct);  

		switch(part) {
			case "stepTitle":
				document.write(checkCalibrationTitle);
				break;
			case "instructions":
				document.write(checkCalibrationTextOne + "<br><br>" + checkCalibrationTextTwo + "<br><br>" + checkCalibrationTextThree);
				break;
			case "finishLabel":
		  	      document.write(finishCalibrationLabel);
				break;
			case "reCalibrationLabel":
				document.write(reCalibrationLabel);
				break;					
			case "dot":
                        document.write('<img src="images/' +  color + 'circle.gif">');
				break;
			case "finishBtn":
				document.write('<div id="ereg">');
				document.write('<a class="link" onClick="eregYes();" onMouseOver="SwapImageEx(this,0,\'images/medBtn2.gif\')" onMouseOut="SwapImageEx(this)">');
				document.write('<img name="eregBtn" src="images/medBtn1.gif" border="0"></a>');
				document.write('</div>');
				break;
			case "reCalibrationBtn":
				document.write('<div id="privacy">');
				document.write('<a class="link" onClick="readPrivacy();" onMouseOver="SwapImageEx(this,0,\'images/medBtn2.gif\')" onMouseOut="SwapImageEx(this)">');
				document.write('<img name="privacyBtn" src="images/medBtn1.gif" border="0"></a>');
				document.write('</div>');
				break;
			case "nextBtn":
				writeNext('active','eregNext()','White');
				break;
			case "backBtn":
				writeBack('active','eregBack()','Blue','two');
				break;
			case "exitBtn":
				writeExit('active','after');
				break;
		}
}

function installComp(part){
	switch(part){
		case "title":
			document.write(installCompTitle);
			break;
		case "text":
			document.write(installCompOne);
			document.write('<p>');
			document.write(installCompTwo);
      		break;
		case "product":
			document.write(assistantLabel);
			break;
		case "nextBtn":
			writeNext('active','installCompNext()','White');
			break;
		case "backBtn":
			writeBack('active','installCompBack()','Blue','two');
			break;
		case "exitBtn":
			break;
	}
}

